function Create(self)
	self.sounds = {};

	self.sounds.bored = CreateSoundContainer(self.PresetName .. " Bored");
	self.sounds.attack = CreateSoundContainer(self.PresetName .. " Attack");
	
	self.sounds.pickup = CreateSoundContainer(self.PresetName .. " Pickup");

	self.sounds.panic = CreateSoundContainer(self.PresetName .. " Panic");
	self.sounds.fight = CreateSoundContainer(self.PresetName .. " Fight");
	
	self.sounds.pain = CreateSoundContainer(self.PresetName .. " Pain");
	self.sounds.belittle = CreateSoundContainer(self.PresetName .. " Belittle");
	
	self.sounds.danger = CreateSoundContainer(self.PresetName .. " Danger");
	
	self.sounds.goto = CreateSoundContainer(self.PresetName .. " Goto");
	
	self.sounds.calm = CreateSoundContainer(self.PresetName .. " Calm");
	self.sounds.upsetAtEnemy = CreateSoundContainer(self.PresetName .. " UpsetAtEnemy");
	self.sounds.upsetAtPlayer = CreateSoundContainer(self.PresetName .. " UpsetAtPlayer");
	
	self.sounds.kill = CreateSoundContainer(self.PresetName .. " Kill");
	
	self.sounds.fly = CreateSoundContainer(self.PresetName .. " Fly");
	
	self.sounds.bouttaDie = CreateSoundContainer(self.PresetName .. " BouttaDie");
	self.sounds.die = CreateSoundContainer(self.PresetName .. " Die");
	
	self.checkTimer = Timer();
	self.checkTimer:SetSimTimeLimitMS(500);
	
	self.idleTimer = Timer();
	self.idleTimer:SetSimTimeLimitMS(6000);
	
	self.mood = "Default";
end
function Update(self)
	self.controller = self:GetController();
	local soundToPlay;
	local playerControlled = self:IsPlayerControlled();
	local hurt = self.Health < self.PrevHealth - 2;
	if not self.dead then
		if self.playingSound and self.Head then
			if self.playingSound:IsBeingPlayed() then
				self.Head.Frame = math.floor(math.sin(self.Age * 0.02));
			else
				self.Head.Frame = 0;
				self.playingSound = nil;
			end
		else
			if self.target then
				if self.target.Status == Actor.DYING--[[ or not MovableMan:IsActor(self.target)]] then
					soundToPlay = self.sounds.kill;
				end
				self.idleTimer:Reset();

				if self.alarmedTimer then
					if self.alarmedTimer:IsPastSimMS(30000) then
						soundToPlay = self.sounds.attack;
						self.alarmedTimer:Reset();
					end
				else
					self.alarmedTimer = Timer();

					if self.target:HasObjectInGroup("Actors - Light") and math.random() < 0.5 then
						soundToPlay = self.sounds.belittle;
					else
						if self.Health < self.MaxHealth * 0.67 then
							if self.mood ~= "Panic" then
								self.mood = "Panic";
								soundToPlay = self.sounds.fight;
							end
						else
							self.mood = "UpsetAtEnemy";
						end
						soundToPlay = self.sounds.attack;
					end
				end
			else
				if hurt then
					self.mood = "UpsetAtPlayer";
				end
				if (not self.goToTimer or self.goToTimer:IsPastSimMS(30000)) and self.MOMoveTarget and SceneMan:ShortestDistance(self.Pos, self.MOMoveTarget.Pos, SceneMan.SceneWrapsX).Magnitude > 240 then
					soundToPlay = self.sounds.goto;
					if self.goToTimer then
						self.goToTimer:Reset();
					else
						self.goToTimer = Timer();
					end
				end
			end
			if self.checkTimer:IsPastSimTimeLimit() then
				self.checkTimer:Reset();
				self.target = self.AI.Target;
				if playerControlled then
					local dist = Vector();
					local enemy = MovableMan:GetClosestEnemyActor(self.Team, self.ViewPoint, math.min(FrameMan.PlayerScreenWidth, FrameMan.PlayerScreenHeight) * 0.3, dist);
					if enemy and not SceneMan:CastStrengthRay(enemy.Pos, dist, 10, Vector(), enemy.ID, 3, SceneMan.SceneWrapsX) then
						self.target = enemy;
					end
				end
				if self.alarmedTimer and self.alarmedTimer:IsPastSimMS(15000) then
					--self.playerSelected = false;
					playerControlled = true;
					self.alarmedTimer = nil;
				end
			end
			if playerControlled then
				self.prevPlayerPos = Vector(self.Pos.X, self.Pos.Y);
				if self.controller:IsState(Controller.WEAPON_PICKUP) and self.canPickup then
					soundToPlay = self.sounds.pickup;
				end
				if not self.playerSelected then
					if self.Health < 10 and self.WoundCount > 5 then
						soundToPlay = self.sounds.bouttaDie;
					elseif self.mood == "Bored" then
						soundToPlay = self.sounds.bored;
					elseif self.Health < self.MaxHealth then
						if self.mood == "UpsetAtEnemy" then
							soundToPlay = self.sounds.upsetAtEnemy;
						elseif self.mood == "Panic" then
							soundToPlay = self.sounds.panic;
						else--if self.mood == "UpsetAtPlayer" then
							soundToPlay = self.sounds.upsetAtPlayer;
						end
					else
						self.mood = "Calm";
						soundToPlay = self.sounds.calm;
					end
					self.playerSelected = true;
				end
				self.idleTimer:Reset();
			--	if SceneMan:ShortestDistance(self.prevPlayerPos, self.prevAIPos, SceneMan.SceneWrapsX).Magnitude < 120 then
			--		soundToPlay = self.sound.bored;
			--	end
			else
				self.prevAIPos = Vector(self.Pos.X, self.Pos.Y);
				self.playerSelected = false;
				if self.AIMode ~= Actor.AIMODE_SENTRY then
					self.idleTimer:Reset();
				end
				self.mood = self.idleTimer:IsPastSimTimeLimit() and "Bored" or self.mood;
			end
			if self.Status >= Actor.DYING then
				soundToPlay = self.sounds.die;
				self.dead = true;
			elseif hurt then
				
				soundToPlay = self.sounds.pain;
				self.idleTimer:Reset();
		--	elseif damage < 0 then	--Healed
		--		soundToPlay = self.sounds.happy;
			end
			if soundToPlay then
				self.playingSound = soundToPlay;
				soundToPlay:Play(self.Pos);
			end
		end
		self.canPickup = self.ItemInReach ~= nil;
	end
end