function Create(self)
	self.speed = 500;
	self.dir = 0;
	self.minAnimDuration = 135;
	self.Health = 1;
	self.SpriteAnimDuration = math.random(self.minAnimDuration, self.minAnimDuration * 2)/self.Health + (self.Vel.Magnitude - math.abs(self.AngularVel)) * 10;
end
function OnDetach(self)
	self.SpriteAnimDuration = math.random(self.minAnimDuration, self.minAnimDuration * 2)/self.Health + (self.Vel.Magnitude - math.abs(self.AngularVel)) * 10;
	self.AngularVel = self.AngularVel - self.Vel.X;
end
function OnCollideWithTerrain(self, terrainID)
	self.IgnoresTeamHits = false;
	self.Health = 1 - math.min(self.WoundCount/self.GibWoundLimit, 0.9);
	self.AngularVel = self.AngularVel + RangeRand(-0.1, 0.1);
	if SceneMan:GetTerrMatter(self.Pos.X, self.Pos.Y + 5) ~= rte.airID then
		if self.Vel.X < 0 then
			if self.dir == -1 then
				self.HFlipped = true;
			end
			self.dir = -1;
		else
			if self.dir == 1 then
				self.HFlipped = false;
			end
			self.dir = 1;
		end
		local uprightRatio = math.abs(math.cos(self.RotAngle * 0.5)) * self.Health/(1 + self.Vel.Magnitude);
		local velFactor = 1 - uprightRatio * 0.1;
		self.AngularVel = self.AngularVel * velFactor - math.sin(self.RotAngle) * uprightRatio;
		self.Vel = self.Vel * velFactor;
		self:AddForce(Vector(0, -self.speed):RadRotate(RangeRand(-1, 1) - self.dir * 0.5) * uprightRatio, Vector());
	end
	self.SpriteAnimDuration = math.random(self.minAnimDuration, self.minAnimDuration * 2)/self.Health - (self.Vel.Magnitude - math.abs(self.AngularVel)) * 10;
end
function OnAttach(self)
	self.SpriteAnimDuration = math.random(self.minAnimDuration, self.minAnimDuration * 2)/self.Health;
end