function Create(self)
	self.tailSize = 4;
	self.tailName = "Scorpion Tail Part";
	self.stingerName = "Scorpion Tail Stinger";
	self.tail = {};
	self.speed = 0.15;
	local part = self;
	--Find existing tail
	for i = 1, self.tailSize do
		for att in part.Attachables do
			if (i == self.tailSize and att.PresetName == self.stingerName) or att.PresetName == self.tailName then
				table.insert(self.tail, att);
				part = att;
				break;
			end
		end
	end
	--Create new tail if none was found
	if #self.tail == 0 then
		for i = 1, self.tailSize do
			local newPart = CreateAttachable(i == self.tailSize and self.stingerName or self.tailName);
			part:AddAttachable(newPart);
			table.insert(self.tail, newPart);
			part = newPart;
		end
	end
end
function Update(self)
	local parent = self:GetRootParent();
	if parent and IsACrab(parent) then
		parent = ToACrab(parent);
		local controller = parent:GetController();
		local curl = -0.8;
		self.rotTarget = -curl - parent.RotAngle;
		if controller:IsState(Controller.WEAPON_FIRE) then
			self.rotTarget = -math.pi * 0.3 - parent.RotAngle * self.FlipFactor;
			curl = curl * 0.3;
		end
		self.InheritedRotAngleOffset = (self.InheritedRotAngleOffset * (1 - self.speed) + self.rotTarget * self.speed);
		for i = 1, #self.tail do
			local part = self.tail[i];
			if part and not part.ToDelete then
				part.InheritedRotAngleOffset = (part.InheritedRotAngleOffset * (1 - self.speed) + curl * self.speed);
			else
				self.tail[i] = nil;
			end
		end
	end
end