function Create(self)
	self.length = 1 + ToMOSprite(self):GetSpriteWidth() * 0.5;
	self.isBG = string.find(self.PresetName, "BG");
	self.resetRotAngle = {};
end
function Update(self)
	for _, item in pairs(self.resetRotAngle) do
		if IsHDFirearm(item) then
			item.InheritedRotAngleOffset = 0;
		end
	end
	self.resetRotAngle = {};
	local parent = self:GetParent();
	if parent and IsAHuman(parent) then
		parent = ToAHuman(parent);
		local controller = parent:GetController();
		local aimAngle = parent:GetAimAngle(false);
		local arm = self.isBG and parent.BGArm or parent.FGArm;
		local length = 0;
		if arm then
			length = arm.Frame/arm.FrameCount;
			self.Frame = arm.Frame;
		end
		local reload = controller:IsState(Controller.WEAPON_RELOAD);
		local fire = controller:IsState(Controller.WEAPON_FIRE);
		local handsFull = parent.EquippedItem and parent.EquippedBGItem;
		local equipped;
		self.InheritedRotAngleOffset = (arm.RotAngle - parent.RotAngle) * self.FlipFactor;
		for att in self.Attachables do
			if IsHDFirearm(att) then
				equipped = ToHDFirearm(att);
				equipped.IgnoresTeamHits = true;
				equipped.ParentOffset = Vector(length * self.length, 0);
				equipped.InheritedRotAngleOffset = aimAngle - self.RotAngle * self.FlipFactor;
				table.insert(self.resetRotAngle, equipped);
				if fire then
					equipped:Activate();
					if equipped.RoundInMagCount == 0 then
						equipped:Reload();
					end
				else
					equipped:Deactivate();
				end
				if controller:IsState(Controller.WEAPON_DROP) and not (parent.EquippedItem or parent.EquippedBGItem) then
					MovableMan:AddItem(equipped:Clone());
					self:RemoveAttachable(equipped);
				elseif reload and (not equipped.Magazine or not equipped.Magazine.IsFull) then
					equipped:Reload();
				end
			end
		end
		if parent.EquippedItem and IsHDFirearm(parent.EquippedItem) and ((reload and not ToHDFirearm(parent.EquippedItem):IsFull()) or (fire and ToHDFirearm(parent.EquippedItem).RoundInMagCount == 0)) then
			ToHDFirearm(parent.EquippedItem):Reload();
		end
		if parent.EquippedBGItem and IsHDFirearm(parent.EquippedBGItem) and ((reload and not ToHDFirearm(parent.EquippedBGItem):IsFull()) or (fire and ToHDFirearm(parent.EquippedBGItem).RoundInMagCount == 0)) then
			ToHDFirearm(parent.EquippedBGItem):Reload();
		end
		if not equipped then
			for i = 1, parent.InventorySize do
				local item = parent:Inventory();
				if item and IsHDFirearm(item) and ToHDFirearm(item):IsOneHanded() and ToHDFirearm(item):IsDualWieldable() then
					self:AddAttachable(ToHDFirearm(item):Clone());
					item = nil;
					parent:SwapNextInventory(item, true);
					break;
					--parent:RemoveInventoryItem(item);
				end
				parent:SwapNextInventory(item, true);
			end
		end
	end
end