function Create(self)
	self.errorSound = CreateSoundContainer("Error", "Base.rte");
end
function Update(self)
	if self.EquippedItem then
		self.healing = nil;
		self:RemoveNumberValue("ApplyBandages");
	end
	if self.healing and self.healing.part then
		if self.healing.timer:IsPastSimTimeLimit() then
			local offset;
			--local bandageName = "Bandage" .. (string.find(self.healing.part.PresetName, "BG") and " BG" or "");
			if self.healing.wound then
				self.healing.wound.ToDelete = true;
				self.healing.wound = nil;
			else
				for wound in self.healing.part.Wounds do
					--[[
					if offset == nil or (wound.ParentOffset - offset).Magnitude > 1 then	--Patch nearby wounds with the same bandage
						offset = wound.ParentOffset;
						local bandage = CreateAttachable(bandageName, "Ronin.rte");
						bandage.Frame = offset.Magnitude > 4 and 1 or 0;
						bandage.InheritedRotAngleOffset = offset.AbsRadAngle;
						self.healing.part:AddAttachable(bandage, offset * 0.9);
					end
					]]--
					wound.ToDelete = true;
				end
			end
			self.healing = nil;
		else
			for state = 1, 40 do
				self.controller:SetState(state, false);
			end
			local arms = {self.FGArm, self.BGArm};
			for _, arm in pairs(arms) do
				if arm then
					arm = ToArm(arm);
					if IsAttachable(self.healing.part) then
						arm.IdleOffset = self.healing.part.ParentOffset - Vector(self.healing.part.JointOffset.X, self.healing.part.JointOffset.Y):RadRotate(self.healing.part.RotAngle) - arm.ParentOffset + Vector(self.healing.radius, 0):DegRotate(self.Age);
					else
						arm.IdleOffset = Vector(3, 0):DegRotate(self.Age) - arm.ParentOffset;
					end
				end
			end
		end
		self.controller:SetState(Controller.BODY_CROUCH, true);
	elseif self:NumberValueExists("ApplyBandages") then
		self.healing = {};
		local parts = {self.Head, self.FGArm, self, self.FGLeg, self.BGLeg, self.BGArm};
		local mostWounds = 0;
		for _, part in pairs(parts) do
			if part then
				local woundCount = part:GetWoundCount(false, false, false);
				if woundCount > mostWounds then
					mostWounds = woundCount
					self.healing.part = part;
					local avgWoundOffset = Vector();
					for wound in part.Wounds do
						avgWoundOffset = avgWoundOffset + wound.ParentOffset;
					end
					avgWoundOffset = avgWoundOffset/woundCount;
					self.healing.radius = avgWoundOffset.Magnitude * 0.9;
				end
			end
		end
		if self.healing.part then
			self.healing.timer = Timer();
			self.healing.timer:SetSimTimeLimitMS(1000 * math.sqrt(mostWounds));
			--[[Unequip both arms
			if self.EquippedItem then
				local item = CreateHeldDevice("Null Item");
				self:AddInventoryItem(item);
				self:EquipNamedDevice("Null Item", true);
				item.ToDelete = true;
			end
			]]--
		else
			self.healing = nil;
		end
		self:RemoveNumberValue("ApplyBandages");
	end
end
function OnPieMenu(self)
	if self.WoundCount == 0 then
		ToGameActivity(ActivityMan:GetActivity()):RemovePieMenuSlice("Heal", "ApplyBandages");
	end
end
function ApplyBandages(actor)
	if actor and IsAHuman(actor) and ToAHuman(actor).WoundCount > 0 then
		ToAHuman(actor):SetNumberValue("ApplyBandages", 1);
	else
		self.errorSound:Play(actor.Pos);
	end
end