function Create(self)
	self.jumpPower = self:NumberValueExists("JumpPower") and self:GetNumberValue("JumpPower") * 0.5 or 250;
	--self.jumpSound = CreateSoundContainer("Jump", "4zK.rte");
	self.jumpCoolDown = Timer();
	self.jumpCoolDown:SetSimTimeLimitMS(250);
end
function Update(self)
	self.controller = self:GetController();
	if self.controller:IsState(Controller.BODY_JUMPSTART) and self.jumpCoolDown:IsPastSimTimeLimit() then
		local feet = {self.FGFoot, self.BGFoot};
		local rotFactor =  math.abs(math.cos(self.RotAngle));
		local offset = (self.controller:IsState(Controller.MOVE_LEFT) or self.controller:IsState(Controller.MOVE_RIGHT)) and 5 or 3;
		local force = Vector();
		for i = 1, #feet do
			local foot = feet[i];
			if foot then
				local checkPos = foot.Pos + Vector(0, offset * rotFactor):RadRotate(self.RotAngle);
				if SceneMan:GetTerrMatter(checkPos.X, checkPos.Y) ~= rte.airID then
					self.Vel = self.Vel * 0.95;
					force = force + (Vector(0, -self.jumpPower) + Vector(self.jumpPower, 0):RadRotate(self:GetAimAngle(true))) * rotFactor;
					if self.jumpSound then
						self.jumpSound:Play(checkPos);
					end
					self.jumpCoolDown:Reset();
					--self.Status = Actor.UNSTABLE;
					break;
				end
			end
		end
		local arms = {self.FGArm, self.BGArm};
		for i = 1, #arms do
			local arm = arms[i];
			if arm then
				local checkPos = ToArm(arm).HandPos + Vector(offset * rotFactor * self.FlipFactor, 0);
				if SceneMan:GetTerrMatter(checkPos.X, checkPos.Y) ~= rte.airID then
					self.Vel = self.Vel * 0.95;
					force = force * 1.25 + (Vector(0, -self.jumpPower) + Vector(self.jumpPower, 0):RadRotate(self:GetAimAngle(true))) * rotFactor * 0.25;
					break;
				end
			end
		end
		if self.Jetpack then
			force = force * 0.4;
		end
		self:AddForce(force * (self.Mass - self.InventoryMass), Vector());
	end
	--[[Ukemi
	if self.controller:IsState(Controller.BODY_CROUCH) and math.abs(self.AngularVel) < 3 and self.PrevVel.Y + math.abs(self.PrevVel.X * 0.5) > 10 then
		local feet = {self.FGFoot, self.BGFoot};
		for _, foot in pairs(feet) do
			if foot and SceneMan:GetTerrMatter(foot.Pos.X, foot.Pos.Y + self.PrevVel.Y) ~= rte.airID then
				self.Vel = Vector(self.PrevVel.Magnitude * 0.5 * self.FlipFactor, -1);
				self.AngularVel = -12 * self.FlipFactor;
				self.Status = Actor.UNSTABLE;
				break;
			end
		end
	end
	]]--
end