function Create(self)
end
function Update(self)
	local controller = self:GetController();
	local inventory = self:Inventory();
	if inventory and IsAHuman(inventory) then
		local passenger = ToAHuman(inventory);
		if self.Team ~= passenger.Team then
			MovableMan:ChangeActorTeam(self, passenger.Team);
		end
		if controller:IsState(Controller.BODY_CROUCH) then
			self:DropAllInventory();
		end
	else
		self.Status = Actor.UNSTABLE;
		controller:SetState(Controller.WEAPON_FIRE, false);
		if self.HUDVisible then
			self.HUDVisible = false;
		end
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance(actor.Pos, self.Pos, SceneMan.SceneWrapsX);
			if dist.Magnitude < 50 then
				if IsAHuman(actor) and actor:GetController():IsState(Controller.BODY_CROUCH) then
					self:AddInventoryItem(actor:Clone());
					actor.ToDelete = true;
					ActivityMan:GetActivity():ReportDeath(actor.Team, -1);
				end
			end
		end
	end
end