
function Create(self)

	self.parent = nil;

	for actor in MovableMan.Actors do
		if actor.Team == self.Team and (IsAHuman(actor) or IsACrab(actor)) and SceneMan:ShortestDistance(self.Pos, actor.Pos, SceneMan.SceneWrapsX).Magnitude < 50 then
			if not actor:NumberValueExists("Parachute") then
				actor:SetNumberValue("Parachute", 1);

				spread = math.ceil(20*(self.Sharpness-1)*math.sin(1.57 +3.14*self.Sharpness));
				--print(spread);

				actor.Vel = actor.Vel*0.6 + Vector(0,20);	-- actor.Vel is relatively random here
				actor.AngularVel = math.random(-6,6);
				actor.Pos = actor.Pos +Vector(spread,-math.random(100));
				actor.Status = math.random(0,1);

				self.parent = ToActor(actor);
				self.Pos = self.parent.Pos;
				self.RotAngle = 3/2*math.pi;
				break;
			end
		end
	end

	-- deliver items too

	if self.parent == nil then
		for item in MovableMan.Items do
			if SceneMan:ShortestDistance(self.Pos, item.Pos, SceneMan.SceneWrapsX).Magnitude < 50 then
				if not ToMOSRotating(item):NumberValueExists("Parachute") then
					ToMOSRotating(item):SetNumberValue("Parachute", 1);

					spread = math.ceil(20*(self.Sharpness-1)*math.sin(1.57 +3.14*self.Sharpness));

					item.Vel = item.Vel*0.6 + Vector(0,20);	--
					item.AngularVel = math.random(-3,3);
					item.Pos = item.Pos +Vector(spread,-math.random(100));

					self.parent = ToMOSRotating(item);
					self.Pos = self.parent.Pos;
					self.RotAngle = 3/2*math.pi;
					break;
				end
			end
		end
	end
end

function Update(self)

	if self.parent then

		local height = self.parent.Diameter;

		if IsActor(self.parent) then
			height = ToActor(self.parent).Height;
			if not ToActor(self.parent):IsPlayerControlled() then

				ToActor(self.parent):GetController():SetState(Controller.BODY_JUMP,false);
				ToActor(self.parent):GetController():SetState(Controller.BODY_JUMPSTART,false);
			end
		end

		self.Scale = 1-0.5/(self.parent.Vel.Magnitude+1);

		self.Vel = self.parent.Vel+Vector(0,-1);
		self.Pos = self.parent.Pos;
		local massfactor = 1-1/(math.sqrt(math.abs(self.parent.Mass))*2+10);
		self.parent.Vel = Vector(self.parent.Vel.X*massfactor,self.parent.Vel.Y*massfactor);
		self.parent.AngularVel = self.parent.AngularVel*0.98;

		if self.parent.ToDelete then

			self.ToDelete = true;
		else
			local rayHitPos = Vector();
			local terrainRaycast = SceneMan:CastStrengthRay(self.Pos,Vector(self.Vel.X,self.Vel.Y):SetMagnitude(height),0,rayHitPos,0,0,SceneMan.SceneWrapsX);

			if terrainRaycast == true then
				self.ToDelete = true;
			end
		end
	else
		self.ToDelete = true;
	end

	if self.ToDelete then

		local gib = CreateMOSRotating("4zK.rte/Parachute Gib");
		gib.Pos = self.Pos + Vector(-43 * self.FlipFactor, 0):RadRotate(self.RotAngle);
		gib.Vel = self.Vel;
		gib.Scale = self.Scale;
		gib.RotAngle = self.RotAngle + math.pi * 0.5 * self.FlipFactor;
		gib.HFlipped = self.HFlipped;
		gib.AngularVel = self.AngularVel;
		MovableMan:AddMO(gib);
	end
end