function Create(self)
	self:Deactivate();

	self.StanceOffset = Vector(6, 6);
	self.SharpStanceOffset = Vector(6, 6);

	local template = CreateHeldDevice(self:GetModuleAndPresetName());
	self.realParentOffset = Vector(template.ParentOffset.X, template.ParentOffset.Y);
	DeleteEntity(template);
	
	self.activateTime = 200;
	--The following timer prevents a glitch where you can equip two items at once
	self.inventorySwapTimer = Timer();
	self.inventorySwapTimer:SetSimTimeLimitMS(math.ceil(TimerMan.DeltaTimeMS));
end
function Update(self)
	local parent = self:GetRootParent();
	if not self.inventorySwapTimer:IsPastSimTimeLimit() and IsAHuman(parent) then
		parent = ToAHuman(parent);
		self.HFlipped = parent.HFlipped;
		if self.activateTimer then
			self.StanceOffset = (Vector(0, -5) + (self.realParentOffset - self.JointOffset)):RadRotate(parent.RotAngle * parent.FlipFactor - parent:GetAimAngle(false)) - ToAttachable(self:GetParent()).ParentOffset;
			self.SharpStanceOffset = self.StanceOffset;
			if self.activateTimer:IsPastSimMS(self.activateTime) then
				local armor = self:Clone();
				armor.HFlipped = parent.HFlipped;
				parent:AddAttachable(armor, self.realParentOffset);
				if (armor.IndividualRadius + parent.SpriteOffset.Magnitude < parent.IndividualRadius - 1) or (EnforceLevelRequirement and self:GetNumberValue("DefenceLevel") > parent:GetNumberValue("DefenceLevel")) then
					parent:RemoveAttachable(armor, true, false);
				end
				self.ToDelete = true;
				if not parent.EquippedItem then
					parent:GetController():SetState(Controller.WEAPON_CHANGE_NEXT, true);
				end
			else
				local timerRatio = self.activateTimer.ElapsedSimTimeMS/self.activateTime;
				self.RotAngle = self.RotAngle * (1 - timerRatio) + parent.RotAngle * timerRatio;
			end
		elseif self:IsActivated() then
			self.activateTimer = Timer();
			for attachable in parent.Attachables do
				if attachable and attachable.PresetName == self.PresetName then
					--if IsHeldDevice(attachable) then
					--	parent:AddInventoryItem(attachable:Clone());
					--	attachable.ToDelete = true;
					--else
						parent:RemoveAttachable(attachable, true, false);
					--end
				end
			end
		end
	else
		self:Deactivate();
		self.activateTimer = nil;
	end
	self.inventorySwapTimer:Reset();
end