function Create(self)
	self:Deactivate();

	self.StanceOffset = Vector(6, 6);
	self.SharpStanceOffset = Vector(6, 6);
	self.SupportOffset = Vector(99, 99);
	
	self.activateTime = 150;
	--The following timer prevents a glitch where you can equip two items at once
	self.inventorySwapTimer = Timer();
	self.inventorySwapTimer:SetSimTimeLimitMS(math.ceil(TimerMan.DeltaTimeMS));
	self.activateSound = CreateSoundContainer("RS Eat", "4zK.rte");
end
function Update(self)
	local parent = self:GetRootParent();
	if IsAHuman(parent) and ToAHuman(parent).Head then
		parent = ToAHuman(parent);
		self.HFlipped = parent.HFlipped;
		if self.activateTimer then
			self.StanceOffset = (parent.Head.ParentOffset - parent.Head.JointOffset):RadRotate(parent.Head.RotAngle * parent.FlipFactor - parent:GetAimAngle(false)) - ToAttachable(self:GetParent()).ParentOffset;
			self.SharpStanceOffset = self.StanceOffset;
			if self.activateTimer:IsPastSimMS(self.activateTime) then
				parent.Health = math.min(parent.Health + self:GetNumberValue("HealthBonus"), parent.MaxHealth);
				self.activateSound:Play(parent.Head.Pos);
				if self:GetStringValue("Message") ~= "" then
					ConsoleMan:PrintString(self:GetStringValue("Message"));
				end
				self.ToDelete = true;
			end
		elseif self:IsActivated() then
			self.activateTimer = Timer();
		end
	else
		self:Deactivate();
		self.activateTimer = nil;
	end
	self.inventorySwapTimer:Reset();
end