function Create(self)
	self:Deactivate();

	self.StanceOffset = Vector(6, 6);
	self.SharpStanceOffset = Vector(6, 6);

	local template = CreateHeldDevice(self:GetModuleAndPresetName());
	self.realParentOffset = Vector(template.ParentOffset.X, template.ParentOffset.Y);
	DeleteEntity(template);
	
	self.activateTime = 200;
	--The following timer prevents a glitch where you can equip two items at once
	self.inventorySwapTimer = Timer();
	self.inventorySwapTimer:SetSimTimeLimitMS(math.ceil(TimerMan.DeltaTimeMS));
end
function Update(self)
	local parent = self:GetRootParent();
	if not self.inventorySwapTimer:IsPastSimTimeLimit() and IsAHuman(parent) and ToAHuman(parent).Head then
		parent = ToAHuman(parent);
		self.HFlipped = parent.HFlipped;
		if self.activateTimer then
			self.StanceOffset = ((parent.Head.ParentOffset - parent.Head.JointOffset) + (self.realParentOffset - self.JointOffset)):RadRotate(parent.Head.RotAngle * parent.FlipFactor - parent:GetAimAngle(false)) - ToAttachable(self:GetParent()).ParentOffset;
			self.SharpStanceOffset = self.StanceOffset;
			if self.activateTimer:IsPastSimMS(self.activateTime) then
				local headgear = self:Clone();
				headgear.HFlipped = parent.HFlipped;
				parent.Head:AddAttachable(headgear, self.realParentOffset);
				--Pop off the helmet if the head is too big
				if (headgear.IndividualRadius + self.realParentOffset.Magnitude < parent.Head.IndividualRadius - 1) or (EnforceLevelRequirement and self:GetNumberValue("DefenceLevel") > parent:GetNumberValue("DefenceLevel")) then
					parent.Head:RemoveAttachable(headgear, true, false);
				end
				if self:NumberValueExists("MagicBonus") then
					parent:SetNumberValue("MagicLevel", parent:GetNumberValue("MagicLevel") + self:GetNumberValue("MagicBonus"));
					headgear:RemoveNumberValue("MagicBonus");
				end
				self.ToDelete = true;
				if not parent.EquippedItem then
					parent:GetController():SetState(Controller.WEAPON_CHANGE_NEXT, true);
				end
			else
				local timerRatio = self.activateTimer.ElapsedSimTimeMS/self.activateTime;
				self.RotAngle = self.RotAngle * (1 - timerRatio) + parent.Head.RotAngle * timerRatio;
			end
		elseif self:IsActivated() then
			self.activateTimer = Timer();
			for attachable in parent.Head.Attachables do
				if attachable then
					--if IsHeldDevice(attachable) then
					--	parent:AddInventoryItem(attachable:Clone());
					--	attachable.ToDelete = true;
					--else
						parent.Head:RemoveAttachable(attachable, true, false);
					--end
				end
			end
		end
	else
		self:Deactivate();
		self.activateTimer = nil;
	end
	self.inventorySwapTimer:Reset();
end