function Create(self)
	self.skillLevel = {};
		self.skillLevel.ATTACK = self:GetNumberValue("AttackLevel");
		self.skillLevel.STRENGTH = self:GetNumberValue("StrengthLevel");
		self.skillLevel.DEFENCE = self:GetNumberValue("DefenceLevel");
		self.skillLevel.RANGED = self:GetNumberValue("RangedLevel");
		self.skillLevel.PRAYER = self:GetNumberValue("PrayerLevel");
		self.skillLevel.MAGIC = self:GetNumberValue("MagicLevel");
		self.skillLevel.RUNECRAFT = 1;
		self.skillLevel.HITPOINTS = self.MaxHealth;
		self.skillLevel.CRAFTING = 1;
		self.skillLevel.MINING = 1;
		self.skillLevel.SMITHING = 1;
		self.skillLevel.FISHING = 1;
		self.skillLevel.COOKING = 1;
		self.skillLevel.FIREMAKING = 1;
		self.skillLevel.WOODCUTTING = 1;
		
	for i = 1, #self.skillLevel do
		self.skillLevel[i] = math.min(math.max(self.skillLevel[i], 1), 99);
	end
	
	self.ThrowPrepTime = 1000/(1 + self.skillLevel.RANGED * 0.02);
	
	self.splat = CreateMOSRotating("Lämä", "4zK.rte");
	self.damage = {};
	self.totalDamage = 0;
	self.painSound = CreateSoundContainer("Rune Ukko Pain", "4zK.rte");
	self.tick = 300;
	self.deathDelay = self.tick * 4;
	self.tickTimer = Timer();
	self.tickTimer:SetSimTimeLimitMS(self.tick);
	self.boxWidth = 16;
	self.appliedThisFrame = 0;
	self.prevHealth = self.Health;
	self.pickupSound = CreateSoundContainer("RS Pick up", "4zK.rte");
	self.dropSound = CreateSoundContainer("RS Drop", "4zK.rte");
	self.jumpSound = CreateSoundContainer("RS Jump", "4zK.rte");
end
function Update(self)
	local controller = self:GetController();
	self.isDead = self.Status > Actor.INACTIVE;
	if self.WoundCount == 0 and self.PrevHealth <= self.Health then
		self.tickTimer:Reset();
		if self.Health < self.MaxHealth and not self.healthTimer then
			self.Health = math.min(self.Health + 0.001, self.MaxHealth);
		end
	end
	local damage = self.prevHealth - self.Health - self.appliedThisFrame;
	if self.tickTimer:IsPastSimTimeLimit() then
		local avgOffset = Vector();
		local woundCount = 0;
		local totalDamage = 0;
		local defenceFactor = 1 + self.skillLevel.DEFENCE * 0.1;
		for wound in self.Wounds do
			if wound.PresetName == "Rune Ukko Wound" then
				woundCount = woundCount + 1;
				avgOffset = avgOffset + wound.ParentOffset;
				totalDamage = totalDamage + (RangeRand(0, 5) * wound.DamageMultiplier * self.DamageMultiplier)/defenceFactor;
				wound.ToDelete = true;
			end
		end
		for att in self.Attachables do
			for wound in att.Wounds do
				if wound.PresetName == "Rune Ukko Wound" then
					woundCount = woundCount + 1;
					avgOffset = avgOffset + att.ParentOffset + wound.ParentOffset;
					totalDamage = totalDamage + (RangeRand(0, 5) * wound.DamageMultiplier * att.DamageMultiplier)/defenceFactor;
					wound.ToDelete = true;
				end
			end
		end
		local maxDamage = math.max(self.prevHealth, 1);
		avgOffset = avgOffset/woundCount;
		totalDamage = math.max(math.floor(totalDamage + damage), 0);
		if woundCount > 0 or totalDamage > 0 then
			if totalDamage < self.Health and totalDamage > 0 and not self.painSound:IsBeingPlayed() then
				self.painSound:Play(self.Pos);
			end
			self.appliedThisFrame = self.appliedThisFrame + totalDamage;
			table.insert(self.damage, {damage = math.floor(math.min(totalDamage, maxDamage) + 0.5), timer = Timer(), offset = avgOffset:RadRotate(self.RotAngle)});
			self.Health = self.Health - totalDamage;
			self.healthTimer = Timer();
			if self.skulled and self.Health <= 0 then
				for item in self.Inventory do
					item.ToDelete = true;
				end
			end
		end
		self.prevHealth = self.Health;
		self.tickTimer:Reset();
	end
	local count = 0;	--Failsafe
	for i = 1, #self.damage do
		if self.damage[i] then
			count = count + 1;
			if self.damage[i].timer then
				local drawPos = self.Pos + Vector(10 * math.sqrt(i - 1), 0):DegRotate((i - 1) * 137.508);
				--local drawPos = self.Pos + self.damage[i].offset;
				
				PrimitiveMan:DrawBitmapPrimitive(drawPos, self.splat, 0, (self.damage[i].damage > 0 and 0 or 1), false, false);
				PrimitiveMan:DrawTextPrimitive(drawPos + Vector(0, -5), tostring(self.damage[i].damage), true, 1);
				
				if self.damage[i].timer:IsPastSimMS(self.tick + 1000 + self.damage[i].damage * 10) then
					self.damage[i] = nil;
				end
			end
		end
	end
	--There is a glitch where he can avoid all damage from a hit, but I don't know how to fix it yet
	--if count == 0 then
	--	self.damage = {};
	--end
	self.appliedThisFrame = 0;
	if self.healthTimer then
		if self.healthTimer:IsPastSimMS(10000) then
			self.healthTimer = nil;
		else
			local upLeft = self.AboveHUDPos + Vector(-self.boxWidth * 0.5, 5) + self.Vel * rte.PxTravelledPerFrame;
			PrimitiveMan:DrawBoxFillPrimitive(upLeft, upLeft + Vector(self.boxWidth, 2), 12);
			if self.Health >= 0.5 then
				PrimitiveMan:DrawBoxFillPrimitive(upLeft, upLeft + Vector(math.floor(self.boxWidth * (self.Health/self.MaxHealth) + 0.5), 2), 148);
			end
		end
	end
	if controller:IsState(Controller.WEAPON_DROP) then
		local dropItem = self.EquippedItem or self.EquippedBGItem;
		if dropItem and IsAttachable(dropItem) then
			dropItem = ToAttachable(dropItem);
			ToMOSRotating(dropItem:GetParent()):RemoveAttachable(dropItem, true, true);
			local size = Vector(dropItem:GetSpriteWidth(), dropItem:GetSpriteHeight());
			if size.X > size.Y then
				dropItem.RotAngle = 0;
				dropItem.Pos = SceneMan:MovePointToGround(Vector(self.Pos.X + 5 * self.FlipFactor, self.Pos.Y), 0, 2) - Vector(0, size.Y * 0.5);
			else
				dropItem.RotAngle = math.pi * 0.5 * dropItem.FlipFactor;
				dropItem.Pos = SceneMan:MovePointToGround(Vector(self.Pos.X + 5 * self.FlipFactor, self.Pos.Y), 0, 2) - Vector(0, size.X * 0.5);
			end
			self.dropSound:Play(self.Pos);
		end
	end
	if self.EquippedItem and self.EquippedItem.PresetName == "Tea" and IsHDFirearm(self.EquippedItem) and ToHDFirearm(self.EquippedItem).FiredFrame then
		self.message = "Aaah, nothing like a nice cuppa tea!";
	end
	if self.message then
		self.messageTimer = self.messageTimer or Timer();
		PrimitiveMan:DrawTextPrimitive(self.AboveHUDPos, tostring(self.message), false, 1);
		if self.messageTimer:IsPastSimMS(2500) then
			self.message = nil;
			self.messageTimer = nil;
		end
	end
	controller:SetState(Controller.WEAPON_DROP, false);
	if controller:IsState(Controller.WEAPON_PICKUP) and self.ItemInReach and not self.pickupSound:IsBeingPlayed() then
		self.pickupSound:Play(self.Pos);
	end
	if self.isDead then
		if self.deathTimer then
			self.AngularVel = self.AngularVel * 0.5 + (0.3 - (self.deathTimer.ElapsedSimTimeMS/self.deathDelay)) * (3 + 3 * math.abs(math.cos(self.RotAngle))) * self.FlipFactor;
			self.ToSettle = false;
			if self.deathTimer:IsPastSimMS(self.deathDelay) then
				self.ToDelete = true;
			end
		else
			self.deathTimer = Timer();
		end
	elseif self.soundTimer and self.soundTimer:IsPastSimMS(self.tick) then
		self.soundTimer = nil;
	end
end
function Destroy(self)
	if MovableMan:ValidMO(self) and self.prevHealth > 0 then
		self.splat.Pos = Vector(self.Pos.X, self.Pos.Y);
		self.splat.Sharpness = math.floor(self.prevHealth + 0.5);
		MovableMan:AddParticle(self.splat);
	end
end