function Create(self)
	self.updateTimer = Timer();
	self.aggressive = true;	--On vihane
	self.walkSpeed = self:GetLimbPathSpeed(1);

	self.lungeTapDelay = 200;
	self.lungePower = 22;
	self.tapTimer = Timer();
end
function Update(self)
	self.controller = self:GetController();
	if self.RotAngle > math.pi then
		self.RotAngle = self.RotAngle - math.pi * 2;
	end
	if self.RotAngle < -math.pi then
		self.RotAngle = self.RotAngle + math.pi * 2;
	end
	if self.updateTimer:IsPastSimMS(250) then
		local healthRatio = self.Health/self.MaxHealth;
		if self.Status == Actor.STABLE then
			self:SetLimbPathSpeed(1, self.walkSpeed * RangeRand(0.75, 1.25) * (2 - healthRatio));
			self.AngularVel = self.AngularVel + RangeRand(-2, 2)/(math.abs(self.AngularVel - self.RotAngle) + 1);
		end
		if self.Frame == 0 and (self.WoundCount > self.GibWoundLimit * 0.5 or self.Health < self.MaxHealth * 0.5) then
			self.Frame = 1;	--Paita repee
		end
		self.updateTimer:Reset();
		self.DamageMultiplier = healthRatio;
		local limbs = {self.FGArm, self.BGArm, self.FGLeg, self.BGLeg};
		for _, limb in pairs(limbs) do
			if limb then
				limb.DamageMultiplier = healthRatio;
			end
		end
	end
	local crouching = self.controller:IsState(Controller.BODY_CROUCH);
	if self:IsPlayerControlled() and self.Status < Actor.DYING and self.FGLeg and self.BGLeg then
		if self.Status == Actor.UNSTABLE then
			if not crouching then
				local motion = self.Vel.Magnitude * 0.5 + math.abs(self.AngularVel);
				if self.AngularVel ~= 0 then
					self.AngularVel = self.AngularVel * (1 - 0.1/motion);
				end
			end
		elseif crouching then
			if not self.keyHeld then
				if not self.tapTimer:IsPastSimMS(self.lungeTapDelay) and SceneMan.Scene.GlobalAcc.Magnitude > 10 then
					Lunge(self, self.lungePower);
				else
					self.tapTimer:Reset();
				end	
			end
			self.keyHeld = true;
		else
			self.keyHeld = false;
		end
	end
	if self.aggressive and self.EquippedItem and IsHDFirearm(self.EquippedItem) then
		local gun = ToHDFirearm(self.EquippedItem);
		if self.firedLastFrame then
			self.firedLastFrame = false;
			for part in MovableMan.Particles do
				if part.Team == self.Team and SceneMan:ShortestDistance(gun.MuzzlePos, part.Pos + (self.Vel - part.Vel) * rte.PxTravelledPerFrame, SceneMan.SceneWrapsX).Magnitude < (1 + self.separation) then
					part.IgnoresTeamHits = false;	--Tapan kaikki
				end
			end
		elseif gun.FiredFrame then
			self.firedLastFrame = true;
		elseif gun.Magazine and gun.Magazine.NextRound then
			self.separation = gun.Magazine.NextRound.Separation;
		end
		gun.Team = -1;
	end
end