function Create(self)
	self.updateTimer = Timer();

	self.lungeTapDelay = 200;
	self.lungePower = 10;
	self.tapTimer = Timer();
	self.lastHFlipped = self.HFlipped;
	self.controller = self:GetController();
	self.maxWebs = 2;
	self.webs = {};
end
function Update(self)
	local webArm = self.EquippedItem == nil and self.FGArm or (self.EquippedBGItem == nil and self.BGArm or nil);
	if webArm and #self.webs < self.maxWebs then
		if self.controller:IsState(Controller.WEAPON_FIRE) then
			if not self.webShot then
				local web = CreateAEmitter("Webslinger Web Shot");
				web.Pos = webArm.HandPos;
				web.Vel = self.Vel;
				web.Team = self.Team;
				MovableMan:AddParticle(web);
				self.webArm = webArm;
				table.insert(self.webs, web);
				self.ArmSwingRate = 0.1;
			end
			self.webShot = true;
		else
			self.webShot = false;
		end
	end
	local arms = {self.FGArm, self.BGArm};
	for _, arm in pairs(arms) do
		if arm then
			arm.IdleOffset = Vector(6, 8);
		end
	end
	local reload = self.controller:IsState(Controller.WEAPON_RELOAD);
	for i = 1, #self.webs do
		if MovableMan:IsParticle(self.webs[i]) then
			if reload then
				self.webs[i].ToDelete = true;
			end
		else
			self.webs[i] = nil;
		end
	end
	if reload then
		self.webs = {};
		self.ArmSwingRate = 1;
	end
	--[[
	if self.FGArm then
		if self.webTarget and self.webTarget.ID ~= rte.NoMOID and not self.webTarget.ToDelete then
			local dist = SceneMan:ShortestDistance(ToArm(self.FGArm).HandPos, self.webTarget.Pos, SceneMan.SceneWrapsX);
			local forceVector = Vector(self.Vel.X, self.Vel.Y);
			if self.controller:IsMouseControlled() then
			elseif self.controller.AnalogAim.Magnitude > 0 then
			else
				if self.HFlipped ~= self.lastHFlipped then
					forceVector = forceVector + Vector(self.FlipFactor * 25, 0);
				end
			end
		end
	end
	]]--
	local crouching = self.controller:IsState(Controller.BODY_CROUCH);
end