function Create(self)
	self.waspCount = 10;
	self.maxDist = 100;
	self.pullStrength = 100;
	self.gravityPerFrame = SceneMan.Scene.GlobalAcc * GetMPP() * rte.PxTravelledPerFrame * 0.5;
	self.wasps = {};
	
	for i = 1, self.waspCount do
		self.wasps[i] = CreateActor("Swarm Wasp");
		self.wasps[i].Pos = self.Pos;
		self.wasps[i].Vel = self.Vel + Vector(math.random(5), 0):RadRotate(math.pi * 2 * math.random());
		MovableMan:AddActor(self.wasps[i]);
	end
end
function Update(self)
	local totalCount = 0;
	for i = 1, #self.wasps do
		local wasp = self.wasps[i];
		if wasp and IsActor(wasp) and wasp.Status == Actor.STABLE then
			local dist = SceneMan:ShortestDistance(wasp.Pos, self.Pos, SceneMan.SceneWrapsX);
			if dist.Magnitude < self.maxDist then
				totalCount = totalCount + wasp.Health/wasp.MaxHealth;
				wasp.Vel = wasp.Vel - self.gravityPerFrame;
				wasp:AddForce(dist:RadRotate(RangeRand(-0.1, 0.1)) * self.pullStrength, Vector());
			else
				wasp.Health = 0;
			end
		else
			self.wasps[i] = nil;
		end
	end
	self.Health = self.MaxHealth * totalCount/self.waspCount;
end