function Create(self)
	self.gunName = "UZI";
	
	self.lungeTapDelay = 200;
	self.lungePower = 6;
	self.tapTimer = Timer();
	self.dir = 0;
	
	self.stableVel = self:GetStableVelocityThreshold();
end
function Update(self)
	self.controller = self:GetController();
	local items = {self.EquippedItem, self.EquippedBGItem};
	local empty = self:IsInventoryEmpty();
	for _, item in pairs(items) do
		if item and IsHDFirearm(item) then
			empty = false;
			if item.PresetName == self.gunName or string.find(item.PresetName, "UZI") or string.find(item.PresetName, "Uzi") then
				item = ToHDFirearm(item)
				self.gunName = item.PresetName;
				if item.RoundInMagCount == 0 then
					item.HUDVisible = false;
					item.Lifetime = item.Age + math.random(4000, 6000);
					item.GetsHitByMOs = false;
					item:AddScript("Base.rte/Scripts/Shared/GibOverLifeTime.lua");
					item:GetParent():RemoveAttachable(item, true, false);
					
					item = CreateHDFirearm(self.gunName);
					item:SetGoldValue(0);
					item.UnPickupable = true;
					self:AddInventoryItem(item);
					
					self.controller:SetState(Controller.WEAPON_FIRE, false);
					self:EquipNamedDevice(self.gunName, true);
				end
			end
		end
	end
	if empty and (self.controller:IsState(Controller.WEAPON_RELOAD) or self.controller:IsState(Controller.WEAPON_CHANGE_NEXT) or self.controller:IsState(Controller.WEAPON_CHANGE_PREV)) and not self:HasObject(self.gunName) then
		local item = CreateHDFirearm(self.gunName);
		item:SetGoldValue(0);
		self:AddInventoryItem(item);
		if item:IsDualWieldable() then
			item = CreateHDFirearm(self.gunName);
			item:SetGoldValue(0);
			item.UnPickupable = true;
			self:AddInventoryItem(item);
		end
	end
	local crouching = false;
	if self:IsPlayerControlled() and self.Status < Actor.INACTIVE and self.FGLeg and self.BGLeg then
		crouching = self.controller:IsState(Controller.BODY_CROUCH);
		if self.Status == Actor.UNSTABLE then
			if self.dir == self.FlipFactor then
				local motion = (self.Vel.Magnitude * 0.5 + math.abs(self.AngularVel));
				local stillness = 1/(1 + motion);
				if crouching then
					self.AngularVel = self.AngularVel * (1 - stillness) - (self.RotAngle - (self:GetAimAngle(false) - math.pi * 0.5) * self.FlipFactor) * 2 * stillness;
				end
			else
				self.dir = 0;
			end
			crouching = false;
		elseif crouching then
			if not self.crouchHeld then
				if not self.tapTimer:IsPastSimMS(self.lungeTapDelay) and SceneMan.Scene.GlobalAcc.Magnitude > 10 then
				--	self.dir = HumanFunctions.Lunge(self, self.lungePower);
				end
				self.tapTimer:Reset();
				self.controller:SetState(Controller.BODY_CROUCH, false);
			end
		end
		self.crouchHeld = crouching;
	end
	self:SetStableVelocityThreshold(crouching and self.stableVel * (1 + math.cos(self.RotAngle)) or self.stableVel)
end