function Create(self)
	--Variables
	self.magicPower = self:GetNumberValue("MagicLevel");
	self.spellRadius = self.AimDistance + math.sqrt(self.magicPower) + math.sqrt(FrameMan.PlayerScreenWidth^2 + FrameMan.PlayerScreenHeight^2) * 0.3;
	self.firedDelay = 500;
	self.idleOffset = Vector(6, 6);
	--Static properties
	self.activity = ToGameActivity(ActivityMan:GetActivity());
	self.gravity = SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs;
	--Sounds
	self.dissipateSound = CreateSoundContainer("Dissipate Sound", "Techion.rte");
	self.disintegrationSound = CreateSoundContainer("Disintegration Sound", "Techion.rte");
	self.releaseSound = CreateSoundContainer("RS Splash");
	
	for att in self.Attachables do
		if att.PresetName == "Wizard Robe" then
			self.robe = att;
			break;
		end
	end
	if not self.robe then
		self.robe = CreateAttachable("Wizard Robe");
		self:AddAttachable(self.robe);
	end
	--Functions
	function self.Telekinesis(target, release)
		if target then
			local aimAngle = self:GetAimAngle(true);
			local arm = self.FGArm or self.BGArm;
			local startPos = arm.Pos + Vector(arm.Radius, 0):RadRotate(aimAngle);
			local dist = SceneMan:ShortestDistance(startPos, target.Pos, SceneMan.SceneWrapsX);
			if IsActor(target) then
				target = ToActor(target);
				if target.Status == Actor.STABLE and math.random(target.Mass) < math.random(self.Mass) then
					target.Status = Actor.UNSTABLE;
				end
			end
			self:SetWhichMOToNotHit(target, 100);
			target:SetWhichMOToNotHit(self, 100);
			local mass = math.sqrt(math.abs(target.Mass) + 1);
			local distRatio = 1 - (dist.Magnitude/(self.spellRadius * 1.1)) * 0.5;
			local resistance = (distRatio * self.healthRatio)/mass;
			local pushPower = math.min((self.magicPower * self.multiplier) * resistance, 444);
			local aimVector = Vector();
			if self.controller:IsMouseControlled() then
				--TODO: test this cus I have no idea how it works lol
				self.cursor = self.cursor and self.cursor + self.controller.MouseMovement or Vector(target.Pos.X, target.Pos.Y);
				--aimVector = Vector(self.controller.MouseMovement.X, self.controller.MouseMovement.Y);
				aimVector = SceneMan:ShortestDistance(target.Pos, self.cursor, SceneMan.SceneWrapsX) * rte.PxTravelledPerFrame;
			else
				aimVector = SceneMan:ShortestDistance(target.Pos, startPos + Vector(math.min(dist.Magnitude, self.spellRadius), 0):RadRotate(aimAngle), SceneMan.SceneWrapsX) * rte.PxTravelledPerFrame;
			end
			target.Vel = target.Vel/math.sqrt(1 + pushPower) + self.Vel * resistance + aimVector:SetMagnitude(math.min(aimVector.Magnitude, pushPower)) - self.gravity * target.GlobalAccScalar;
			target.AngularVel = target.AngularVel/(1 + math.abs(target.AngularVel) * 0.0001) - aimVector.X * TimerMan.DeltaTimeSecs * distRatio;
			if IsHDFirearm(target) then
				target = ToHDFirearm(target);
				if IsMagazine(self.newMag) then
					local dist = SceneMan:ShortestDistance(self.Pos, target.Pos + Vector((self.newMag.ParentOffset.X - self.newMag.JointOffset.X) * target.FlipFactor, self.newMag.ParentOffset.Y - self.newMag.JointOffset.Y):RadRotate(target.RotAngle), SceneMan.SceneWrapsX);
					self.newMag.Pos = self.Pos + Vector(dist.X, dist.Y) * target.ReloadProgress;
					self.newMag.Vel = self.gravity * self.newMag.GlobalAccScalar * (-1);
					self.newMag.RotAngle = target.RotAngle + SceneMan:ShortestDistance(self.newMag.Pos, target.Pos, SceneMan.SceneWrapsX).Magnitude * TimerMan.DeltaTimeSecs;
					self.newMag.HFlipped = target.HFlipped;
					if target:DoneReloading() then
						self.newMag.ToDelete = true;
						self.newMag = nil;
					end
				else
					self.newMag = nil;
				end
				if not target:IsFull() and self.controller:IsState(Controller.WEAPON_RELOAD) then
					if not MovableMan:ValidMO(self.newMag) then
						local reference = CreateHDFirearm(target:GetModuleAndPresetName());
						if reference.Magazine then
							self.newMag = reference.Magazine;
							reference:RemoveAttachable(reference.Magazine, true, true);
							self.newMag.Pos = self.Pos;
						end
						DeleteEntity(reference);
					end
					target:Reload();
				end
			end
			if release then
				self.cursor = nil;
				if IsActor(target) and target.Team ~= self.Team then
					target.IgnoresTeamHits = false;
				end
				target.HitsMOs = true;
				local vector = Vector(math.max(pushPower - target.Vel.Magnitude, 0), 0):RadRotate(aimAngle);
				target.Vel = target.Vel + vector;
				target.AngularVel = target.AngularVel - vector.X/math.sqrt(target.Radius);
			end
		end
	end
	function self.Shield(target, release)
		local shieldRadius = self.Diameter + math.sqrt(self.spellRadius) * (release and 1.5 or 1);
		local coll = {MovableMan.Actors, MovableMan.Items, MovableMan.Particles};
		local arm = self.FGArm or self.BGArm;
		local aimAngle = self:GetAimAngle(true);
		local startPos = arm.Pos + Vector(arm.MaxLength, 0):RadRotate(aimAngle);
		--PrimitiveMan:DrawCirclePrimitive(startPos, shieldRadius, 5);
		local power = self.magicPower * (release and 2 or 1);
		local glow;
		for i = 1, #coll do
			for mo in coll[i] do
				if mo.PinStrength == 0 and (mo.Team ~= self.Team or not mo.IgnoresTeamHits) and (mo.Team ~= Activity.NOTEAM or mo.HitsMOs) then
					local vel = mo.Vel + self.Vel;
					local force = mo.Mass * (1 + vel.Magnitude);
					if force > 1/mo.Radius then
						local checkPos = mo.Pos + vel * rte.PxTravelledPerFrame;
						local dist = SceneMan:ShortestDistance(startPos, checkPos, SceneMan.SceneWrapsX);
						if dist.Magnitude < shieldRadius then
							dist = SceneMan:ShortestDistance(startPos, checkPos, SceneMan.SceneWrapsX);
							local push = math.min(power/force, 1);
							mo.Vel = mo.Vel * (1 - push) + dist:SetMagnitude(vel.Magnitude * push + push);
							if mo.HitsMOs then
								mo.IgnoresTeamHits = false;
							end
							glow = CreateMOPixel("Laser Rifle Glow ".. math.min(math.floor(math.abs(force * 0.002 + mo.Radius * 0.02)), 5));
							glow.Pos = mo.Pos + Vector(mo.Radius * RangeRand(0, 0.5), 0):RadRotate(RangeRand(-math.pi, math.pi));
							glow.Vel = mo.Vel;
							MovableMan:AddParticle(glow);
						end
					end
				end
			end
		end
		if not glow then
			glow = CreateMOPixel("Laser Rifle Glow " .. math.random(0, 3));
			glow.Pos = startPos + Vector(shieldRadius, 0):RadRotate(aimAngle + RangeRand(-math.pi, math.pi));
			MovableMan:AddParticle(glow);
		end
	end
	function self.Bloat(target, release)
		if target then
			local mass = math.sqrt(math.abs(target.Mass) + 1);
			local distRatio = 1 - (SceneMan:ShortestDistance(self.Pos, target.Pos, SceneMan.SceneWrapsX).Magnitude/(self.spellRadius * 1.1)) * 0.5;
			local resistance = (distRatio * self.healthRatio)/mass;
			local power = math.sqrt(self.magicPower * self.multiplier) * resistance;
			local speed = 1 + (power * 0.01);
			target.Scale = target.Scale * speed;
			local maxScale = 1.5;
			local vec = Vector(power * (release and 20 or 4) * target.Scale, 0):RadRotate(self:GetAimAngle(true));
			for att1 in target.Attachables do
				att1.Scale = att1.Scale * speed;
				att1.ParentOffset = Vector(att1.ParentOffset.X, att1.ParentOffset.Y):SetMagnitude(att1.ParentOffset.Magnitude * speed);
				for att2 in att1.Attachables do
					att2.Scale = att2.Scale * speed;
					att2.ParentOffset = Vector(att2.ParentOffset.X, att2.ParentOffset.Y):SetMagnitude(att2.ParentOffset.Magnitude * speed);
					for att3 in att2.Attachables do
						att3.Scale = att3.Scale * speed;
						att3.ParentOffset = Vector(att3.ParentOffset.X, att3.ParentOffset.Y):SetMagnitude(att3.ParentOffset.Magnitude * speed);
						for att4 in att3.Attachables do
							att4.Scale = att4.Scale * speed;
							att4.ParentOffset = Vector(att4.ParentOffset.X, att4.ParentOffset.Y):SetMagnitude(att4.ParentOffset.Magnitude * speed);
							if (release and att4.Scale > RangeRand(1, maxScale)) or att4.Scale > RangeRand(maxScale, maxScale * 2) then att4.Vel = att4.Vel + vec; att4:GibThis(); end
						end
						if (release and att3.Scale > RangeRand(1, maxScale)) or att3.Scale > RangeRand(maxScale, maxScale * 2) then att3.Vel = att3.Vel + vec; att3:GibThis(); end
					end
					if (release and att2.Scale > RangeRand(1, maxScale)) or att2.Scale > RangeRand(maxScale, maxScale * 2) then att2.Vel = att2.Vel + vec; att2:GibThis(); end
				end
				if (release and att1.Scale > RangeRand(1, maxScale)) or att1.Scale > RangeRand(maxScale, maxScale * 2) then att1.Vel = att1.Vel + vec; att1:GibThis(); end
			end
			if (release and target.Scale > maxScale) or target.Scale > maxScale * 2 then target.Vel = target.Vel + vec; target:GibThis(); end
		end
	end
	function self.Teleport(target, release)
		if target then
			if self.controller.Player ~= Activity.PLAYER_NONE then
				local frames = math.ceil(math.sqrt(target.IndividualRadius) * 5);
				local timeScalar = (frames - math.floor(self.Age/TimerMan.DeltaTimeMS) % frames)/frames;
				PrimitiveMan:DrawCirclePrimitive(self.controller.Player, target.Pos, (target.Radius * 1.1) * timeScalar, 254);
			end
			if release then
				local massRatio = 1/((target.Mass > 0 and self.Mass > 0) and math.max(target.Mass/self.Mass, 1) or 1);
				local prevPos = Vector(self.Pos.X, self.Pos.Y);
				local prevVel = Vector(self.Vel.X, self.Vel.Y);
				self.Pos = target.Pos;
				self.Vel = self.Vel * (1 - massRatio) + target.Vel * (massRatio);
				if IsActor(target) then
					ToActor(target):FlashWhite(80);
				end
				self:FlashWhite(80);
				target.Pos = prevPos;
				target.Vel = target.Vel * (1 - massRatio) + prevVel * (massRatio);
					
				local targets = {self.Pos, target.Pos};
				for _, pos in pairs(targets) do
					local effect = CreateMOSRotating("Warp Grenade Effect", "Techion.rte");
					effect.Pos = pos;
					MovableMan:AddParticle(effect);
					effect:GibThis();
				end
			end
		end
	end
	function self.Carcinizate(target, release)
		if target and target.Radius > 10 and not string.find(target.PresetName, "Crab") then
			local distRatio = 1 - (SceneMan:ShortestDistance(self.Pos, target.Pos, SceneMan.SceneWrapsX).Magnitude/(self.spellRadius * 1.1)) * 0.5;
			local size = math.sqrt(target.Radius + math.abs(target.Mass) + target.Material.StructuralIntegrity);
			local power = (self.magicPower * 0.01 * distRatio * self.healthRatio)/size;
			local charge = target.Scale;
			target.Scale = target.Scale * 0.99;
			local count = 1;
			for att in target.Attachables do
				att.ParentOffset = Vector(att.ParentOffset.X, att.ParentOffset.Y):SetMagnitude(att.ParentOffset.Magnitude * 0.93);
				att.JointOffset = Vector(att.JointOffset.X, att.JointOffset.Y):SetMagnitude(att.JointOffset.Magnitude * 0.96);
				charge = charge + att.ParentOffset.Magnitude + att.JointOffset.Magnitude;
				count = count + 1;
			end
			if charge < (release and 7 or 3) * count then
				self.controller:SetState(Controller.WEAPON_FIRE, false);
				if size > math.sqrt(self.Radius + math.abs(self.Mass) + self.Material.StructuralIntegrity) * 2 then
					target = self;
				end
				if IsActor(target) then
					ToActor(target):FlashWhite(100);
					ActivityMan:GetActivity():ReportDeath(target.Team, -1);
				end
				local crab = target.Radius > 20 and CreateACrab("Crab") or CreateThrownDevice("Baby Crab");
				crab.Team = target.Team;
				crab.Pos = target.Pos;
				crab.RotAngle = target.RotAngle;
				crab.HFlipped = target.HFlipped;
				crab.Vel = target.Vel * 0.5;
				crab.AngularVel = target.AngularVel * 0.5;
				MovableMan:AddMO(crab);
				PrimitiveMan:DrawCircleFillPrimitive(crab.Pos, math.max(target.Radius, crab.Radius), 254);
				target.ToDelete = true;
			end
		end
	end
	function self.Laser(target, release)
	
		local arms = {self.FGArm, self.BGArm};
		local vel = math.sqrt(self.Vel.Magnitude);
		local power = self.magicPower * self.multiplier;
		for i = 1, #arms do
			if arms[i] then
				local startPos = arms[i].HandPos;
				local hitPos = Vector(startPos.X, startPos.Y);
				local gapPos = Vector(startPos.X, startPos.Y);
				local range = self.spellRadius + math.random(power);
				local skipPx = 4;
				local trace = (arms[i].IdleOffset * vel) + Vector(self.spellRadius, 0):RadRotate(self:GetAimAngle(true)):SetMagnitude(range);
				local rayLength = SceneMan:CastObstacleRay(startPos, trace, hitPos, gapPos, self.ID, self.Team, rte.airID, skipPx);
			
				if rayLength >= 0 then
					gapPos = gapPos - Vector(trace.X, trace.Y):SetMagnitude(skipPx);
					skipPx = 1;
					local shortRay = SceneMan:CastObstacleRay(gapPos, Vector(trace.X, trace.Y):SetMagnitude(range - rayLength + skipPx), hitPos, gapPos, self.ID, self.Team, rte.airID, skipPx);
					gapPos = gapPos - Vector(trace.X, trace.Y):SetMagnitude(skipPx);
					local strengthFactor = math.max(1 - rayLength/self.spellRadius, math.random()) * math.random();
					
					local moID = SceneMan:GetMOIDPixel(hitPos.X, hitPos.Y);
					if moID ~= rte.NoMOID and moID ~= self.ID then
						local mo = ToMOSRotating(MovableMan:GetMOFromID(moID));
						if power * strengthFactor >= mo.Material.StructuralIntegrity then
							local moAngle = -mo.RotAngle * mo.FlipFactor;
							
							local woundName = mo:GetEntryWoundPresetName();
							if woundName ~= "" then
								local wound = CreateAEmitter(woundName);
								
								local dist = SceneMan:ShortestDistance(mo.Pos, hitPos, SceneMan.SceneWrapsX);
								local offset = Vector(dist.X * mo.FlipFactor, dist.Y):RadRotate(moAngle):SetMagnitude(dist.Magnitude - (wound.Radius - 1) * wound.Scale);
								local traceOffset = Vector(trace.X * mo.FlipFactor, trace.Y):RadRotate(moAngle);
								
								wound.InheritedRotAngleOffset = traceOffset.AbsRadAngle - (mo.HFlipped and 0 or math.pi);
								mo:AddWound(wound, Vector(offset.X, offset.Y), true);
							end
						end
					end
					local smoke = CreateMOSParticle("Tiny Smoke Ball 1" .. (math.random() < 0.5 and " Glow Blue" or ""), "Base.rte");
					smoke.Pos = gapPos;
					smoke.Vel = Vector(-trace.X, -trace.Y):SetMagnitude(math.random(3, 6)):RadRotate(RangeRand(-1.5, 1.5));
					smoke.Lifetime = smoke.Lifetime/strengthFactor;
					MovableMan:AddParticle(smoke);

					local pix = CreateMOPixel("Laser Rifle Glow " .. math.floor(strengthFactor * 5 + 0.5), "Techion.rte");
					pix.Pos = gapPos;
					pix.Sharpness = power/6;
					pix.Vel = Vector(trace.X, trace.Y):SetMagnitude(6);
					MovableMan:AddParticle(pix);
				end
				if rayLength ~= 0 then
					trace = SceneMan:ShortestDistance(startPos, gapPos, SceneMan.SceneWrapsX);
					for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
						local team = self.activity:GetTeamOfPlayer(player);
						local screen = self.activity:ScreenOfPlayer(player);
						if screen ~= -1 and not (SceneMan:IsUnseen(startPos.X, startPos.Y, team) or SceneMan:IsUnseen(hitPos.X, hitPos.Y, team)) then
							PrimitiveMan:DrawLinePrimitive(screen, startPos, startPos + trace, 254);
						end
					end
					local particleCount = trace.Magnitude * RangeRand(0.4, 0.8);
					for i = 0, particleCount do
						local pix = CreateMOPixel("Laser Rifle Glow 0", "Techion.rte");
						pix.Pos = startPos + trace * i/particleCount;
						pix.Vel = self.Vel;
						MovableMan:AddParticle(pix);
					end
				end
			end
		end
	end
	function self.Confuse(target, release)
		if target then
			if IsActor(target) then
				target = ToActor(target);
				local cont = target:GetController();
				
				local aiming = cont:IsState(Controller.AIM_SHARP);
				local firing = cont:IsState(Controller.WEAPON_FIRE);
				
				cont:SetState(Controller.WEAPON_FIRE, aiming);
				cont:SetState(Controller.AIM_SHARP, firing);
	
				if cont:IsState(Controller.BODY_JUMP) then
				
					cont:SetState(Controller.BODY_JUMP, false);
					cont:SetState(Controller.BODY_JUMPSTART, false);
					cont:SetState(Controller.BODY_CROUCH, true);
					
				elseif cont:IsState(Controller.BODY_CROUCH) then
				
					if not controller:IsState(Controller.BODY_JUMP) then
						cont:SetState(Controller.BODY_JUMPSTART, true);
					end
					cont:SetState(Controller.BODY_JUMP, true);
					cont:SetState(Controller.BODY_CROUCH, false);
				end
				if cont:IsState(Controller.MOVE_LEFT) then
				
					cont:SetState(Controller.MOVE_LEFT, false);
					cont:SetState(Controller.MOVE_RIGHT, true);
					
				elseif cont:IsState(Controller.MOVE_RIGHT) then
				
					cont:SetState(Controller.MOVE_RIGHT, false);
					cont:SetState(Controller.MOVE_LEFT, true);
				end
				if release and target.Status == Actor.STABLE then
					target.Status = Actor.UNSTABLE;
				end
			end
		end
	end
	function self.Control(target, release)
		if target then
			local dist = SceneMan:ShortestDistance(self.EyePos, target.EyePos or target.Pos, SceneMan.SceneWrapsX);
			if IsActor(target) then
				target = ToActor(target);
				local controller = target:GetController();
				for i = 1, Controller.CONTROLSTATECOUNT - 1 do
					if i ~= Controller.WEAPON_FIRE then
						controller:SetState(i, self.controller:IsState(i));
						self.controller:SetState(i, false);
					end
				end
				if dist.Magnitude > self.Radius then
					self:SetAimAngle(math.sin(dist.AbsRadAngle));
					self.HFlipped = dist.X < 0;
				end
				if release then
					if target.Status == Actor.STABLE then
						target.Status = Actor.UNSTABLE;
					end
					controller:SetState(Controller.WEAPON_FIRE, true);
				end
			else
				local resistance = math.sqrt(target.Radius + math.abs(target.Mass) + target.Vel.Magnitude);
				local power = self.magicPower/resistance;
				local rot = math.sin(self:GetAimAngle(true) - self.lastAimAngle) * power;
				target.AngularVel = target.AngularVel + rot;
				target.RotAngle = target.RotAngle + rot * TimerMan.DeltaTimeSecs;
				target.Vel = target.Vel - (SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs * target.GlobalAccScalar) * (math.abs(rot * 5)/resistance);
				if IsHDFirearm(target) then
					ToHDFirearm(target):Deactivate();
					if self.prevHFlipped ~= self.HFlipped then
						target.HFlipped = self.HFlipped;
					end
					if self.controller:IsState(Controller.WEAPON_RELOAD) then
						ToHDFirearm(target):Reload();
					end
				end
			end
			if release then
				local vector = Vector(math.max(math.sqrt(self.magicPower) * ((1 - (dist.Magnitude/(self.spellRadius * 1.1)) * 0.5) * self.healthRatio)/math.sqrt(math.abs(target.Mass) + 1), 0), 0):RadRotate(self:GetAimAngle(true));
				target.Vel = target.Vel + vector;
				target.AngularVel = target.AngularVel - vector.X/math.sqrt(target.Radius);
				if IsHDFirearm(target) then
					ToHDFirearm(target):Activate();
				end
			end
		end
	end
	function self.Heal(target, release)
		if MovableMan:IsActor(target) and ToActor(target).Health < ToActor(target).MaxHealth then
			target = (target.Team ~= self.Team and self.Health < self.MaxHealth) and self or ToActor(target);
		else
			target = self;
		end
		local distRatio = 1 - SceneMan:ShortestDistance((self.FGArm or self.BGArm).Pos, target.Pos, SceneMan.SceneWrapsX).Magnitude/(self.spellRadius * 1.1) * 0.5;
		local power = math.sqrt(self.magicPower * self.multiplier);
		local tick = math.ceil(math.sqrt(target.IndividualRadius) * distRatio * 30/power);
		if math.floor(self.Age/TimerMan.DeltaTimeMS) % tick == 0 then
			if target.WoundCount > 0 then
				target:FlashWhite(60/power);
				target:RemoveWounds(1);
			elseif target.Health < target.MaxHealth then
				target:FlashWhite(60/power);
				target.Health = math.min(target.Health + 1, target.MaxHealth);
			end
		end
	end
	function self.Alchemize(target, release)

		local dustTarget;

		if target then
			local distRatio = 1 - (SceneMan:ShortestDistance((self.FGArm or self.BGArm).Pos, target.Pos, SceneMan.SceneWrapsX).Magnitude/(self.spellRadius * 1.1)) * 0.5;
			local power = math.sqrt(self.magicPower * self.multiplier) * distRatio * self.healthRatio;
			if release or math.floor(self.Age/TimerMan.DeltaTimeMS) % math.ceil(math.sqrt(target.Mass + target.IndividualRadius + target.Material.StructuralIntegrity) * 10/power) == 0 then
					
				if IsActor(target) then
					target = ToActor(target);
					target:FlashWhite(10);
					target.Health = target.Health - 1;
					if target.Health < 1 or target.Status > Actor.INACTIVE then
						dustTarget = target;
					end
				elseif target.GibWoundLimit > 0 then
					if target:GetWoundCount(true, false, false) + 1 >= target.GibWoundLimit then
						dustTarget = ToMOSRotating(target);
					else
						target:AddWound(CreateAEmitter("Null Emitter"), Vector(), false);
					end
				end
				local piece = CreateMOPixel("4zK.rte/Gold Particle " .. math.random(9));
				piece.Pos = target.Pos;
				piece.Vel = target.Vel * 0.5 + Vector(math.sqrt(target.Radius), 0):RadRotate(RangeRand(-math.pi, math.pi)) + Vector(0, -1);
				piece.GlobalAccScalar = piece.GlobalAccScalar * RangeRand(0.8, 1.0);
				piece.AirResistance = RangeRand(0, 0.1);
				MovableMan:AddParticle(piece);
				
				if self.dissipateSound:IsBeingPlayed() then
					self.dissipateSound.Pitch = RangeRand(RangeRand(0.9, 1.2));
					self.dissipateSound:Play(target.Pos);
				end
			end
			if dustTarget then
				local parts = {dustTarget};
				--Measure the corners of a box that the Actor is supposedly inside of
				local topLeft = Vector(-dustTarget.IndividualRadius, -dustTarget.IndividualRadius);
				local bottomRight = Vector(dustTarget.IndividualRadius, dustTarget.IndividualRadius);
				for att in dustTarget.Attachables do
					if IsAttachable(att) then
						local dist = SceneMan:ShortestDistance(dustTarget.Pos, att.Pos, SceneMan.SceneWrapsX);
						local reach = dist:SetMagnitude(dist.Magnitude + att.Radius + 5);
						if reach.X < topLeft.X then
							topLeft.X = reach.X;
						elseif reach.X > bottomRight.X then
							bottomRight.X = reach.X;
						end
						if reach.Y < topLeft.Y then
							topLeft.Y = reach.Y;
						elseif reach.Y > bottomRight.Y then
							bottomRight.Y = reach.Y;
						end
						table.insert(parts, att);
					end
				end
				--Spawn a pixel particle for each pixel of the Actor
				local skip = 2;
				for x = 1, (bottomRight.X - topLeft.X)/skip do
					for y = 1, (bottomRight.Y - topLeft.Y) do
						local checkPos = (dustTarget.Pos + topLeft) + Vector(x * skip, y);
						local terrCheck = SceneMan:GetTerrMatter(checkPos.X, checkPos.Y);
						if terrCheck == rte.airID or terrCheck == rte.grassID then
							local id = SceneMan:GetMOIDPixel(checkPos.X, checkPos.Y);
							if id ~= rte.NoMOID and MovableMan:GetMOFromID(id).RootID == dustTarget.ID then
								for px = 1, skip do
									local piece = CreateMOPixel("4zK.rte/Gold Particle " .. math.random(9));
									piece.Pos = checkPos + Vector(px - 1, 0);
									piece.Vel = dustTarget.Vel * RangeRand(0.25, 0.50) + Vector(0, -1) + SceneMan:ShortestDistance(dustTarget.Pos, piece.Pos, SceneMan.SceneWrapsX):SetMagnitude(math.random());
									piece.GlobalAccScalar = piece.GlobalAccScalar * RangeRand(0.75, 1.0);
									piece.AirResistance = RangeRand(0, 0.1);
									MovableMan:AddParticle(piece);
								end
							end
						end
					end
				end
				for _, mo in pairs(parts) do
					local particleCount = math.sqrt(mo.IndividualRadius);
					for i = 1, particleCount do
						local piece = CreateMOPixel("4zK.rte/Gold Particle " .. math.random(9));
						local vector = Vector(particleCount * RangeRand(0.5, 1.5), 0):RadRotate(RangeRand(-math.pi, math.pi));
						piece.Pos = mo.Pos + vector;
						piece.Vel = dustTarget.Vel * RangeRand(0.3, 0.6) + Vector(0, -1) + vector;
						piece.GlobalAccScalar = piece.GlobalAccScalar * RangeRand(0.75, 1.0);
						piece.AirResistance = RangeRand(0, 0.1);
						MovableMan:AddParticle(piece);
					end
					local glowDiameter = math.min(math.floor(1 + (mo.Diameter * mo.Scale) * 0.1) * 10, 50);
					local glow = CreateMOPixel("Techion.rte/Disintegration Glow ".. glowDiameter);
					glow.Pos = mo.Pos;
					glow.Vel = mo.Vel;
					MovableMan:AddParticle(glow);
				end
				self.disintegrationSound:Play(dustTarget.Pos);
				dustTarget.ToDelete = true;
			end
		end
	end
	self.chant = CreateSoundContainer("Wizard Chant");
	self.lastAimAngle = self:GetAimAngle(true);
	self.castCurrentSpell = self.Shield;
	self.spells = {["Telekinesis"] = self.Telekinesis, ["Teleport"] = self.Teleport, ["Heal"] = self.Heal, ["Shield"] = self.Shield, ["Confuse"] = self.Confuse, ["Control"] = self.Control, ["Alchemize"] = self.Alchemize};
end
function OnPieMenu(self)
	local drunk = self.Status == Actor.INACTIVE and self:GetNumberValue("AlcoholLevel") > 0;
	if not (self.FGArm or self.BGArm) or drunk then
		for x, y in pairs(self.spells) do
			self.activity:RemovePieMenuSlice(x, self.PresetName .. x);
		end
	end
	if drunk then
		self.activity:AddPieMenuSlice("Sober", "VelhoSober", 2, true);
	else
		self.activity:RemovePieMenuSlice("Sober", "VelhoSober");
	end
	self.activity:RemovePieMenuSlice("Brain Hunt AI Mode", "");
	self.activity:RemovePieMenuSlice("Gold Dig AI Mode", "");
	self.activity:RemovePieMenuSlice("Patrol AI Mode", "");
	self.activity:RemovePieMenuSlice("Not holding anything!", "");
end
function Update(self)
	if self:StringValueExists("Spell") then
		self:UnequipFGArm();
		self:UnequipBGArm();
		self.castCurrentSpell = self.spells[self:GetStringValue("Spell")];
		self:RemoveStringValue("Spell");
	end
	local alcLevel = self:GetNumberValue("AlcoholLevel");
	self.multiplier = 1 + alcLevel;
	local aimAngle = self:GetAimAngle(false);
	if self.Head then
		self.chant.Pos = self.Head.Pos;
		if alcLevel > 0 then
			self.chant.Pitch = 1 + ((self.RotAngle - self.Head.RotAngle) * self.FlipFactor + aimAngle) * alcLevel * 0.1;
		end
		if self.chant:IsBeingPlayed() then
			self.Head.SpriteAnimMode = MOSprite.ALWAYSPINGPONG;
		else
			self.Head.SpriteAnimMOde = MOSprite.NOANIM;
			self.Head.Frame = 0;
		end
	end
	self.magicPower = self:GetNumberValue("MagicLevel");
	self.controller = self:GetController();
	self.healthRatio = 0.5 + (self.Health/self.MaxHealth) * 0.5;
	local firing = self.controller:IsState(Controller.WEAPON_FIRE);
	local arms = {self.FGArm, self.BGArm};
	if self.Status == Actor.STABLE and (self.FGArm or self.BGArm) then
		local casting = firing and not (self.EquippedItem or self.EquippedBGItem) and not self.firedTimer;
		if casting then
			local animSpeed = 0.7;
			
			if self.target == nil then
				local trace = Vector(self.spellRadius, 0):RadRotate(self:GetAimAngle(true));
				--self.target = MovableMan:GetClosestEnemyActor(self.Team, self.Pos + trace * 0.5, self.spellRadius * 0.5, Vector());
				local moCheck = SceneMan:CastMORay((self.FGArm or self.BGArm).HandPos, trace, self.ID, Activity.NOTEAM, rte.airID, false, math.sqrt(self.spellRadius) * 0.5);
				if moCheck ~= rte.NoMOID then
					self.target = ToMOSRotating(ToMOSRotating(MovableMan:GetMOFromID(moCheck)):GetRootParent());
				end
			end
			if self.target == nil or not IsMOSRotating(self.target) or not MovableMan:ValidMO(self.target) or self.target.PinStrength > 0 or SceneMan:ShortestDistance(self.Pos, self.target.Pos, SceneMan.SceneWrapsX).Magnitude > self.spellRadius * 1.1 then
				self.target = nil;
				--self.chant:Stop();
			else
				self.animSpeed = 1.0;
			end
			if not self.chant:IsBeingPlayed() then
				self.chant:Play(self.Pos);
			end
			self.castCurrentSpell(self.target, false);
			
			for i = 1, #arms do
				if arms[i] then
					local prevOffset = Vector(arms[i].IdleOffset.X, arms[i].IdleOffset.Y);
					local offset = Vector(arms[i].MaxLength * 0.6, 0):RadRotate(self.Age * 0.01 * animSpeed - math.pi * i);
					--arms[i].IdleOffset = Vector(arms[i].MaxLength * 0.6 + offset.X * 0.5, offset.Y):RadRotate(aimAngle * 0.6 + math.pi * 0.2);
					arms[i].IdleOffset = Vector(arms[i].MaxLength * 0.6 + offset.X * 0.5, offset.Y):RadRotate(aimAngle);
				
					local handPos = arms[i].HandPos + Vector(-1, -1);
					local power = (self.target and self.magicPower or self.magicPower^0.9) * self.multiplier * RangeRand(0.004, 0.04);
					local px = CreateMOPixel("Laser Rifle Glow " .. math.min(math.floor(power), 4));
					px.Pos = handPos;
					px.Vel = Vector(power, 0):RadRotate(self:GetAimAngle(true));
					MovableMan:AddParticle(px);
				end
			end
		else
			if self.target and IsMOSRotating(self.target) then
				self.castCurrentSpell(self.target, not self.controller:IsState(Controller.PIE_MENU_ACTIVE));
				self.firedTimer = Timer();
				self.releaseSound:Play(self.Pos);
			end
			local delay = math.max(self.firedDelay - self.magicPower, 100);
			if self.firedTimer and not self.firedTimer:IsPastSimMS(delay) then
				for i = 1, #arms do
					if arms[i] then
						local prevOffset = Vector(arms[i].IdleOffset.X, arms[i].IdleOffset.Y);
						local offset = Vector(arms[i].MaxLength * 0.6, 0):RadRotate(self.Age * 0.01 - math.pi * i);
						local timerRatio = self.firedTimer.ElapsedSimTimeMS/delay;
						arms[i].IdleOffset = Vector(arms[i].MaxLength * 2, arms[i].IdleOffset.Y * 0.5):RadRotate(aimAngle) * (1 - timerRatio) + self.idleOffset * 0.5 * timerRatio;
					
						if self.target then
							for j = 1, 3 do
								local handPos = arms[i].HandPos + Vector(-1, -1);
								local vel = (arms[i].IdleOffset - prevOffset)/j;
						
								local px = CreateMOPixel("Laser Rifle Glow " .. math.min(math.floor(self.magicPower * self.multiplier * 0.02), 5));
								px.Pos = handPos;
								px.Vel = Vector(vel.X * self.FlipFactor, vel.Y);
								MovableMan:AddParticle(px);
							end
						end
					end
				end
			else
				for i = 1, #arms do
					if arms[i] then
						arms[i].IdleOffset = self.idleOffset;
					end
				end
				self.firedTimer = nil;
			end
			self.chant:Stop();
			self.target = nil;
		end
	else
		self.chant:Stop();
		self.target = nil;
	end
	if self.robe then
		if self.FGLeg and self.BGLeg then
			local halfPI = math.pi * 0.5;
			local ratio = math.sin(self.RotAngle) - (math.cos(self.FGLeg.RotAngle * self.FlipFactor) - math.cos(self.BGLeg.RotAngle * self.FlipFactor));
			self.robe.Frame = math.max(math.floor(math.abs(ratio) * self.robe.FrameCount) + self.Vel.Y * 0.3, 0);
			self.robe.InheritedRotAngleOffset = (ratio) * 0.3 - math.sin(self.RotAngle * self.FlipFactor) * halfPI;
			if self.Status == Actor.STABLE and (self.controller:IsState(Controller.BODY_JUMP) or self.Jetpack:IsEmitting()) then
				local adjustedAimAngle = aimAngle * self.FlipFactor;
				self:SetWalkAngle(AHuman.FGROUND, adjustedAimAngle * 0.5);
				self:SetWalkAngle(AHuman.BGROUND, adjustedAimAngle * 0.5);
				local feet = {self.FGFoot, self.BGFoot};
				--local middle;
				for _, foot in pairs(feet) do
					if foot then
						local px = CreateMOPixel("Laser Rifle Glow " .. math.random(0, 4));
						local footPos = foot.Pos + Vector(-self.FlipFactor, 1);
						px.Pos = footPos;
						px.Vel = self.Vel;
						MovableMan:AddParticle(px);
						
						--middle = middle and middle + SceneMan:ShortestDistance(middle, footPos, SceneMan.SceneWrapsX) * RangeRand(0.2, 0.8) or footPos;
					end
				end
				--if middle then
				--	local px = CreateMOPixel("Laser Rifle Glow End " .. math.random(3));
				--	px.Pos = middle;
				--	px.Vel = self.Vel;
				--	MovableMan:AddParticle(px);
				--end
				local vel = Vector(self.FlipFactor, 0):RadRotate(adjustedAimAngle);
				if self.controller:IsState(Controller.MOVE_LEFT) then
					vel.X = vel.X - 1;
				elseif self.controller:IsState(Controller.MOVE_RIGHT) then
					vel.X = vel.X + 1;
				elseif self.controller:IsState(Controller.BODY_CROUCH) then
					vel = Vector();
				else
					vel.X = 0;
					vel.Y = vel.Y * 2;
				end
				vel = vel * math.sqrt(self:GetLimbPathSpeed(1)) * 0.1;
				self.Vel = self.Vel * 0.95 - self.gravity * self.GlobalAccScalar + vel;
			end
			--if not self.controller:IsState(Controller.PIE_MENU_ACTIVE) then
				self.controller:SetState(Controller.BODY_JUMP, false);
			--end
		else
			self.robe.ToDelete = true;
			self.robe = nil;
		end
	end
	self.lastAimAngle = self:GetAimAngle(true);
	self.prevHFlipped = self.HFlipped;
end