function Create(self)
	self.moveSpeed = 2;
	self.size = 20;
	self.Scale = 0;
	
	self.parts = {};
	
	for i = 1, self.size do
		local part = CreateMOSRotating("Worm Part");
		part.Pos = self.Pos;
		part.Team = self.Team;
		part.IgnoresTeamHits = true;
		part:SetWhichMOToNotHit(self, -1);
		
		MovableMan:AddParticle(part);
		table.insert(self.parts, part);
	end
end


function Update(self)

	local parts = {};	-- temp
	for i = 1, #self.parts do
		if self.parts[i] and IsMOSRotating(self.parts[i]) then
			local part = self.parts[i];
			part.ToSettle = false;
			table.insert(parts, part);
			
			local parent = self;
			if i > 1 then
				parent = self.parts[i - 1];
			end
			
			local dist = SceneMan:ShortestDistance(parent.Pos, part.Pos, SceneMan.SceneWrapsX);
			part.RotAngle = dist.AbsRadAngle;
			if dist.Magnitude > part.Radius then
				part.Pos = parent.Pos + dist:SetMagnitude(part.Radius);
				part.Vel = dist:SetMagnitude(dist.Magnitude - part.Radius);
			end
		else	-- break apart the body from where it was damaged
			self.parts = parts;
			break;
		end
	end

	self.RotAngle = self.Vel.AbsRadAngle;

	local speed = self.moveSpeed / math.sqrt(self.Vel.Magnitude + 1);

	local ctrl = self:GetController();
	if ctrl:IsState(Controller.MOVE_LEFT) then
		self.Vel = self.Vel + Vector(-speed, 0);
	end
	if ctrl:IsState(Controller.MOVE_RIGHT) then
		self.Vel = self.Vel + Vector(speed, 0);
	end
	if ctrl:IsState(Controller.MOVE_UP) then
		self.Vel = self.Vel + Vector(0, -speed);
	end
	if ctrl:IsState(Controller.MOVE_DOWN) then
		self.Vel = self.Vel + Vector(0, speed);
	end
end