dofile("Base.rte/Constants.lua")
require("AI/NativeDropShipAI")

function Create(self)
	self.AI = NativeDropShipAI:Create(self)
	
	self.throttlePower = 1000;
	
	self.beamTimer = Timer();
	self.beamSound = CreateSoundContainer("Beam Sound", "4zK.rte");
	self.beamDistance = math.sqrt(FrameMan.PlayerScreenWidth^2 + FrameMan.PlayerScreenHeight^2) * 0.5;
	self.fireVel = 69;
	self.beamTimer:SetSimTimeLimitMS(50 + self.beamDistance/(self.fireVel * 0.2) * 20);
	
	self.hover = 0;
end

function UpdateAI(self)
	self.AI:Update(self)
end

function OnPieMenu(self)
	ToGameActivity(ActivityMan:GetActivity()):RemovePieMenuSlice("Scuttle!", "");
end

function Update(self)
	if self.beamTimer:IsPastSimTimeLimit() then
		self.beamTimer:Reset();
		if self.HatchState == ACraft.CLOSED then
			local dist = Vector();
			local target = MovableMan:GetClosestEnemyActor(self.Team, self.Pos, 500, dist);
			dist = dist * (-1);
			if target and math.abs(dist.Y) < FrameMan.PlayerScreenHeight * 0.5 + target.Radius and math.abs(dist.X) < FrameMan.PlayerScreenWidth * 0.5 + target.Radius and SceneMan:CastObstacleRay(self.Pos, dist, Vector(), Vector(), self.ID, target.Team, rte.airID, 5) < 0 then
				local shot = CreateMOPixel("Techion Dihelical Cannon Shot Particle", "Techion.rte");
				shot.Vel = Vector(dist.X, dist.Y):SetMagnitude(self.fireVel);
				local checkPos = self.Pos;
				local offset = Vector(dist.X, dist.Y):SetMagnitude(3);
				while true do
					checkPos = checkPos + offset;
					if SceneMan:GetMOIDPixel(checkPos.X, checkPos.Y) ~= self.ID then
						shot.Pos = checkPos + offset + Vector(dist.X, dist.Y):SetMagnitude(self.Vel.Magnitude/self.fireVel * 20) + self.Vel * rte.PxTravelledPerFrame;
						break;
					end
				end
				shot.Team = self.Team;
				shot.IgnoresTeamHits = true;
				MovableMan:AddParticle(shot);
				self.beamSound:Play(checkPos);
				
				self.beamTimer:SetSimTimeLimitMS(50 + dist.Magnitude/(self.fireVel * 0.2) * 20);
			end
		end
	end
	self.controller = self:GetController();
	
	if self.Status == Actor.STABLE then
		self.Vel = self.Vel * 0.96 - SceneMan.Scene.GlobalAcc * GetMPP() * rte.PxTravelledPerFrame;
		local dir = Vector();
		if self.controller:IsState(Controller.MOVE_RIGHT) then
			dir.X = dir.X + 1;
		end
		if self.controller:IsState(Controller.MOVE_LEFT) then
			dir.X = dir.X - 1;
		end
		if self.controller:IsState(Controller.MOVE_DOWN) then
			dir.Y = dir.Y + 1;
		end
		if self.controller:IsState(Controller.MOVE_UP) then
			dir.Y = dir.Y - 1;
		end
		if dir.Magnitude ~= 0 then
			self.Vel = self.Vel + dir:SetMagnitude(1);
			self.AngularVel = self.AngularVel - dir.X * 0.3;
			self:AddForce(dir * self.throttlePower, Vector());
		else
			self.Vel.Y = self.Vel.Y + math.sin(self.hover) * 0.1;
			self.hover = self.hover + 0.1;
		end
		self.AngularVel = self.AngularVel * 0.9 - self.RotAngle;
	end
end