function Create(self)
	self.strength = 6;	-- DO NOT TOUCH! ;)
	
	self.radius = 0;
	self.speed = self.strength * 2;	-- Also "size"
	self.initPos = Vector(self.Pos.X, self.Pos.Y);
	self.activity = ActivityMan:GetActivity();
end

function Update(self)

	PrimitiveMan:DrawCircleFillPrimitive(self.Pos, self.radius, 245);
	
	if not self.erased and self.radius > 60 then
		local eraser = CreateActor("BLACKHOLE Eraser 60");
		eraser.Pos = self.Pos;
		MovableMan:AddParticle(eraser);
		self.erased = true;
	end
	
	self.radius = self.radius + self.speed;
	self.speed = self.speed - 1;
	
	if self.radius < 0 then
		self.ToDelete = true;
	else
		-- Dig some terrain to create terrain-eating feel?
		local size = self.radius;
		local rand = math.random();
		for i = 1, size do
			local part = CreateMOPixel("BLACKHOLE Particle");
			local vec = Vector(self.radius * 2, 0):RadRotate(rand + 6.28 / size * i);
			part.Vel = vec;
			part.Pos = self.Pos + (vec / 3);
			part.Mass = part.Mass * RangeRand(0.1, 1.0);
			MovableMan:AddParticle(part);
		
			local glow = CreateMOPixel("BLACKHOLE Rim Glow");
			glow.Pos = self.Pos + Vector(self.radius, 0):RadRotate(6.28 / size * i);
			MovableMan:AddParticle(glow);
		end
	end

	self.ToSettle = false;
	self.Pos = self.initPos;

	local list = {MovableMan.Actors, MovableMan.Items, MovableMan.Particles};

	for i = 1, 3 do
		for mo in list[i] do
			if not string.find(mo.PresetName, "BLACKHOLE") then	-- Exclude MOs related to this
				local dist = SceneMan:ShortestDistance(self.Pos, (mo.Pos + mo.Vel * 0.3), SceneMan.SceneWrapsX);
				local radius = self.radius;
				if IsMOSRotating(mo) then
					radius = radius / (1 + ToMOSRotating(mo).Radius * 0.01);
				end
				if dist.Magnitude < radius then
					mo.ToDelete = true;
				elseif mo.PinStrength > 0 then
					mo.PinStrength = mo.PinStrength - (self.strength / (1 + dist.Magnitude));	-- This might fuck shit up but it's a black hole after all
					if mo.PinStrength < 0 then
						mo.PinStrength = 0;
					end
				else
					if IsMOSRotating(mo) then
						ToMOSRotating(mo).AngularVel = ToMOSRotating(mo).AngularVel * 1 + (self.radius / (1 + dist.Magnitude + math.abs(mo.Mass)));
					end
					mo.Vel = mo.Vel * (1 - (1 / (1 + dist.Magnitude * 0.1))) - (SceneMan.GlobalAcc / (1 + dist.Magnitude)) - dist:SetMagnitude(self.strength * self.radius / (1 + (dist.Magnitude + math.abs(mo.Mass) * 0.1)));
				end
			end
		end
	end
	-- Do deletion for individual MOIDs as well
	for i = 1 , MovableMan:GetMOIDCount() - 1 do
		local mo = MovableMan:GetMOFromID(i);
		if mo then
			local dist = SceneMan:ShortestDistance(self.Pos, (mo.Pos + mo.Vel * 0.3), SceneMan.SceneWrapsX);
			local radius = self.radius / (1 + mo.Radius * 0.01);
			if dist.Magnitude < radius then
				mo.ToDelete = true;
			elseif radius > 1 then
				-- Also detach Attachables that are close enough
				if IsAttachable(mo) and ToAttachable(mo).JointStrength > 0 then
					mo = ToAttachable(mo);
					if dist.Magnitude < math.random(math.ceil((radius * 5) / (1 + mo.JointStrength * 0.1))) and not (IsHDFirearm(mo) or IsTDExplosive(mo) or IsHeldDevice(mo)) then
						mo:GetParent():RemoveAttachable(mo, true, true);
					end
				end
			end
		end
	end
	local range = FrameMan.PlayerScreenWidth * 0.75;
	local strength = self.radius;
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		if self.activity:PlayerActive(player) and self.activity:PlayerHuman(player) then
			local screen = self.activity:ScreenOfPlayer(player);
			local scrollTarget = SceneMan:GetScrollTarget(screen);
			local dist = SceneMan:ShortestDistance(self.Pos, scrollTarget, SceneMan.SceneWrapsX);
			if dist.Magnitude < range then
				SceneMan:SetScrollTarget(scrollTarget + Vector(strength * (1 - dist.Magnitude/range), 0):RadRotate(math.pi * 2 * math.random()), 0.2, false, screen);
			end
		end
	end
end