
function Create(self)
	self.origMass = self.Mass;	-- same as the bottle
	self.lastVel = 0;

	self.resetTimer = Timer();
	self.thrown = false;

	self.stuck = false;
	self.target = nil;	-- target MO
	self.sAngle = self.rotAngle
	self.tsAngle = 0		-- target sticking angle

	self.sPos = Vector(0,0);
	self.sPosX = 0;
	self.sPosY = 0;

	self.equip = false;

	self.negNum = 1;
	if self.HFlipped == true then
		self.negNum = -1;
	else
		self.negNum = 1;
	end

	self.spinNum = math.random(11,13)*0.1;	-- spin speed is slightly random so that all throws from pos x wont be consistent
end

function Update(self)

	if self.ToDelete == true then	-- failsafe
		self.stuck = false;
		self.target = nil;
	end

	if self.HFlipped == true then
		self.negNum = -1;
	else
		self.negNum = 1;
	end

	if self.ID == self.RootID then

		self.equip = false;

		if self:IsActivated() then	-- thrown

			if self.stuck == true and self.target and self.target.ID ~= 255 then

				self.PinStrength = 1000;
				self.AngularVel = 0;
				self.Vel = Vector(0,0);
				--self.GetsHitByMOs = false;

				--self.HFlipped = self.target.HFlipped;

				self.Pos = self.target.Pos - Vector(self.sPosX,self.sPosY):RadRotate(self.target.RotAngle-self.tsAngle);
				self.RotAngle = self.sAngle+(self.target.RotAngle-self.tsAngle);

				self.resetTimer:Reset();

			else
				self.PinStrength = 0;
				--self.GetsHitByMOs = true;

				self.stuck = false;
				self.target = nil;

				if self.Vel.Magnitude > 5 then	-- gotta be flying

					self.resetTimer:Reset();

					self.AngularVel = -self.Vel.Magnitude*self.spinNum*self.negNum;	-- spinny

					self.Mass = self.origMass + math.sqrt(self.lastVel);
					local velNum = math.sqrt(self.Vel.Magnitude+1);

					local mocheck = SceneMan:CastMORay(self.Pos,Vector(math.floor(self.Radius+velNum)*self.negNum,0):RadRotate(self.RotAngle),self.ID,self.Team,0,true,0);
					if mocheck ~= 255 then
						local mo = MovableMan:GetMOFromID(MovableMan:GetMOFromID(mocheck).ID);
						if mo and mo.Team ~= self.Team and mo.PresetName ~= self.PresetName then

							--SceneMan:ShortestDistance(checkPos,self.Pos,SceneMan.SceneWrapsX):SetMagnitude(3)

							self.target = ToMOSRotating(mo);
							self.stuck = true;

							--self.GetsHitByMOs = false
										-- s for stuck
							self.sAngle = self.RotAngle;	-- own angle when sticking
							self.tsAngle = mo.RotAngle;	-- target angle when sticking	

							self.sPosX = (mo.Pos.X-self.Pos.X)*0.7;	-- for closing the distance a bit
							self.sPosY = (mo.Pos.Y-self.Pos.Y)*0.7;

							self.Pos = mo.Pos - Vector(self.sPosX,self.sPosY);
							--self.rotAngle = self.sAngle+(self.target.RotAngle-self.tsAngle);
					-- damage
							local velBonus = math.floor(math.sqrt(self.Vel.Magnitude)*0.6);
							--print(velBonus);

							for i=1, velBonus do

								part = CreateMOPixel("Particle Knife 1");
								part.Pos = self.Pos-Vector(2,0):RadRotate(self.RotAngle)*self.negNum;

								part.Vel =	(mo.Pos-part.Pos):SetMagnitude(25)
										+Vector(25+velBonus,0):RadRotate(self.RotAngle):SetMagnitude(30)
										*self.negNum;

								part.Sharpness = part.Sharpness+i;	-- random chance to penetrate armor
								part.Team = self.Team;
								part.IgnoresTeamHits = true;

								MovableMan:AddParticle(part);
							end

							--local sfx = CreateAEmitter("Knife Hit");
							--sfx.Pos = self.Pos;
							--MovableMan:AddParticle(sfx);

							--self.PinStrength = 1000;
							--self.Vel = Vector(0,0);
							--self.AngularVel = 0;

							actor = MovableMan:GetMOFromID(mo.RootID);	-- some extra damage
							if IsActor(actor) then
								local damage = 100/(math.abs(actor.Mass)/2+1);	-- avoid zero division
								ToActor(actor).Health = ToActor(actor).Health - damage;
								--print(damage);
								actor.Vel = actor.Vel + self.Vel/(math.abs(actor.Mass)/10+1)
							end

							mo.Vel = mo.Vel + self.Vel/(math.abs(actor.Mass)/10+1);

							self.Mass = self.origMass;
						end
					end
				else
					if self.resetTimer:IsPastSimMS(1000) then	-- return to pickup form after 1 second 

						self:Deactivate();
						self.target = nil;
						self.Team = -2;
					end
				end
			end
		else
			self.resetTimer:Reset();
		end
	else				-- equipped

		if self.equip == false then

			sfx = CreateAEmitter("Knife Draw");	-- schwing!
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx)

			self.equip = true;
		end

		self.stuck = false;
		self.target = nil;

		self.RotAngle = self.RotAngle + 1*self.negNum;

		self.thrown = false;
		self.Mass = self.origMass;
	end

	self.lastVel = self.Vel.Magnitude;

end

function Destroy(self)
	
	self.stuck = false;
	self.target = nil;
end