
function Create(self)
	self.origMass = self.Mass;	-- same as the bottle
	self.lastVel = 0;

	self.resetTimer = Timer();
	self.thrown = false;

	self.stuck = false;
	self.target = nil;	-- target MO
	self.sAngle = self.rotAngle;
	self.tsAngle = 0		-- target sticking angle

	self.sPos = Vector(0,0);
	self.sPosX = 0;
	self.sPosY = 0;

	self.equip = false;

	self.negNum = 1;
	if self.HFlipped == true then
		self.negNum = -1;
	else
		self.negNum = 1;
	end

	self.spinNum = math.random(11, 13) * 0.1;	-- spin speed is slightly random so that all throws from pos x wont be consistent
end

function Update(self)

	if self.ToDelete == true then	-- failsafe
		self.stuck = false;
		self.target = nil;
	end

	self.negNum = 1;
	if self.HFlipped then
		self.negNum = -1;
	end

	if self.ID == self.RootID then

		self.equip = false;

		if self:IsActivated() then	-- thrown

			if self.stuck == true and self.target and self.target.ID ~= 255 then

				self.PinStrength = self.target.Mass;
				self.AngularVel = 0;
				self.Vel = Vector(0, 0);

				self.Pos = self.target.Pos - Vector(self.sPosX, self.sPosY):RadRotate(self.target.RotAngle - self.tsAngle);
				self.rotAngle = self.sAngle + (self.target.RotAngle - self.tsAngle);

				self.resetTimer:Reset();
			else
				self.PinStrength = 0;

				self.stuck = false;
				self.target = nil;

				if self.Vel.Magnitude > 5 then	-- gotta be flying
				
					if self.Vel.Magnitude > 20 then	-- blunt damage
						self.DamageOnCollision = 1;
					else 
						self.DamageOnCollision = 0;
					end
					self.resetTimer:Reset();

					self.AngularVel = -self.Vel.Magnitude * self.spinNum * self.negNum;	-- spinny

					self.Mass = self.origMass + math.sqrt(self.lastVel);
					local velNum = math.sqrt(self.Vel.Magnitude + 1);

					local mocheck = SceneMan:CastMORay(self.Pos,Vector(math.floor(self.Radius+velNum)*self.negNum,0):RadRotate(self.RotAngle),self.ID,self.Team,0,true,0);
					if mocheck ~= 255 then
						local mo = MovableMan:GetMOFromID(MovableMan:GetMOFromID(mocheck).ID);
						if mo and mo.Team ~= self.Team and mo.PresetName ~= self.PresetName then

							self.target = ToMOSRotating(mo);
							self.stuck = true;
							
							self.sAngle = self.RotAngle;	-- own angle when sticking
							self.tsAngle = mo.RotAngle;	-- target angle when sticking	

							self.sPosX = (mo.Pos.X-self.Pos.X) * 0.7;	-- for closing the distance a bit
							self.sPosY = (mo.Pos.Y-self.Pos.Y) * 0.7;

							self.Pos = mo.Pos - Vector(self.sPosX,self.sPosY);
	
							part = CreateMOPixel("Particle Knife 1");
							part.Pos = self.Pos + Vector(-self.Radius * 0.3 * self.negNum, 0):RadRotate(self.RotAngle);

							part.Vel = Vector((20 + self.Vel.Magnitude / 2) * self.negNum, 0):RadRotate(self.RotAngle);

							part.Sharpness = part.Sharpness + math.random();
							part.Team = self.Team;
							part.IgnoresTeamHits = true;

							MovableMan:AddParticle(part);

							--local sfx = CreateAEmitter("Knife Hit");
							--sfx.Pos = self.Pos;
							--MovableMan:AddParticle(sfx);

							actor = MovableMan:GetMOFromID(mo.RootID);	-- some extra damage
							if IsActor(actor) then
								local damage = 100/((mo.Material.StructuralIntegrity + math.abs(actor.Mass))/3);	-- avoid zero division
								ToActor(actor).Health = ToActor(actor).Health - damage;

								actor.Vel = actor.Vel + self.Vel/(math.abs(actor.Mass)/10+1);
							else
								mo.Vel = mo.Vel + self.Vel/(math.abs(mo.Mass)/10+1);
							end

							self.Mass = self.origMass;
						end
					end
				else
					if self.resetTimer:IsPastSimMS(1000) then	-- return to pickup form after 1 second 

						self.target = nil;
						self.Team = -2;

						if infiniteAmmo == true then	-- break if infinite ammo
							self:GibThis();
						else
							self:Deactivate();
							--self.HitsMOs = true;
							--self.GetsHitByMOs = true;
						end
					end
				end
			end
		else
			self.resetTimer:Reset();
		end
	else				-- equipped

		if self.equip == false then

			sfx = CreateAEmitter("Knife Draw");	-- schwing!
			sfx.Pos = self.Pos;
			MovableMan:AddParticle(sfx)

			self.equip = true;
		end

		self.stuck = false;
		self.target = nil;

		self.RotAngle = self.RotAngle + 1*self.negNum;

		self.thrown = false;
		self.Mass = self.origMass;
	end

	self.lastVel = self.Vel.Magnitude;

end

function Destroy(self)
	
	self.stuck = false;
	self.target = nil;
end