function Create(self)
	self.charge = 0;
	
	self.minFireVel = 30;
	self.gainFireVel = 60;
	
	self.chargeDelay = 900;

	self.chargeTimer = Timer();
	self.chargeTimer:SetSimTimeLimitMS(self.chargeDelay);
	
	--self.drawSound = AudioMan:PlaySound("4zK.rte/Devices/BowAndArrow/Sounds/Draw.wav", self.Pos);
end
function Update(self)
	self.Frame = 0;
	local parent = self:GetRootParent();
	if parent and IsAHuman(parent) and ToAHuman(parent).FGArm and ToAHuman(parent).BGArm then
		parent = ToAHuman(parent);
		if self.RoundInMagCount ~= 0 then
			if self:DoneReloading() then
				self:Deactivate();
			end
			local aimAngle = parent:GetAimAngle(false);
			
			--self.charge = self.charge * math.abs(math.cos(aimAngle));
			
			local drawPos = Vector(2 - 7 * self.charge, -1);
			self.Magazine.ParentOffset = drawPos;
			self.JointOffset = Vector(-6, 1) + drawPos;
			
			self.StanceOffset = Vector(parent.BGArm.MaxLength - 5, 0) + self.JointOffset + (parent.BGArm.ParentOffset - parent.FGArm.ParentOffset):RadRotate(-aimAngle);
			self.SharpStanceOffset = Vector(parent.BGArm.MaxLength - 5, 0) + self.JointOffset + (parent.BGArm.ParentOffset - parent.FGArm.ParentOffset):RadRotate(-aimAngle);
			
			if self:IsActivated() and self.Supported ~= false then
				self:Deactivate();
				self.Frame = math.ceil((self.FrameCount - 1) * self.charge);
				if not self.chargeTimer:IsPastSimTimeLimit() then
					self.charge = self.chargeTimer.ElapsedSimTimeMS/self.chargeDelay;
				else
					self.charge = 1;
				end
			else
				if self.charge > 0 then
					--Fire the arrow while manually triggering activation
					self.Magazine.RoundCount = 1;
					self:Activate();
				end
				self.chargeTimer:Reset();
			end
		else
			self.JointOffset = Vector();
			self:Reload();
		end
	else
		if self.Magazine and self.Magazine:IsAttached() then
			self:RemoveAttachable(self.Magazine, true, false);
		end
		self.charge = 0;
		self:Deactivate();
	end
	if self.FiredFrame then
		local arrow = CreateMagazine("4zK.rte/Arrow");
		arrow.Team = self.Team;
		arrow.IgnoresTeamHits = true;
		arrow.Pos = self.MuzzlePos;
		arrow.Vel = self.Vel + Vector((self.minFireVel + self.gainFireVel * self.charge) * self.FlipFactor, 0):RadRotate(self.RotAngle);
		arrow.RotAngle = arrow.Vel.AbsRadAngle;
		MovableMan:AddParticle(arrow);

		self.charge = 0;
		if self.Magazine then self.Magazine.ToDelete = true; end
	end
end