function Create(self)
	self.lastAngle = 0;
	self.bulletTimer = Timer();
	self.power = self:NumberValueExists("Power") and self:GetNumberValue("Power") or 1;
	self.sway = 0;
	self.comboPhase = 0;
	self.comboTimer = Timer();
	self.comboCooldown = 300/self.power;
	self.parryCooldown = self.comboCooldown;
	
	self.hitSound = CreateSoundContainer("Smack", "4zK.rte");
	self.thudSound = CreateSoundContainer("Thud", "4zK.rte");
end
function Update(self)
	local parent = self:GetRootParent();
	if parent and IsAHuman(parent) then
		parent = ToAHuman(parent);
		local controller = parent:GetController();
		local arm = self:GetParent();
		if parent.EquippedItem and parent.EquippedBGItem then
			if parent:NumberValueExists("BoxingGlove") then
				if parent.EquippedBGItem.ID == self.ID then
					self:Deactivate();
				end
			elseif parent.EquippedItem.ID == self.ID then
				self:Deactivate();
			end
		end
		self:ClearImpulseForces();
		arm:ClearImpulseForces();
			
		local punchAngle = (parent:GetAimAngle(false) - self.lastAngle) * (parent:IsPlayerControlled() and 2 or 0.5) * parent.FlipFactor;
		if self:IsActivated() then
			self.Frame = 1;
			self.RotAngle = self.RotAngle + (punchAngle * 2);
			self.StanceOffset = Vector(arm.Diameter * 4 * self.power, 0):RadRotate(punchAngle);
		else
			if self.Frame == 1 then
				if parent:NumberValueExists("BoxingGlove") then
					parent:RemoveNumberValue("BoxingGlove");
				else
					parent:SetNumberValue("BoxingGlove", 1);
				end
				self.Frame = 0;
			end
			self.RotAngle = self.RotAngle + (self.FlipFactor * 0.5) + punchAngle;
			self.StanceOffset = Vector(arm.Radius * 0.5, math.sin(self.sway) * 3);
		end
		local aim = (not controller:IsMouseControlled() and controller:IsState(Controller.AIM_SHARP));-- or controller.MouseMovement.Magnitude > 100;

		if not controller:IsState(Controller.WEAPON_FIRE) then
			self.sway = self.sway + RangeRand(0.01, 0.1) * self.power;
		end

		local down = crouch or controller:IsState(Controller.AIM_DOWN);
		local forward = controller:IsState(Controller.MOVE_RIGHT) or controller:IsState(Controller.MOVE_LEFT);
	
		if parent:NumberValueExists("ComboCooldown") then
			local armVar = (parent.EquippedBGItem and parent.EquippedBGItem.ID == self.ID) and 0.5 or -1;
			local numberValue = parent:GetNumberValue("ComboCooldown");
			--if parent:NumberValueExists("Parry") then
			--	self.StanceOffset = Vector(3 -(armVar) , -(armVar) * 2);
			--	self.RotAngle = self.RotAngle + (self.FlipFactor * 0.5);
				--local parryGlow = CreateMOSParticle("4zK.rte/Parry Glow ".. parent.FlipFactor);
				--parryGlow.Pos = parent.Pos + Vector(parent.Radius * parent.FlipFactor, 0);
				--MovableMan:AddParticle(parryGlow);
			--else
				self.RotAngle = self.RotAngle + (armVar * self.FlipFactor);
				self.StanceOffset = Vector(arm.Radius * 0.5 + arm.Diameter * (numberValue/self.comboCooldown), 0):RadRotate(armVar * 0.3 + 0.1);
			--end
			parent:SetNumberValue("ComboCooldown", numberValue - 1);
			if numberValue <= 0 then
				parent:RemoveNumberValue("ComboCooldown");
			--	parent:RemoveNumberValue("Parry");
			end
			self.comboPhase = 0;
			self:Deactivate();
		else
			if aim then
				--To-do
				local armVar = (parent.EquippedBGItem and parent.EquippedBGItem.ID == self.ID) and 0.5 or -1;
				self.StanceOffset = Vector(3 - (armVar) , -(1 + armVar) * 2);
				self.RotAngle = self.RotAngle + (self.FlipFactor * 0.5);
				--controller:SetState(Controller.AIM_SHARP, false);
				self:Deactivate();
			--	parent:SetNumberValue("ComboCooldown", self.parryCooldown);
			--	parent:SetNumberValue("Parry", 1);
			elseif self.FiredFrame then
				self:RemoveWounds(self.power);
				if self.comboPhase == 3 then
					self.sound = AudioMan:PlaySound("4zK.rte/Devices/Test/wave_attack.png", parent.Pos);
		
					local wave = CreateAEmitter("Combo Flash");
					wave.Pos = self.MuzzlePos;
					wave.Vel = self.Vel * 0.5 + Vector(15 + self.power, 0):RadRotate(parent:GetAimAngle(true));
					wave.RotAngle = wave.Vel.AbsRadAngle + math.pi;
					wave.Team = self.Team;
					wave.Sharpness = self.Team;
					wave.IgnoresTeamHits = true;
					MovableMan:AddParticle(wave);
					
					parent:SetNumberValue("ComboCooldown", self.comboCooldown);
				else
					if controller:IsMouseControlled() then
						punchAngle = controller.MouseMovement.AbsRadAngle * 0.3 * self.FlipFactor;
					elseif parent:IsPlayerControlled() then
						punchAngle = punchAngle * 3;
					elseif math.random() < 0.5 then
						controller:SetState(Controller.WEAPON_FIRE, false);
					end
					parent.AngularVel = parent.AngularVel * 0.5 + punchAngle * 2 + (parent:GetAimAngle(false) - parent.RotAngle * parent.FlipFactor - 1.57) * parent.FlipFactor/(1 + math.abs(parent.RotAngle));
					local startPos = self.Pos + Vector(self.Radius * self.FlipFactor, 0):RadRotate(self.RotAngle - punchAngle) + Vector(0, punchAngle * 10 * self.FlipFactor);
					local punchSize = arm.Radius;
					local punchVector = Vector(punchSize * self.FlipFactor, 0):RadRotate(self.RotAngle + punchAngle);
					for i = 1, math.sqrt(punchSize * self.power) do
						local particle = CreateMOPixel("Boxing Glove Blast");
						particle.Pos = startPos - (punchVector * 0.3) + Vector(self.Radius * 0.5, 0):RadRotate(6.28 * math.random());
						particle.Vel = self.Vel * 0.5 + punchVector;
						particle.Sharpness = math.sqrt(self.power)/i;
						particle.Team = parent.Team;
						particle.IgnoresTeamHits = true;
						MovableMan:AddParticle(particle);
					end
					local crouch = controller:IsState(Controller.BODY_CROUCH);
					local moRay = SceneMan:CastMORay(startPos, (punchVector * 0.3 + self.Vel * 0.5), parent.ID, -1, rte.airID, true, 1);
					if moRay ~= rte.NoMOID then
						local target = MovableMan:GetMOFromID(MovableMan:GetMOFromID(moRay).RootID);
						if target and IsActor(target) then
							target = ToActor(target);
							if (not target:NumberValueExists("Parry") or target.HFlipped == parent.HFlipped) and target.Mass < (parent.Mass * (0.5 + self.power)) then
								target.Status = Actor.UNSTABLE;
								target.Health = target.Health - (punchSize * self.power * math.sqrt(1 + parent.Vel.Magnitude + math.abs(target.AngularVel)))/(1 + target.Material.StructuralIntegrity * 0.01 + target.ImpulseDamageThreshold * 0.001);
								self.hitSound:Play(self.Pos);
								local effectSize = 2 + self.power;
								local randomAngle = math.pi * 2 * math.random();
								for i = 1, effectSize do
									local effect = CreateMOPixel("4zK.rte/Hit Effect");
									effect.Pos = startPos;
									effect.Vel = Vector(10 + effectSize, 0):RadRotate(randomAngle + 6.28 * (i/effectSize));
									effect.Lifetime = effect.Lifetime - math.random(20);
									MovableMan:AddParticle(effect);
								end
							else
								self.thudSound:Play(self.Pos);
							end
							local parentMassSqrt = math.sqrt(math.abs(parent.Mass) + 1);
							local targetMassSqrt = math.sqrt(math.abs(target.Mass) + 1);
							if target:NumberValueExists("Parry") then
								parent:AddForce((punchVector * (-target.Mass)), Vector());
								target:AddForce((punchVector * parent.Mass * self.power), Vector());
								
								target:RemoveNumberValue("Parry");
								target:RemoveNumberValue("ComboCooldown");
							elseif crouch then
								target.Vel = target.Vel/parentMassSqrt - (SceneMan.GlobalAcc * 0.02) * self.power;
								target.AngularVel = target.AngularVel/parentMassSqrt - math.sin(target.RotAngle);
								parent.Vel = parent.Vel/targetMassSqrt - (SceneMan.GlobalAcc * 0.02) * self.power;
								parent.AngularVel = parent.AngularVel/targetMassSqrt - parent.RotAngle;
							else
								target:AddForce((punchVector + parent.Vel * 0.5) * parent.Mass * math.sqrt(math.abs(target.Mass)) * (1 + math.abs(punchAngle) * 2) * self.power, Vector());
								if controller:IsState(Controller.BODY_JUMP) then
									parent.Vel = parent.Vel * 0.5 + (punchVector * (1 + math.abs(punchAngle) * 3) * self.power)/targetMassSqrt;
									if parent.Vel.Y < -(math.abs(parent.Vel.X) + 3) then
										self.sound = AudioMan:PlaySound("4zK.rte/Devices/Test/rising_attack.png", parent.Pos);
									end
								end
							end
						end
					end
					parent.Vel = parent.Vel * 0.99 + punchVector/(20 + (parent.Mass * 0.05 + parent.Vel.Magnitude) * 0.05) * self.power;
				end
				self.comboPhase = 0;
			elseif self.comboPhase == 2 and not down and forward then
				controller:SetState(Controller.AIM_DOWN, false);
				self.comboPhase = 3;
				self.comboTimer:Reset();
			elseif self.comboPhase == 1 and down and forward then
				controller:SetState(Controller.AIM_DOWN, false);
				self.comboPhase = 2;
				self.comboTimer:Reset();
			elseif down and not forward then
				self.comboPhase = 1;
				self.comboTimer:Reset();
			end
			if self.comboTimer:IsPastSimMS(100) then
				self.comboPhase = 0;
			end
		end
		if forward then
			controller:SetState(Controller.BODY_CROUCH, false);
		end
		controller:SetState(Controller.AIM_SHARP, false);
		self.lastAngle = parent:GetAimAngle(false);
		if self.sound and self.sound:IsBeingPlayed() then
			self.sound.Pos = parent.Pos;
		end
	end
end