function Create(self)
	self.pressureLimit = 20;	--Mass * sqrt(Vel) "Newtons" required to trigger the explosive
	self.checkTimer = Timer();
	self.height = ToMOSprite(self):GetSpriteHeight();
	
	self.activationTimer = Timer();
end
function OnCollideWithTerrain(self, terrainID)
	if self:GetParent() then
		if self.activationTimer:IsPastSimMS(1000) then
			self:Deactivate();
		end
		self.activationTimer:Reset();
	elseif self:IsActivated() then
		self.ToSettle = false;
		if self.RotAngle > math.pi then
			self.RotAngle = self.RotAngle - (math.pi * 2);
		elseif self.RotAngle < -math.pi then
			self.RotAngle = self.RotAngle + (math.pi * 2);
		end
		local totalVel = math.abs((self.Vel - self.PrevVel).Magnitude) + math.abs(self.AngularVel);
		if totalVel > 2 then	-- Orient upright when moving
			self.RotAngle = self.RotAngle/(1 + (totalVel * 0.01))
			self.AngularVel = self.AngularVel/(1 + (totalVel * 0.01));
			self.activationTimer:Reset();
		end
		if self.activationTimer:IsPastSimMS(1000) and self.checkTimer:IsPastSimMS(20) then
			self.checkTimer:Reset();
			local checkPos = self.Pos + Vector(0, -(1 + self.height * 0.5)):RadRotate(self.RotAngle);
			local moCheck = SceneMan:GetMOIDPixel(checkPos.X, checkPos.Y);
			if moCheck ~= rte.NoMOID and moCheck ~= self.ID then
				local mo = ToMOSRotating(MovableMan:GetMOFromID(moCheck)):GetRootParent();
				totalVel = math.sqrt(mo.Vel.Magnitude + math.abs(mo.AngularVel));
				if (mo.Mass * totalVel) > self.pressureLimit then
					self.Vel = Vector(0, -10):RadRotate(self.RotAngle);	--Aim explosion slightly upwards
					self:GibThis();
				end
			end
		end
		self.UnPickupable = self.Frame ~= 1;
	end
end