function Create(self)
	self.radius = 1 + math.sqrt(FrameMan.PlayerScreenWidth^2 + FrameMan.PlayerScreenHeight^2);
	self.blastStrength = 1000;
	local smokeCount = 5000;
	local sparcity = 6;
	for i = 1, smokeCount do
		--Fermat spiral
		local smoke = CreateMOSParticle("Thomas Blast " .. math.random(2));
		smoke.Pos = self.Pos;
		smoke.GlobalAccScalar = smoke.GlobalAccScalar * RangeRand(0, 1);

		smoke.Vel = Vector(sparcity * math.sqrt(smokeCount - i), RangeRand(-1, 1)):DegRotate(i * 137.508);
		smoke.Lifetime = math.random(500, 750) + 10 * math.sqrt(i);
		MovableMan:AddParticle(smoke);
	end
	for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
		local screen = ActivityMan:GetActivity():ScreenOfPlayer(player);
		if screen ~= -1 then
			local scrollTarget = SceneMan:GetScrollTarget(screen);
			PrimitiveMan:DrawCircleFillPrimitive(screen, scrollTarget, self.radius, 254);
		end
	end
	local pillarCount = 5;
	local blastVel = 200;
	local additionalBlastVel = 50;
	for i = 1, pillarCount do
		local particleCount = 1000 + i * 100;
		local vel = blastVel + i * additionalBlastVel;
		for j = 1, particleCount do
			local part = CreateMOPixel("Thomas Blast 1");
			part.Sharpness = math.random();
			part.Pos = Vector(self.Pos.X, self.Pos.Y - (pillarCount - i) * 50);
			part.Vel = Vector(vel, 0):RadRotate(math.pi * 2 * j/particleCount);
			MovableMan:AddParticle(part);
		end
	end
	--Terrain damage blast
	local particleCount = 1000;
	for i = 1, particleCount do
		local part = CreateMOPixel("Thomas Blast 1");
		part.HitsMOs = false;
		local outVec = Vector(1, 0):RadRotate(math.pi * 2 * i/particleCount);
		part.Vel = Vector(outVec.X * 480, outVec.Y * 240);
		part.Pos = Vector(self.Pos.X, self.Pos.Y - 1);
		part.Mass = 200;
		part.Sharpness = 10/part.Vel.Magnitude;
		MovableMan:AddParticle(part);
	end
	--AudioMan:ClearMusicQueue();
	--AudioMan:PlayMusic("4zK.rte/Devices/Explosives/Thomas/Thomas.ogg", 2, 1);
	--After Blast
	self.blastTravel = (blastVel + pillarCount * additionalBlastVel) * rte.PxTravelledPerFrame;
	self.blastDist = 0 - self.blastTravel * 3;
	self.blastDistMax = self.radius;
	FrameMan:LoadPalette("4zK.rte/Devices/Explosives/Thomas/palette.bmp");
	self.radTimer = Timer();
	self.radStrength = 1000;
	self.grainCount = 100;
	
	self.MissionCritical = true;
	
	local shaker = CreateMOPixel("Camera Shaker", "4zK.rte");
	shaker.Pos = self.Pos;
	shaker.PinStrength = self.blastStrength * 0.5;
	MovableMan:AddParticle(shaker);
end
function Update(self)
	if self.blastDist < self.blastDistMax then
		self.coll = {MovableMan.Actors, MovableMan.Items, MovableMan.Particles};
		self.blastDist = self.blastDist + self.blastTravel;
		local lastDist = self.blastDist - self.blastTravel;
		if self.blastDist > 0 then
			for _, coll in pairs(self.coll) do
				for mo in coll do
					if mo and mo.PinStrength == 0 and mo.PresetName ~= "Thomas Blast 1" and mo.PresetName ~= "Thomas Blast 2" then
						local dist = SceneMan:ShortestDistance(self.Pos, mo.Pos, SceneMan.SceneWrapsX);
						if dist.Magnitude < self.blastDist and dist.Magnitude > lastDist then
							local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + dist, math.random(8, 12), rte.airID);
							if strSumCheck < self.blastStrength then
								local massFactor = math.sqrt(1 + math.abs(mo.Mass) * 0.01);
								local distFactor = math.sqrt(1 + dist.Magnitude * 0.01);
								local forceVector =	dist:SetMagnitude((self.blastStrength - strSumCheck)/distFactor);
								mo.Vel = mo.Vel + forceVector/massFactor;
								mo:AddForce(forceVector * massFactor, Vector());
							end
						end
					end
				end
			end
			self.blastStrength = self.blastStrength * 0.1 - 1;
		end
	else
		--Radioactivity
		for i = 1, self.grainCount do
			local randPos = self.Pos + Vector(math.random(self.radius), 0):RadRotate(math.pi * 2 * math.random());
			PrimitiveMan:DrawLinePrimitive(randPos, randPos, math.random(255));
		end
		if self.radTimer:IsPastSimMS(250) then
			self.radTimer:Reset();
			for actor in MovableMan.Actors do
				if actor.ClassName == "AHuman" or actor.ClassName == "ACrab" then
					local dist = SceneMan:ShortestDistance(self.Pos, actor.Pos, SceneMan.SceneWrapsX);
					if dist.Magnitude < 1000 then
						local strSumCheck = SceneMan:CastStrengthSumRay(self.Pos, self.Pos + dist, 12, rte.airID);
						if strSumCheck < self.radStrength then
							local massAndDistFactor = 1/(1 + (math.abs(actor.Mass) + dist.Magnitude) * 0.01);
							local strength = self.radStrength/(1 + strSumCheck) * massAndDistFactor;
							if math.random(self.radStrength) < strength then
								actor.Health = actor.Health - 1;
							end
						end
					end
				end
			end
		end
	end
end
function Destroy(self)
	FrameMan:LoadPalette("Base.rte/palette.bmp");
end