function Create(self)
	self.belts = {};
	self.beltsVel = {};
 	self.beltsPos = {};
	self.beltOffset = Vector(0, -13);
	self.beltsCount = 17;
	for i = 1, self.beltsCount do
		self.belts[i] = CreateAttachable(self.PresetName .. " Part");
		self.belts[i].Frame = (i - 1) % self.belts[i].FrameCount;
		self.beltsVel[i] = Vector();
		self.beltsPos[i] = Vector(self.Pos.X, self.Pos.Y);
		self:AddAttachable(self.belts[i], self.beltOffset);
	end
	Wind = Wind or 10;
	self.lastAngle = self.RotAngle;
end
function Update(self)	
	local parentPos = self.Pos + Vector(self.beltOffset.X, self.beltOffset.Y):RadRotate(self.RotAngle);
	for i, belt in ipairs(self.belts) do
		belt.Pos = parentPos;
		--Gravity
		local vel = Vector(self.beltsVel[i].X, self.beltsVel[i].Y):RadRotate(self.lastAngle - self.RotAngle) + SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs * 0.45;
		local pos = Vector(self.beltsPos[i].X, self.beltsPos[i].Y);
		
		local windFactorA = math.sin((i * 150 + self.Age)/1000 * math.pi);
		
		vel = Vector(vel.X + RangeRand(-0.1, 0.2) * Wind * TimerMan.DeltaTimeSecs * 100, vel.Y + math.abs(vel.X) * RangeRand(-1.0, 1.0) * TimerMan.DeltaTimeSecs * 40);

		local dist = SceneMan:ShortestDistance(pos, parentPos, SceneMan.SceneWrapsX);
		vel = vel + dist * math.min(math.max((dist.Magnitude), 0), 4) * TimerMan.DeltaTimeSecs;
		
		--Pull the last segment
		local add = Vector(RangeRand(-0.1, 0.2) * Wind * TimerMan.DeltaTimeSecs * 7 * math.max(12 - math.abs(vel.Magnitude), 0) * (1 + windFactorA), 40 * windFactorA * TimerMan.DeltaTimeSecs * RangeRand(0.5, 1.0));
		vel = vel + add * RangeRand(-0.1, 1.0) * 0.7;
		
		--Air friction
		vel = vel/(1 + TimerMan.DeltaTimeSecs * 6);
		pos = pos + vel * rte.PxTravelledPerFrame;
		
		--Limit position
		local newPos = SceneMan:ShortestDistance(parentPos, pos, SceneMan.SceneWrapsX);
		newPos = parentPos + newPos:SetMagnitude(math.min(newPos.Magnitude, 2));
		pos = Vector(newPos.X, newPos.Y);
		
		local dif = SceneMan:ShortestDistance(parentPos, pos, SceneMan.SceneWrapsX);
		
		self.beltsVel[i] = vel;
		self.beltsPos[i] = pos;

		parentPos = belt.Pos + Vector(0, -1):RadRotate(dif.AbsRadAngle - math.pi * 0.5);
	end
	self.lastAngle = self.RotAngle;
end
function OnDetach(self)
	self:GibThis();
end