function Create(self)

	self.ToSettle = false;
	self.Status = 1;
	
	self.strength = 300;

	self.initPosX = self.Pos.X;
	self.initPosY = self.Pos.Y;

	local range = self.Radius;
	local maxrange = self.Radius * 0.3;

	local coll = {MovableMan.Actors, MovableMan.Items, MovableMan.Particles};
	for i = 1, #coll do
		for mo in coll[i] do
		
			local dist = SceneMan:ShortestDistance(self.Pos, mo.Pos, SceneMan.SceneWrapsX);

			if mo and dist.Magnitude < range then
			
				local forceVector =	dist:SetMagnitude(self.strength/math.sqrt(dist.Magnitude + 1));

				if dist.Magnitude < maxrange then
					forceVector = dist:SetMagnitude(self.strength/math.sqrt(maxrange + 1));
				end

				local massNum = math.sqrt(math.abs(mo.Mass) * 0.1 + 1);	--10 %
				local velNum = math.sqrt(mo.Vel.Magnitude * 0.3 + 1);	--30 %

				mo.Vel = mo.Vel + forceVector * 3/(massNum + velNum);

				if IsMOSRotating(mo) then
					mo = ToMOSRotating(mo);
					mo.AngularVel = mo.AngularVel - mo.Vel.X/massNum;
					
					if IsActor(mo) then
						mo = ToActor(mo);
						local damage = -(forceVector.Magnitude * self.strength * mo.DamageMultiplier)/(mo.Mass + mo.Material.StructuralIntegrity);
						mo.Health = mo.Health + damage;
					end
				end
			end	
		end
	end
	for i = 1, self.Radius do
		local smoke = CreateMOSParticle("Holy Hand Grenade Smoke 1");
		local vec = Vector(self.Radius * 0.6 * math.random(), 0):RadRotate(math.pi * 2 * math.random());
		smoke.Pos = self.Pos - (self.Vel * 0.6) + vec;
		smoke.Vel = vec;
		smoke.Lifetime = math.random(smoke.Lifetime, smoke.Lifetime * 1.5);
		MovableMan:AddParticle(smoke);
	end
	AudioMan:PlaySound("4zK.rte/Devices/Holies/Hallelujah.wav", self.Pos);
	local glow = CreateMOPixel("Holy Hand Grenade Glow");
	glow.Pos = self.Pos;
	MovableMan:AddParticle(glow);
	
	self.ToDelete = true;
end