function Create(self)

	self.range = (FrameMan.PlayerScreenWidth + FrameMan.PlayerScreenHeight) * 0.5;

	self.ejectedShell = 0;

	self.rotNum = 0;
	self.prevAngle = 0;
	
	self.shake = 0;
	
	self.ricochetSound = CreateSoundContainer("Ricochet", "Base.rte");
	self.fireSound = CreateSoundContainer("Holy Revolver Fire", "4zK.rte");
end

function Update(self)

	if self.FiredFrame then
	
		self.rotNum = self.rotNum + RangeRand(0.3, 0.4);
	
		local parent = self:GetRootParent();
		if IsActor(parent) then
			parent = ToActor(parent);
			self.shake = self.shake + math.sqrt(parent.Vel.Magnitude) * 0.1;
			
			if parent:GetController():IsState(Controller.AIM_SHARP) then
				self.shake = self.shake * 0.5;
			end
		end
		parent.Vel = parent.Vel + Vector(-30/math.sqrt(math.abs(parent.Mass) + 1) * self.FlipFactor, 0):RadRotate(self.RotAngle);
		
		local hitPos = Vector();
		local trace = Vector(self.range * self.FlipFactor, 0):RadRotate(self.RotAngle + RangeRand(-self.shake, self.shake));
		
		local ray = SceneMan:CastObstacleRay(self.MuzzlePos, trace, hitPos, Vector(), parent.ID, -2, rte.airID, 2);
		if ray >= 0 then
		
			local glow = CreateMOPixel("Glow Yellow Big");
			glow.Pos = hitPos;
			MovableMan:AddParticle(glow);

			local id = SceneMan:GetMOIDPixel(hitPos.X, hitPos.Y);
			if id ~= rte.NoMOID and id ~= parent.ID then
				local mo = MovableMan:GetMOFromID(id);
				mo.Vel = Vector(90/math.sqrt(math.abs(mo.Mass) + 1) * self.FlipFactor, 0):RadRotate(self.RotAngle);
				ToMOSRotating(mo):GibThis();
			else
				local dots = 30;
				for i = 1, dots do
					local px = CreateMOPixel("Holy Revolver Erase Particle");
					px.Pos = hitPos;
					px.Mass = math.random(1, 10);
					px.Vel = Vector(dots * 0.3, 0):RadRotate(math.pi * 2 * i/dots);
					MovableMan:AddParticle(px);
				end
				self.ricochetSound:Play(hitPos);
			end
		end
		--Induce inaccuracy
		self.shake = self.shake + (0.1/(self.shake + 1));

		local glow = CreateMOPixel("Glow Yellow Huge");
		glow.Pos = self.MuzzlePos;
		MovableMan:AddParticle(glow);

		for i = 1, 3 do
			local part = CreateMOSParticle("Tiny Smoke Ball 1");
			part.Vel = self.Vel + trace:SetMagnitude(math.random(2, 20));
			part.Pos = self.MuzzlePos + Vector(-1, 0):RadRotate(self.RotAngle);
			MovableMan:AddParticle(part);
		end
		for i = 1, 2 do
			local part = CreateMOSParticle("Side Thruster Blast Ball 1 Glow");
			part.Vel = self.Vel + trace:SetMagnitude(math.random(1, 10));
			part.Pos = self.MuzzlePos + Vector(-1, 0):RadRotate(self.RotAngle);
			MovableMan:AddParticle(part);
		end

		self.fireSound:Play(self.MuzzlePos);
	end
	
	--Revert accuracy
	if self.shake > 0 then
		self.shake = math.max(self.shake * 0.99 - 0.01, 0);
	else
		self.shake = 0;
	end

	if self.Magazine then
		self.ejectedShell = self.Magazine.Capacity - self.Magazine.RoundCount;

	elseif self.ejectedShell > 0 then
		for i = 1, self.ejectedShell do
			local shell = CreateMOSParticle("Holy Casing", "4zK.rte");
			shell.Pos = self.Pos;
			shell.Vel = Vector(RangeRand(-8, -6) * self.FlipFactor, 0):RadRotate(self.RotAngle):DegRotate(math.random(-20, 20));
			MovableMan:AddParticle(shell);
		end
		self.ejectedShell = 0;
	end
	if self:IsReloading() then
		self.JointOffset = Vector(2, 2);
		self.RotAngle = self.prevAngle + self.FlipFactor * 0.42;
	else
		self.JointOffset = Vector(-2, 3);
		self.RotAngle = self.RotAngle + self.rotNum * self.FlipFactor;
		--local vector = Vector(-2 * self.FlipFactor, 3);
		--self.Pos = self.Pos + vector - vector:RadRotate(self.rotNum * self.FlipFactor);
	end
	
	if self.rotNum > 0 then
		self.rotNum = math.max(self.rotNum -0.0001 * self.RateOfFire, 0);
	end
	self.prevAngle = self.RotAngle;
end