function Create(self)
	self.range = (FrameMan.PlayerScreenWidth + FrameMan.PlayerScreenHeight) * 0.5;
	self.power = 750;
	self.size = math.max(self:GetNumberValue("LaserSize"), 1);
end

function Update(self)

	--if self.Magazine and self.Magazine.RoundCount == 0 then
	--	self:Deactivate();
	--end
	if self:DoneReloading() then
		self.size = math.max(self:GetNumberValue("LaserSize"), 1);
	end
	if self.FiredFrame then
	
		local parent = self:GetRootParent();
	
		for i = 1, self.size do
			local muzzlePos = self.MuzzlePos + Vector(0, self.size * 0.5 - i):RadRotate(self.RotAngle);
			local hitPos = Vector(muzzlePos.X, muzzlePos.Y);
			local openPos = Vector(muzzlePos.X, muzzlePos.Y);
			local trace = Vector(self.range * self.FlipFactor, 0):RadRotate(self.RotAngle);
			--First, a rough estimate ray
			local skip = 4;
			local ray = SceneMan:CastObstacleRay(muzzlePos, trace, hitPos, openPos, parent.ID, -2, rte.airID, skip);
			
			if ray >= 0 then
				--A more precise ray
				skip = 1;
				ray = SceneMan:CastObstacleRay(openPos, trace:SetMagnitude(skip * 2), hitPos, openPos, parent.ID, -2, rte.airID, skip);
				trace = SceneMan:ShortestDistance(muzzlePos, openPos, SceneMan.SceneWrapsX);
			
				local glow = CreateMOPixel("Glow Red Small", "4zK.rte");
				glow.Pos = hitPos;
				MovableMan:AddParticle(glow);
				
				local vel = Vector();
				
				local id = SceneMan:GetMOIDPixel(hitPos.X, hitPos.Y);
				if id ~= rte.NoMOID and id ~= parent.ID then
					vel = MovableMan:GetMOFromID(id).Vel * 0.5;
				end
				
				local parPos = hitPos - Vector(trace.X, trace.Y):SetMagnitude(skip * 2) + vel;
				
				local smoke = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte");
				smoke.Pos = parPos;
				smoke.Lifetime = math.random(100, 200);
				smoke.Vel = Vector(-trace.X, -trace.Y):SetMagnitude(math.random(10)):RadRotate(RangeRand(-1, 1)) + vel;
				MovableMan:AddParticle(smoke);
				
				local px = CreateMOPixel("Laser Gun Damage", "4zK.rte");
				px.Pos = parPos;
				px.Vel = Vector(trace.X, trace.Y):SetMagnitude(10) + vel;
				px.Sharpness = math.random(self.power * 0.5, self.power);
				MovableMan:AddParticle(px);
			end

			for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
				local team = ActivityMan:GetActivity():GetTeamOfPlayer(player);
				local traceEnd = muzzlePos + trace;
				if not SceneMan:IsUnseen(muzzlePos.X, muzzlePos.Y, team) or not SceneMan:IsUnseen(traceEnd.X, traceEnd.Y, team) then
					--DrawThiccLine(muzzlePos, traceEnd, 2.5, 13, 1);
					PrimitiveMan:DrawLinePrimitive(muzzlePos, traceEnd, 13);
				end
			end
		
			local glow = CreateMOPixel("Glow Red Small", "4zK.rte");
			glow.Pos = muzzlePos + self.Vel * rte.PxTravelledPerFrame;
			MovableMan:AddParticle(glow);
		end
	end
end