--Chromatic
function Create(self)
	self.length = self:GetSpriteWidth();
	self.realParentOffset = Vector(8, 9);
	self.fireTimer = Timer();
	self.sustainMS = 6000;
	self.vibratoDepth = 0.03;
	self.vibratoRate = 0.03;
	self.semiToneFactor = 1.0594636;
	self.scales = {};
	self.scales.major = {1, 1, 0.5, 1, 1, 1, 0.5};
	self.scales.minor = {1, 0.5, 1, 1, 0.5, 1, 1};
end
function Update(self)
	local parent = self:GetRootParent();
	if IsAHuman(parent) then
		parent = ToAHuman(parent);
		if parent.Head and parent.FGArm and parent.Status == Actor.STABLE then
			local aimAngle = parent:GetAimAngle(false);
			local sinAngle = math.sin(aimAngle);
			self.SharpStanceOffset = ((parent.Head.ParentOffset - parent.Head.JointOffset) + (self.realParentOffset - self.JointOffset)):RadRotate(parent.Head.RotAngle * parent.FlipFactor - aimAngle) - parent.FGArm.ParentOffset;
			self.StanceOffset = self.SharpStanceOffset;
			local controller = parent:GetController();
			if controller:IsState(Controller.WEAPON_FIRE) then
				controller:SetState(Controller.AIM_SHARP, true);
			end
			--for i = 1, self.scales[self.chosenScale] do
			local count = math.floor(1.5 + sinAngle * 12);
			self.FireSound.Pitch = self.semiToneFactor^count;
			if self:IsActivated() then
				local ratio = math.max(math.min(self.fireTimer.ElapsedSimTimeMS/(self.sustainMS * (1 - math.abs(sinAngle) * 0.5)), 1), 0);
				self.FireSound.Volume = self.sustainMS > 0 and 1 - ratio^2 or 1;
				self.FireSound.Pitch = self.FireSound.Pitch + math.sin(self.Age * self.vibratoRate) * ratio * self.vibratoDepth;
			else
				self.fireTimer:Reset();
			end
		else
			self:Deactivate();
		end
	end
end