function Create(self)
	self.realROF = self.RateOfFire;
	self.range = self.SharpLength + math.min(FrameMan.PlayerScreenWidth, FrameMan.PlayerScreenHeight) * 0.5;
	self.areaOfEffectRadius = 70;
	self.rotNum = 0;
	self.aimNum = 0;
	self.stance = Vector(9, 6);
	self.angle = math.pi/3;
	self.levels = {13, 35, 59, 75};
	--self.levels = {smoke = {50, 64, 74, 86}, shadow = {52, 64, 76, 88}, blood = {56, 68, 80, 92}, ice = {58, 70, 82, 94}};
	self.levelSound = {CreateSoundContainer("Magic Level 1"), CreateSoundContainer("Magic Level 1"), CreateSoundContainer("Magic Level 2"), CreateSoundContainer("Magic Level 2")};
	self.startSound = {CreateSoundContainer("Fire Spell Start 1"), CreateSoundContainer("Fire Spell Start 2"), CreateSoundContainer("Fire Spell Start 3"), CreateSoundContainer("Fire Spell Start 4")};
	self.endSound = {CreateSoundContainer("Fire Spell End 1"), CreateSoundContainer("Fire Spell End 2"), CreateSoundContainer("Fire Spell End 3"), CreateSoundContainer("Fire Spell End 4")};
	self.count = 0;
	self.spread = self.ParticleSpreadRange;
	self.fire = CreateMOSParticle("Fireball Particle", "4zK.rte");
	self.appearSound = CreateSoundContainer("RS Appear");
end
function Update(self)
	local parent = self:GetRootParent();
	local aimAngle = self.RotAngle;
	local fire = false;
	local muzzlePos = self.MuzzlePos;
	local magicLevel = 1;
	local magicPower = 1;
	if self.Magazine then
		self.Magazine.Scale = 0;
	end
	if IsActor(parent) then
		parent = ToActor(parent);
		aimAngle = parent:GetAimAngle(false) * self.FlipFactor;
		muzzlePos = parent.EyePos + Vector(parent.IndividualRadius * parent.FlipFactor, 0):RadRotate(aimAngle);
		local controller = parent:GetController()
		if self.rotNum > 0 or controller:IsState(Controller.WEAPON_FIRE) then
			local twoPI = math.pi * 2;
			if self.rotNum >= twoPI then
				self.rotNum = 0;
			else
				if self.rotNum == 0 then
					self.count = EnforceLevelRequirement and 0 or 1;
					magicLevel = math.min(math.max(parent:GetNumberValue("MagicLevel"), 1), 99);
					local newLevel = math.min(magicLevel + 1/magicLevel, 99);
					magicPower = 1 + magicLevel * 0.02;
					local sound = self.startSound[1];
					for l = 1, #self.levels do
						if magicLevel >= self.levels[l] then
							sound = self.startSound[l];
							self.count = l;
						else
							if (EnforceLevelRequirement or l ~= 1) and newLevel >= self.levels[l] and controller.Player ~= -1 then
								self.levelSound[l]:Play(controller.Player);
								parent:FlashWhite(100);
							end
							break;
						end
					end
					sound.Pitch = self.RateOfFire/self.realROF;
					sound:Play(self.Pos);
					parent:SetNumberValue("MagicLevel", newLevel);
				else
					local ratio = 0;
					if self.rotNum >= math.pi then
						ratio = 1 - (self.rotNum - math.pi) * 4/math.pi;
						fire = true;
					else
						ratio = self.rotNum/math.pi;
						if self.Magazine then
							self.Magazine.Frame = math.max(self.count - 1, 0);
							self.Magazine.Scale = math.min(self.count, 1);
							if IsAHuman(parent) and ToAHuman(parent).BGArm then
								self.Magazine.Pos =	ToAHuman(parent).BGArm.HandPos;
							end
							self.Magazine.Pos = self.Magazine.Pos + SceneMan:ShortestDistance(self.Magazine.Pos, muzzlePos, SceneMan.SceneWrapsX) * ratio;
						end
					end
					for i = 1, self.count do
						PrimitiveMan:DrawBitmapPrimitive(muzzlePos + Vector((1 + self.spread) * ratio * math.sqrt(self.count - i), 0):DegRotate(i * 137.508 - self.Age), self.fire, 0, math.floor(self.fire.FrameCount - self.fire.FrameCount * ratio), math.random() < 0.5, math.random() > 0.5);
					end
				end
				self.rotNum = math.min(self.rotNum + self.RateOfFire * 0.0017, twoPI);
			end
		elseif parent:GetController():IsState(Controller.AIM_SHARP) then
			self.aimNum = self.aimNum + 0.1;
		end
	else
		self.rotNum = 0;
	end
	if fire then
		self:Activate();
	else
		self:Deactivate();
	end
	self.aimNum = math.max(self.aimNum * 0.92 - 0.01, 0);
	local stance = Vector(self.stance.X, self.stance.Y):RadRotate(math.sin(self.rotNum) * self.angle + self.aimNum * 0.3) * (1 + math.sin(self.rotNum * 0.5) * 1.5 + self.aimNum);
	self.StanceOffset = stance;
	self.SharpStanceOffset = stance;
	self.InheritedRotAngleOffset = math.sin(self.rotNum - 0.1) * self.angle * 1.5 + self.angle * 0.5 - self.aimNum;
	if self.targetPos then
		for part in MovableMan.Particles do
			if part.Age < TimerMan.DeltaTimeMS and (string.find(part.PresetName, "Blood") or string.find(part.Material.PresetName, "Blood")) and SceneMan:ShortestDistance(self.targetPos, part.Pos, SceneMan.SceneWrapsX).Magnitude < self.targetRadius then
				--part.GlobalAccScalar = math.random(-3, -2);
				--part.AirResistance = RangeRand(0.6, 0.9);
				--part.AirThreshold = math.random();
				--part.Lifetime = part.Lifetime == 0 and math.random(4000, 6000) or part.Lifetime * 1.5;
				part.AirResistance = 0;
				local dist = SceneMan:ShortestDistance(part.Pos, parent.Pos + Vector(math.random(-5, 5), math.random(-10, 0)), SceneMan.SceneWrapsX);
				part.Vel = (dist * 0.5 + parent.Vel) * 0.25 - SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs * math.sqrt(dist.Magnitude);
				part.Lifetime = math.random(200, 400);
			end
		end
		self.targetPos = nil;
		self.targetRadius = nil;
	end
	if self.FiredFrame then
		local checkPos = Vector(muzzlePos.X, muzzlePos.Y);
		local trace = Vector(self.range * self.FlipFactor, 0):RadRotate(aimAngle);
		local rayLength = SceneMan:CastObstacleRay(muzzlePos, trace, checkPos, Vector(), parent.ID, parent.Team, rte.airID, 5);
		local checkPos = checkPos - trace:SetMagnitude(self.areaOfEffectRadius);
		local ice = true;
		local targets = {};
		for actor in MovableMan.Actors do
			if self.count > 0 then 
				if actor.Team ~= self.Team and SceneMan:ShortestDistance(checkPos, actor.Pos, SceneMan.SceneWrapsX).Magnitude < self.areaOfEffectRadius + actor.IndividualRadius then
					table.insert(targets, actor);
					self.count = self.count - 1;
				end
			else
				break;
			end
		end
		if #targets > 0 then
			for _, target in pairs(targets) do
				if smoke then
				elseif shadow then
				
				elseif blood then
					local woundCount = 5;
					local parts = {target};
					for att in target.Attachables do
						if att.GetsHitByMOs then
							table.insert(parts, att);
						end
					end
					while woundCount > 0 do
						local part = parts[math.random(#parts)];
						local woundName = part:GetEntryWoundPresetName();
					
						local wound = CreateAEmitter(woundName);
						local isFlesh = string.find(woundName, "Flesh") or string.find(part.Material.PresetName, "Flesh");
						if wound.BurstSound then
							wound.BurstSound.Volume = 0.2;
						end
						if isFlesh then
							wound.EmitCountLimit = math.ceil(math.sqrt(wound.EmitCountLimit));
							for em in wound.Emissions do
								em.BurstSize = em.BurstSize + wound.EmitCountLimit;
								em.ParticlesPerMinute = 1;
							end
							wound.BurstDamage = wound.BurstDamage + wound.EmitCountLimit * wound.EmitDamage;
							wound.BurstScale = 1;
							wound:TriggerBurst();
						end
						local offset = Vector(RangeRand(0, 0.4), 0):RadRotate(RangeRand(-math.pi, math.pi));
						wound.EmitAngle = offset.AbsRadAngle;
						part:AddWound(wound, Vector(offset.X * part:GetSpriteWidth(), offset.Y * part:GetSpriteHeight()), math.random() < 0.1);
						if isFlesh then
							local glow = CreateMOPixel("Blood Glow", "4zK.rte");
							glow.Pos = wound.Pos;
							--glow.Vel = part.Vel;
							glow.GlobalAccScalar = -5;
							MovableMan:AddMO(glow);
							
							parent.Health = math.min(parent.Health + wound.BurstDamage * 0.25, parent.MaxHealth);
							self.targetPos = target.Pos;
							self.targetRadius = target.Radius * 1.5;
						end
						woundCount = woundCount - 1;
					end
				elseif ice then
					local block = CreateMOSRotating("Ice Block");
					block.Pos = target.Pos - Vector(0, (target.IndividualRadius + target.Radius) * 0.5);
					block.Vel = Vector(0, 5);
					MovableMan:AddMO(block);
					
					local glow = CreateMOPixel("Ice Block Glow");
					glow.Pos = block.Pos;
					glow.Vel = block.Vel;
					MovableMan:AddMO(glow);
					
					target.PinStrength = 1000/math.sqrt(1 + math.abs(target.Mass));
					target:FlashWhite(100);
				end
			end
		end
		self.count = 0;
	end
end