function Create(self)
	if self.ClassName == "HeldDevice" then
		self:Deactivate();

		self.StanceOffset = Vector(6, 6);
		self.SharpStanceOffset = Vector(6, 6);

		local template = CreateHeldDevice(self:GetModuleAndPresetName());
		self.realParentOffset = Vector(template.ParentOffset.X, template.ParentOffset.Y);
		DeleteEntity(template);
		
		self.activateTime = 200;
		--The following timer prevents a glitch where you can equip two items at once
		self.inventorySwapTimer = Timer();
		self.inventorySwapTimer:SetSimTimeLimitMS(math.ceil(TimerMan.DeltaTimeMS));
	end
end
function Update(self)
	if self.ClassName == "HeldDevice" then
		local parent = self:GetRootParent();
		if not self.inventorySwapTimer:IsPastSimTimeLimit() and IsAHuman(parent) then
			parent = ToAHuman(parent);
			self.HFlipped = parent.HFlipped;
			if parent.FGLeg or parent.BGLeg then
				if self.activateTimer then
					self.StanceOffset = (Vector(0, 10) + (self.realParentOffset - self.JointOffset)):RadRotate(parent.RotAngle * parent.FlipFactor - parent:GetAimAngle(false)) - ToAttachable(self:GetParent()).ParentOffset;
					self.SharpStanceOffset = self.StanceOffset;
					if self.activateTimer:IsPastSimMS(self.activateTime) then
						if parent.FGLeg then
							local foot = CreateAttachable("Lightness Boot FG");
							--if parent.FGFoot then
							--	foot.JointOffset = parent.FGFoot.JointOffset;
							--end
							parent.FGFoot = foot;
						end
						if parent.BGLeg then
							local foot = CreateAttachable("Lightness Boot BG");
							--if parent.BGFoot then
							--	foot.JointOffset = parent.BGFoot.JointOffset;
							--end
							parent.BGFoot = foot;
						end
						self.ToDelete = true;
						if not parent.EquippedItem then
							parent:GetController():SetState(Controller.WEAPON_CHANGE_NEXT, true);
						end
					else
						local timerRatio = self.activateTimer.ElapsedSimTimeMS/self.activateTime;
						self.RotAngle = self.RotAngle * (1 - timerRatio) + parent.RotAngle * timerRatio;
					end
				elseif self:IsActivated() then
					self.activateTimer = Timer();
				end
			end
		else
			self:Deactivate();
			self.activateTimer = nil;
		end
		self.inventorySwapTimer:Reset();
	else
		local parent = self:GetParent();
		if parent then
			if self.part then
				self.part.InheritedRotAngleOffset = parent.RotAngle * self.FlipFactor;
			else
				local name = self.PresetName .. " Part";
				for att in self.Attachables do
					if att.PresetName == name then
						self.part = att;
						break;
					end
				end
				if self.part == nil then
					self.part = CreateAttachable(name);
					self:AddAttachable(self.part);
				end
			end
		end
	end
end