EnforceLevelRequirement = false;
function Create(self)
	self.realROF = self.RateOfFire;
	self.rotNum = 0;
	self.aimNum = 0;
	self.stance = Vector(9, 6);
	self.angle = math.pi/3;
	self.levels = {13, 35, 59, 75};
	self.levelSound = {CreateSoundContainer("Magic Level 1"), CreateSoundContainer("Magic Level 1"), CreateSoundContainer("Magic Level 2"), CreateSoundContainer("Magic Level 2")};
	self.startSound = {CreateSoundContainer("Fire Spell Start 1"), CreateSoundContainer("Fire Spell Start 2"), CreateSoundContainer("Fire Spell Start 3"), CreateSoundContainer("Fire Spell Start 4")};
	self.endSound = {CreateSoundContainer("Fire Spell End 1"), CreateSoundContainer("Fire Spell End 2"), CreateSoundContainer("Fire Spell End 3"), CreateSoundContainer("Fire Spell End 4")};
	self.count = 0;
	self.spread = self.ParticleSpreadRange;
	self.fire = CreateMOSParticle("Fireball Particle", "4zK.rte");
	self.appearSound = CreateSoundContainer("RS Appear");
	self.splashSound = CreateSoundContainer("RS Splash");
end
function Update(self)
	self.startSound.Pos = self.Pos;
	self.endSound.Pos = self.Pos;
	local parent = self:GetRootParent();
	local aimAngle = self.RotAngle;
	local fire = false;
	local muzzlePos = self.MuzzlePos;
	local magicLevel = 1;
	local magicPower = 1;
	if self.Magazine then
		self.Magazine.Scale = 0;
	end
	if IsAHuman(parent) then
		parent = ToAHuman(parent);
		aimAngle = parent:GetAimAngle(false) * self.FlipFactor;
		muzzlePos = parent.EyePos + Vector(parent.IndividualRadius * parent.FlipFactor, 0):RadRotate(aimAngle);
		local controller = parent:GetController()
		if self.rotNum > 0 or controller:IsState(Controller.WEAPON_FIRE) then
			local twoPI = math.pi * 2;
			if self.rotNum >= twoPI then
				self.rotNum = 0;
			else
				if self.rotNum == 0 then
					self.count = EnforceLevelRequirement and 0 or 1;
					magicLevel = math.min(math.max(parent:GetNumberValue("MagicLevel"), 1), 99);
					local newLevel = math.min(magicLevel + 1/magicLevel, 99);
					magicPower = 1 + magicLevel * 0.02;
					local sound = self.startSound[1];
					for l = 1, #self.levels do
						if magicLevel >= self.levels[l] then
							sound = self.startSound[l];
							self.count = l;
						else
							if (EnforceLevelRequirement or l ~= 1) and newLevel >= self.levels[l] and controller.Player ~= -1 then
								self.levelSound[l]:Play(controller.Player);
								parent:FlashWhite(100);
							end
							break;
						end
					end
					sound.Pitch = self.RateOfFire/self.realROF;
					sound:Play(self.Pos);
					parent:SetNumberValue("MagicLevel", newLevel);
				else
					local ratio = 0;
					if self.rotNum >= math.pi then
						ratio = 1 - (self.rotNum - math.pi) * 4/math.pi;
						fire = true;
					else
						ratio = self.rotNum/math.pi;
						for i = 1, math.floor(self.count + (ratio * RangeRand(1, 2) * magicPower)^magicPower + 0.5) do
							local spark = CreateMOPixel("Fire Burn Particle", "Base.rte");
							local vector = Vector(((math.random(100, 200) * magicPower) * ratio)/(spark.Lifetime/TimerMan.DeltaTimeMS), 0):RadRotate(RangeRand(-math.pi, math.pi));
							spark.Pos = muzzlePos - vector;
							spark.Vel = vector * rte.PxTravelledPerFrame;
							spark.Team = self.Team;
							spark.IgnoresTeamHits = true;
							MovableMan:AddParticle(spark);
						end
						if self.Magazine then
							self.Magazine.Frame = math.max(self.count - 1, 0);
							self.Magazine.Scale = math.min(self.count, 1);
							if parent.BGArm then
								self.Magazine.Pos =	parent.BGArm.HandPos;
							end
							self.Magazine.Pos = self.Magazine.Pos + SceneMan:ShortestDistance(self.Magazine.Pos, muzzlePos, SceneMan.SceneWrapsX) * ratio;
						end
					end
					for i = 1, self.count do
						PrimitiveMan:DrawBitmapPrimitive(muzzlePos + Vector((1 + self.spread) * ratio * math.sqrt(self.count - i), 0):DegRotate(i * 137.508 - self.Age), self.fire, 0, math.floor(self.fire.FrameCount - self.fire.FrameCount * ratio), math.random() < 0.5, math.random() > 0.5);
					end
				end
				self.rotNum = math.min(self.rotNum + self.RateOfFire * 0.0017, twoPI);
			end
		elseif parent:GetController():IsState(Controller.AIM_SHARP) then
			self.aimNum = self.aimNum + 0.1;
		end
	else
		self.rotNum = 0;
	end
	if fire then
		self:Activate();
	else
		self:Deactivate();
	end
	self.aimNum = math.max(self.aimNum * 0.92 - 0.01, 0);
	local stance = Vector(self.stance.X, self.stance.Y):RadRotate(math.sin(self.rotNum) * self.angle + self.aimNum * 0.3) * (1 + math.sin(self.rotNum * 0.5) * 1.5 + self.aimNum);
	self.StanceOffset = stance;
	self.SharpStanceOffset = stance;
	self.InheritedRotAngleOffset = math.sin(self.rotNum - 0.1) * self.angle * 1.5 + self.angle * 0.5 - self.aimNum;

	if self.FiredFrame then
		if self.count == 0 and math.random() * magicLevel < 0.1 then
			local cabbage = CreateHeldDevice("Cabbage");
			cabbage.Team = self.Team;
			cabbage.IgnoresTeamHits = true;
			cabbage.Pos = Vector(muzzlePos.X, (parent.FGFoot or parent.BGFoot or parent).Pos.Y);
			cabbage.Vel = parent.Vel * 0.5 + Vector((1 + self.count * magicPower) * self.FlipFactor - math.sin(parent.RotAngle - parent.PrevRotAngle) - parent.AngularVel, 0):RadRotate(aimAngle);
			MovableMan:AddItem(cabbage);
			
			self.appearSound:Play(cabbage.Pos);
			
			local smoke = CreateMOSParticle("Smoke Ball 1");
			smoke.GlobalAccScalar = -1;
			smoke.Pos = cabbage.Pos;
			smoke.Vel = cabbage.Vel * 0.5;
			MovableMan:AddMO(smoke);
		else
			local randAngle = math.random(90);
			local sparkCount = 5 * magicPower;
			for i = 1, sparkCount do
				local par = CreateMOPixel("Fire Burn Particle");
				par.Team = self.Team;
				par.IgnoresTeamHits = true;
				par.Pos = muzzlePos + Vector(5 * math.sqrt(5 - i), 0):DegRotate(i * 137.508 + randAngle);
				par.Vel = parent.Vel * 0.5 + Vector(math.random(27, 33) * magicPower * self.FlipFactor, 0):RadRotate(aimAngle);
				par.Lifetime = math.ceil(par.Lifetime * i/sparkCount + 50);
				MovableMan:AddParticle(par);
			end
			for i = 1, self.count do
				local par = CreateAEmitter("Fireball Emitter");
				par.GibSound = self.endSound[self.count];
				par.Team = self.Team;
				par.RotAngle = RangeRand(-math.pi, math.pi);
				par.IgnoresTeamHits = true;
				par.Pos = muzzlePos + Vector(self.spread * math.sqrt(self.count - i), 0):DegRotate(i * 137.508 + randAngle);
				par.Vel = parent.Vel * 0.5 + Vector((30 + self.count * magicPower) * self.FlipFactor - math.sin(parent.RotAngle - parent.PrevRotAngle) - parent.AngularVel, 0):RadRotate(aimAngle);
				MovableMan:AddParticle(par);
			end
		end
	end
end