function Create(self)
	self.realROF = self.RateOfFire;
	self.power = (self.Mass + self.Sharpness)/2;
	self.type = self.Sharpness * 0.5 > self.Mass and "Stab" or (self.Mass * 0.5 > self.Sharpness and "Crush" or "Slash");
	self.rotNum = 0;
	self.aimNum = 0;
	self.stance = Vector(9, 6);
	self.angle = self:NumberValueExists("Angle") and self:GetNumberValue("Angle") or math.pi/2;
	self.hitSound = self:GetStringValue("HitSound") ~= "" and self:GetStringValue("HitSound") or nil;
	self.count = 0;
	self.spread = math.rad(self.ParticleSpreadRange);
	self.isTool = self:IsInGroup("Tools - Diggers");
	self.fireVel = self.Radius/rte.PxTravelledPerFrame;
end
function Update(self)
	local parent = self:GetRootParent();
	local aimAngle = self.RotAngle;
	local fire = false;
	local muzzlePos = self.MuzzlePos;
	local meleePower = 1;
	local ratio = 1;
	if IsActor(parent) then
		parent = ToActor(parent);
		aimAngle = parent:GetAimAngle(false) * self.FlipFactor;
		if self.rotNum > 0 or parent:GetController():IsState(Controller.WEAPON_FIRE) then
			if self.Magazine then
				self.Magazine.Scale = 1;
				self.Scale = 0;
			else
				self.Magazine.Scale = 0;
				self.Scale = 1;
			end
			local twoPI = math.pi * 2;
			if self.rotNum >= twoPI then
				self.rotNum = 0;
			else
				local minLevel = EnforceLevelRequirement and 1 or 50;
				local attackLevel = math.min(math.max(parent:GetNumberValue("AttackLevel"), minLevel), 99);
				ratio = attackLevel/math.max(self:GetNumberValue("AttackLevel"), 1);
				if self.rotNum == 0 then
					local strengthLevel = math.min(math.max(parent:GetNumberValue("StrengthLevel"), minLevel), 99);
					meleePower = strengthLevel * ratio;
					self.count = math.sqrt(meleePower);
					self.RateOfFire = self.realROF * math.sqrt(ratio);
					self.FireSound.Pitch = math.sqrt(self.RateOfFire/self.realROF);
				else
					if self.rotNum >= math.pi then
						fire = true;
					end
				end
				self.rotNum = math.min(self.rotNum + self.RateOfFire * 0.0017, twoPI);
			end
		else
			if self.Magazine then
				self.Magazine.Scale = 0;
				self.Scale = 1;
			end
			if parent:GetController():IsState(Controller.AIM_SHARP) then
				self.aimNum = self.aimNum + 0.1;
			end
		end
	else
		if self.Magazine then
			self.Magazine.Scale = 0;
			self.Scale = 1;
		end
		self.rotNum = 0;
	end
	if fire then
		self:Activate();
	else
		self:Deactivate();
	end
	self.aimNum = math.max(self.aimNum * 0.9 - 0.01, 0);
	local stance = Vector(self.stance.X, self.stance.Y):RadRotate(math.sin(self.rotNum) * self.angle + self.aimNum * 0.3) * (1 + math.sin(self.rotNum * 0.5) * 1.5 + self.aimNum);
	self.StanceOffset = stance;
	self.SharpStanceOffset = stance;
	self.InheritedRotAngleOffset = math.sin(self.rotNum - 0.1) * self.angle * 1.4 + self.angle * 0.8 - self.aimNum;
	if self.FiredFrame then
		local parCount = self.count * self.power * (self.isTool and 2 or 1);
		local parMass = self.Mass/parCount;
		local parSharpness = self.Sharpness/parMass;
		for i = 1, parCount do
			local par = CreateMOPixel(self.type .. " Damage Particle");
			par.Team = self.Team;
			par.IgnoresTeamHits = true;
			par.Pos = muzzlePos;
			par.Mass = parMass;
			local spread = self.spread - self.spread * 2 * i/(parCount + 1);
			par.Sharpness = parSharpness/(1 + math.abs(spread));
			par.Vel = parent.Vel * 0.5 + Vector(self.fireVel * self.FlipFactor, 0):RadRotate(aimAngle + spread);
			if self.isTool and i % 2 == 0 then
				par.HitsMOs = false;
				par.Sharpness = par.Sharpness * 2;
			end
			MovableMan:AddParticle(par);
		end
	end
end