function Create(self)
	self.sound = CreateSoundContainer("Telegrab");
	self.endSound = CreateSoundContainer("Telegrab End");
	self.scaleNum = 0;
	self.power = 2;
	self.telegrab = function(mo)
		if MovableMan:IsActor(self.parent) then
			mo = ToMOSRotating(mo);
			ratio = 1;
			if IsHeldDevice(mo) then
				self.parent:AddInventoryItem(ToHeldDevice(mo):Clone());
				mo.ToDelete = true;
			elseif mo.ID == self.parent.ID then
				self.target = self.parent;
				self.target.GlobalAccScalar = 0;
			else
				ratio = (self.parent.Radius * self.parent.Mass * self.power)/math.max(mo.Mass * mo.Radius, 1);
				if ratio > 1 then
					mo.Pos = self.parent.Pos + Vector((self.parent.IndividualRadius + mo.IndividualRadius) * self.FlipFactor * 0.4, (self.parent.IndividualRadius + mo.IndividualRadius) * 0.2);
				else
					mo.Vel = mo.Vel * (1 - ratio) + SceneMan:ShortestDistance(mo.Pos, self.parent.Pos, SceneMan.SceneWrapsX):SetMagnitude(math.sqrt(ratio) * self.power * 10);
				end
			end
			if IsActor(mo) then
				ToActor(mo):FlashWhite(100 * math.sqrt(ratio));
			end
			self.radius = (mo.IndividualRadius + math.sqrt(mo.Radius))/2;
		end
		self.PinStrength = 100;
		self.HitsMOs = false;
	end
	self.radius = self.Diameter;
end
function Update(self)
	self.sound.Pos = self.Pos;
	local radius = self.radius * 0.5 * self.Scale;
	local scale = radius - self.Radius;
	for i = 1, math.ceil(scale * 5 + 0.1) do
		local glow = CreateMOPixel("Telegrab Glow");
		glow.Pos = self.Pos + Vector(scale * math.random(), 0):RadRotate(RangeRand(-math.pi, math.pi)) + self.Vel * RangeRand(0.15, 0.30);
		MovableMan:AddParticle(glow);
	end
	PrimitiveMan:DrawEllipsePrimitive(-1, self.Pos, radius, math.abs(math.cos(self.RotAngle)) * radius, 0);
	PrimitiveMan:DrawEllipsePrimitive(-1, self.Pos, math.abs(math.sin(self.RotAngle)) * radius, radius, 0);
	local parent = self:GetRootParent();
	if IsAHuman(parent) then
		self.InheritedRotAngleOffset = self.InheritedRotAngleOffset - self.FlipFactor * 0.1;
		self.parent = ToAHuman(parent);
		if self:IsActivated() then
			if not self.sound:IsBeingPlayed() then
				self.sound:Play();
			end
			if self.parent.ThrowProgress == 1 then
				self.parent:GetController():SetState(Controller.WEAPON_FIRE, false);
			end
		end
	else
		self.RotAngle = self.RotAngle - self.FlipFactor * 0.1;
		self:ClearImpulseForces();
		if self.PinStrength > 0 then
			self.GetsHitByMOs = false;
			self.sound:Stop();
			self.scaleNum = self.scaleNum + 0.1;
			self.Scale = 1 + math.sin(self.scaleNum);
			if self.target and self.target.ID == self.parent.ID and IsActor(self.parent) then
				if self.target.Scale ~= 0 then
					self.target.Scale = self.Scale;
				end
				for att in self.target.Attachables do
					if att.Scale ~= 0 then
						att.Scale = self.Scale;
					end
					for attAtt in att.Attachables do
						if attAtt.Scale ~= 0 then
							attAtt.Scale = self.Scale;
						end
						for attAttATT in attAtt.Attachables do
							if attAttATT.Scale ~= 0 then
								attAttATT.Scale = self.Scale;
							end
						end
					end
				end
				ToActor(self.target).Health = ToActor(self.target).Health - self.Scale;
				if self.scaleNum >= math.pi * 1.5 then
					self.target.ToDelete = true;
				end
			end
			if self.scaleNum >= math.pi * 1.5 then
				self.ToDelete = true;
			end
		else
			local moCheck = self.HitWhatMOID ~= rte.NoMOID and self.HitWhatMOID or SceneMan:CastMORay(self.Pos, self.Vel * rte.PxTravelledPerFrame, self.ID, Activity.NOTEAM - 1, rte.airID, false, 1);
			if moCheck ~= rte.NoMOID then
				local mo = ToMOSRotating(MovableMan:GetMOFromID(moCheck)):GetRootParent();
				if not self.parent or mo.ID ~= self.parent.ID then
					self.telegrab(mo);
					self.endSound:Play(self.Pos);
				end
			end
		end
	end
end
function OnCollideWithTerrain(self, terrainID)
	if self.PinStrength == 0 then
		self.endSound:Play(self.Pos);
		self.PinStrength = 100;
		for item in MovableMan.Items do
			if item.PresetName ~= self.PresetName and SceneMan:ShortestDistance(self.Pos, item.Pos, SceneMan.SceneWrapsX).Magnitude < self.Radius then
				self.telegrab(item);
				break;
			end
		end
	end
end
function Destroy(self)
	self.sound:Stop();
end