function Create(self)
	self.targets = {};
end
function Update(self)
	local parent = self:GetRootParent();
	if IsActor(parent) then
		parent = ToActor(parent);
		for i = 1 , MovableMan:GetMOIDCount() - 1 do
			local actor = MovableMan:GetMOFromID(i);
			if actor and IsActor(actor) then
				actor = ToActor(actor);
				if actor.Status > Actor.INACTIVE then
					actor.ToSettle = false;
					if self.FiredFrame then
						actor.Status = Actor.UNSTABLE;
						MovableMan:ChangeActorTeam(actor, self.Team);
						local clone = actor:Clone();
						clone.Health = actor.MaxHealth;
						MovableMan:AddActor(clone);
						table.insert(self.targets, clone);
						actor.ToDelete = true;
						--actor:SetControllerMode(Controller.CIM_AI, -1);
					end
					--actor.HUDVisible = false;
				end
			end
		end
		for _, actor in pairs(self.targets) do
			if IsActor(actor) then
				actor.Health = actor.MaxHealth;
				actor.Status = parent.Status;
				local actorController = actor:GetController();
				local parentController = parent:GetController();
				for i = 1, Controller.CONTROLSTATECOUNT - 1 do
					actorController:SetState(i, parentController:IsState(i));
				end
			end
		end
	end
end