function Update(self)
	local parent;
	if self:GetParent() then
		parent = self:GetRootParent();
	elseif self.thrown == false and self:IsActivated() then
		self.AngularVel = self.AngularVel - self.Vel.Magnitude * self.FlipFactor;
		if self.user and parent == nil then
			self.user.Vel = self.Vel;
			self.Vel = self.Vel - self.user.Vel;
			self.user.Status = Actor.UNSTABLE;
		end
		self.user = nil;
		self.thrown = true;
	else
		self.thrown = false;
	end
	if self.user == nil or not MovableMan:IsActor(self.user) then
		self.user = nil;
		if parent and MovableMan:IsActor(parent) then
			self.user = ToActor(parent);
		end
	end
end
function Destroy(self)
	if MovableMan:ValidMO(self) then
		local count = {};
		local radius = 100;
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance(self.Pos, actor.Pos, SceneMan.SceneWrapsX);
			local checkPos = self.Pos + Vector(dist.X, dist.Y) * 0.5;
			if dist.Magnitude < radius and SceneMan:GetTerrMatter(checkPos.X, checkPos.Y) == rte.airID then
				table.insert(count, {Pos = actor.Pos - Vector(dist.X, dist.Y):SetMagnitude(math.min(actor.IndividualRadius, dist.Magnitude)), Vel = actor.Vel});
			end
		end
		for _, actor in pairs(count) do
			for i = 1, math.ceil(10/#count) do
				local exploed = CreateMOSRotating("Soviet Grenade Explosion", "4zK.rte");
				exploed.Pos = actor.Pos;
				exploed.Vel = actor.Vel
				MovableMan:AddParticle(exploed);
				exploed:GibThis();
			end
		end
	end
end