function Update(self)
	local parent = self:GetParent();
	if parent then
		if self.FiredFrame then
			local rocket = self:GetRootParent();
			local angle = rocket.RotAngle;
			local mass = rocket.Mass;
			if IsActor(rocket) then
				rocket = ToActor(rocket);
				mass = mass - math.sqrt(math.max(rocket.InventoryMass, 0));
				rocket.Status = Actor.UNSTABLE;
				rocket.DeathSound = nil;
				--rocket.OrientToVel = 0.5;
				angle = rocket:GetAimAngle(false);
			end
			
			local thruster = CreateAEmitter("Soviet Launcher Thruster");
			
			thruster.InheritedRotAngleOffset = angle - rocket.RotAngle;
			for em in thruster.Emissions do
				em.ParticlesPerMinute = mass * 20;
				em.MaxVelocity = math.sqrt(mass);
				em.MinVelocity = math.sqrt(mass);
			end

			rocket:AddAttachable(thruster, Vector());
			
			rocket.Vel = Vector(20 * rocket.FlipFactor, 0):RadRotate(angle * rocket.FlipFactor) - (SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs);
			parent:RemoveAttachable(self, true, true);
		end
	else
		self:Deactivate();
		if self.Magazine then
			self.Magazine.RoundCount = 0;
		end
	end
end