function Create(self)
	self.fireVel = 50;
	self.spread = math.rad(self.ParticleSpreadRange);
	self.hasAmmo = false;
	local parent = self:GetRootParent();
	if parent and IsActor(parent) and ToActor(parent):IsPlayerControlled() then
		self.hasAmmo = true;
	end
end
function Update(self)
	if self.FiredFrame then
		local parent = self:GetParent();
		local rootParent = ToMOSRotating(self:GetRootParent());
		if self.hasAmmo then
			rootParent = rootParent:Clone();
			rootParent.Pos = self.MuzzlePos;
			MovableMan:AddMO(rootParent);
		elseif parent then
			parent:RemoveAttachable(self, true, false);
		end
		rootParent.HUDVisible = false;
		if IsAHuman(rootParent) then
			rootParent = ToAHuman(rootParent);
			if self.hasAmmo then
				if rootParent.EquippedItem then rootParent.EquippedItem.ToDelete = true; end
				for item in rootParent.Inventory do
					rootParent:RemoveInventoryItem(item.PresetName);
				end
			else
				rootParent:DropAllInventory();
			end
		end
		if rootParent.Jetpack then
			rootParent.Jetpack:EnableEmission(false);
		end
		for att in rootParent.Attachables do
			rootParent:RemoveAttachable(att, true, false);
			att.Vel = Vector(50 * self.FlipFactor, 0):RadRotate(self.RotAngle + RangeRand(-1, 1) * self.spread);
			if self.hasAmmo then
				att.Pos = self.MuzzlePos + Vector(att.ParentOffset.X * rootParent.FlipFactor, att.ParentOffset.Y):RadRotate(rootParent.RotAngle);
				att.HFlipped = rootParent.HFlipped;
			end
			att.Team = self.Team; att.IgnoresTeamHits = true;
			for attAtt in att.Attachables do
				att:RemoveAttachable(attAtt, true, false);
				attAtt.Vel = Vector(50 * self.FlipFactor, 0):RadRotate(self.RotAngle + RangeRand(-1, 1) * self.spread);
				if self.hasAmmo then
					attAtt.Pos = self.MuzzlePos + Vector(attAtt.ParentOffset.X * rootParent.FlipFactor, attAtt.ParentOffset.Y):RadRotate(rootParent.RotAngle);
					attAtt.HFlipped = rootParent.HFlipped;
				end
				attAtt.Team = self.Team; attAtt.IgnoresTeamHits = true;
			end
		end
		rootParent.Vel = Vector(50 * self.FlipFactor, 0):RadRotate(self.RotAngle);
	end
end