function Create(self)
	self.reloadPhase = {};
	self.reloadSequence = 0;
	for i = 0, self:GetNumberValue("ReloadPhases") do
		self.reloadPhase[i] = {};
		self.reloadPhase[i].duration = self:GetNumberValue("ReloadPhase".. i .."Duration");
		self.reloadPhase[i].rotAngle = self:GetNumberValue("ReloadPhase".. i .."RotAngle");
		self.reloadPhase[i].frame = self:GetNumberValue("ReloadPhase".. i .."Frame");
		self.reloadPhase[i].sound = self:StringValueExists("ReloadPhase".. i .."Sound") and self:GetStringValue("ReloadPhase".. i .."Sound");
		if self:StringValueExists("ReloadPhase".. i .."MOSParticle") then
			self.reloadPhase[i].particle = self:GetStringValue("ReloadPhase".. i .."MOSParticle");
			self.reloadPhase[i].particleVelX = self:GetNumberValue("ReloadPhase".. i .."MOSParticleVelX");
			self.reloadPhase[i].particleVelY = self:GetNumberValue("ReloadPhase".. i .."MOSParticleVelY");
		end
	end
end
function Update(self)
	if self:IsReloading() then
		if self.reloadPhase[self.reloadSequence] then
			
			self.Frame = self.reloadPhase[self.reloadSequence].frame;
			self.RotAngle = self.RotAngle + (self.reloadPhase[self.reloadSequence].rotAngle * self.FlipFactor);
			local jointOffset = Vector(self.JointOffset.X * self.FlipFactor, self.JointOffset.Y):RadRotate(self.RotAngle);
			self.Pos = self.Pos - jointOffset + Vector(jointOffset.X, jointOffset.Y):RadRotate(-self.reloadPhase[self.reloadSequence].rotAngle * self.FlipFactor);
			
			if self.reloadTimer then
				if self.reloadSequence < #self.reloadPhase then
					if self.reloadTimer:IsPastSimMS(self.reloadPhase[self.reloadSequence].duration) then
						self.reloadTimer:Reset();
						self.reloadSequence = self.reloadSequence + 1;
						if self.reloadPhase[self.reloadSequence] then
							self.ReloadTime = self.ReloadTime + self.reloadPhase[self.reloadSequence].duration;
							if self.reloadPhase[self.reloadSequence].sound then
								AudioMan:PlaySound(self.reloadPhase[self.reloadSequence].sound, self.Pos);
							end
							if self.reloadPhase[self.reloadSequence].particle then
								local particle = CreateMOSParticle(self.reloadPhase[self.reloadSequence].particle);
								particle.Pos = self.Pos;
								particle.Vel = self.Vel + Vector(self.reloadPhase[self.reloadSequence].particleVelX * self.FlipFactor, self.reloadPhase[self.reloadSequence].particleVelY):RadRotate(self.RotAngle);
								MovableMan:AddParticle(particle);
							end
						end
					end
				end
			else
				self.reloadTimer = Timer();
			end
		end
	else
		if self:DoneReloading() then
			self.Frame = 0;
			self.reloadSequence = 0;
		elseif self.reloadTimer then
			self.reloadSequence = math.max(self.reloadSequence - 1, 0);
		end
		self.ReloadTime = self.reloadPhase[self.reloadSequence].duration + (TimerMan.DeltaTimeMS * #self.reloadPhase);
		self.reloadTimer = nil;
	end
end