-- CaveCricket48's Fermat Spiral script as a base for 360-degree hover mechanic
function Create(self)
	self.pointCount = 100;	-- Number of points
	self.spiralScale = 5;	-- Size of the spiral
	self.skipPoints = math.floor(self.Radius);	-- Skip first points (radius: points inside the object itself)
end

function Update(self)

	if self.FiredFrame then
		self.pointCount = math.random(10, 100);
		self.spiralScale = math.random(1, 10);
		self.skipPoints = math.random(1, 10);
	end
	local scale = self.spiralScale;
	if self:IsActivated() then
		scale = self.spiralScale * 2;
	end
	local count = 50;
	local maxRadius = math.sqrt(count);	
	local scale = 25 / maxRadius;	
	for i = self.skipPoints, self.pointCount - 1 do
		local radius = scale * math.sqrt(count - i);
		local angle = i * 137.508;
		--local checkPos = self.Pos + Vector(radius, 0):DegRotate(angle);
		local checkPos = self.Pos + Vector(radius * (maxVelocity / maxRadius), RandomNum(-spread, spread)):RadRotate(i * 2.39996F);
		if SceneMan.SceneWrapsX == true then
			if checkPos.X > SceneMan.SceneWidth then
				checkPos = Vector(checkPos.X - SceneMan.SceneWidth, checkPos.Y);
			elseif checkPos.X < 0 then
				checkPos = Vector(SceneMan.SceneWidth + checkPos.X, checkPos.Y);
			end
		end
		local color = 254;
		local terrCheck = SceneMan:GetTerrMatter(checkPos.X, checkPos.Y);
		local moCheck = SceneMan:GetMOIDPixel(checkPos.X, checkPos.Y);
		if moCheck ~= 255 then
			color = 122;
			if terrCheck ~= 0 then
				color = 149;
			end
		elseif terrCheck ~= 0 then
			color = 5;
		end
		PrimitiveMan:DrawLinePrimitive(checkPos, checkPos, color);
	end
	PrimitiveMan:DrawTextPrimitive(self.Pos + Vector(-20, self.spiralScale * math.sqrt(self.pointCount) + 7), "pointCount = ".. self.pointCount, true, 0);
	PrimitiveMan:DrawTextPrimitive(self.Pos + Vector(-20, self.spiralScale * math.sqrt(self.pointCount) + 14), "spiralScale = ".. self.spiralScale, true, 0);
	PrimitiveMan:DrawTextPrimitive(self.Pos + Vector(-20, self.spiralScale * math.sqrt(self.pointCount) + 21), "skipPoints = ".. self.skipPoints, true, 0);
end