function Create(self)
	self.thc = self:GetNumberValue("THC");
	self.cbd = self:GetNumberValue("CBD");
end
function Update(self)
	local parent = self:GetRootParent();
	if IsAHuman(parent) then
		parent = ToAHuman(parent);
		parent:GetController():SetState(Controller.AIM_SHARP, false);
		self.RotAngle = self.RotAngle - (parent.FlipFactor * 0.2);
		if self.Magazine then
			self.Magazine.RoundCount = math.max(self.FrameCount - self.Frame - 1, 0);
		end
		if parent.Head then
			if self.FiredFrame then
				if self.smokeTimer then
					self.smokeDelay = self.smokeDelay * 0.5 + 25;
					self.litTimer:Reset();
				else
					self.litTimer = Timer();
					self.litTimer:SetSimTimeLimitMS(30000);
					self.smokeTimer = Timer();
					self.smokeDelay = 0;
				end
				self.Frame = self.Frame + 1;
				self.MuzzleOffset = self.MuzzleOffset - Vector(1, 0);
				parent:SetNumberValue("Ganja", parent:GetNumberValue("Ganja") + (self.thc + self.cbd));
				if parent:GetNumberValue("Ganja") == self.FrameCount - 2 then
					--parent.Head:AddAttachable(CreateAttachable("Red Eyes"), Vector(parent.Head.Radius * 0.1, 0));
					parent:SetLimbPathSpeed(1, parent:GetLimbPathSpeed(1) * (self.thc > self.cbd and 1.25 or 0.75));
				end
				local ash = CreateMOPixel("Ash Particle");
				ash.Pos = self.MuzzlePos;
				ash.Vel = self.Vel + Vector(self.FlipFactor, 0);
				MovableMan:AddParticle(ash);
				self:Reload();
			end
			if self:DoneReloading() then
				local particleCount = math.floor(parent.Head.Radius * 0.5 + 0.5);
				for i = 1, particleCount do
					local smoke = CreateMOSParticle("Cigarette Smoke Tiny");
					smoke.Pos = parent.Head.Pos + Vector(particleCount * parent.Head.FlipFactor, particleCount);
					smoke.Vel = parent.Head.Vel + Vector(math.sqrt(parent.Head.Radius) * parent.Head.FlipFactor * RangeRand(0.5, 1.0) * particleCount, RangeRand(-0.5, 0.5) * particleCount):RadRotate(parent.Head.RotAngle);
					smoke.Lifetime = 1 + smoke.Lifetime * RangeRand(0.5, 1.0);
					MovableMan:AddParticle(smoke);
				end
				local targetHealth = parent.MaxHealth * 0.5;
				if parent.Health > targetHealth then
					parent.Health = math.max(parent.Health - 1, targetHealth);
				elseif parent.Health < targetHealth then
					parent.Health = math.min(parent.Health + 1, targetHealth);
				end
				for wound in parent.Wounds do
					wound.Throttle = math.max(wound.Throttle - 0.1, -1);
					wound.Scale = math.max(wound.Scale - 0.1, 0);
				end
				for att in parent.Attachables do
					for wound in att.Wounds do
						wound.Throttle = math.max(wound.Throttle - 0.1, -1);
						wound.Scale = math.max(wound.Scale - 0.1, 0);
					end
				end
				if self.Frame == self.FrameCount - 1 then
					self:GetParent():RemoveAttachable(self, true, true);
					self.Vel.X = self.Vel.X + parent.FlipFactor * math.random(2, 4);
					self.UnPickupable = true;
					self.HUDVisible = false;
				end
			end
		end
	end
	local muzzleVector = Vector(self.FlipFactor, 0):RadRotate(self.RotAngle);
	if self:IsActivated() then
		self.StanceOffset = Vector(4, -3);
		if self.Frame == 0 then
			self.SupportOffset = Vector(3, 1);
		else
			local glow = CreateMOPixel("Cigarette Burn Glow");
			glow.Pos = self.MuzzlePos - muzzleVector;
			MovableMan:AddParticle(glow);
		end
	else
		self.StanceOffset = Vector(5, 5);
		self.SupportOffset = Vector(99, 99);
	end
	if self.smokeTimer and self.smokeTimer:IsPastSimMS(self.smokeDelay * self.Frame) then
		self.smokeTimer:Reset();
		self.smokeDelay = self.smokeDelay + 1;

		local smoke = CreateMOSParticle("Cigarette Smoke Tiny");
		smoke.Pos = self.MuzzlePos + muzzleVector;
		smoke.Vel = muzzleVector * math.random();
		smoke.Lifetime = 1 + smoke.Lifetime * math.random();
		MovableMan:AddParticle(smoke);

		if self.litTimer:IsPastSimTimeLimit() then
			self.litTimer = nil;
			self.smokeTimer = nil;
		end
	end
	if not self.litTimer and self.Frame == self.FrameCount - 1 then
		self.ToSettle = true;
	end
end