function Create(self)
	self.reach = self.Radius;
	self.kills = 0;

	self.setAngle = 0;
	self.stanceOffset = Vector(7, -9);
	
	self.inventoryTimer = Timer();
	self.inventoryTimer:SetSimTimeLimitMS(TimerMan.DeltaTimeMS + 1);
	self.twirlAngle = 0;

			self.twirlAngle = math.pi * 2;
			self:Reload();
			self.StanceOffset = Vector(9, 7);
			self.SharpStanceOffset = Vector(9, 7);

	self.orientation = 0;
	self.stabSound = CreateSoundContainer("Stab", "4zK.rte");
end
function Update(self)

	if self.ID ~= self.RootID then

		local setStance = Vector(self.stanceOffset.X, self.stanceOffset.Y):RadRotate(self.setAngle) + Vector(-self.setAngle * self.reach * 2, 0);
		self.StanceOffset = setStance;
		self.SharpStanceOffset = setStance;

		if self.inventoryTimer:IsPastSimTimeLimit() or IsActor(self:GetRootParent()) and (self.RoundInMagCount == 0 or ToActor(self:GetRootParent()):GetController():IsState(Controller.WEAPON_RELOAD)) then
			self.twirlAngle = math.pi * 2;
			self:Reload();
			self:RemoveWounds(1);
			self.kills = math.max(self.kills - 1, 0);
			self.Frame = math.floor(self.kills * 0.4);
			self.StanceOffset = Vector(9, 7);
			self.SharpStanceOffset = Vector(9, 7);
		end
		self.inventoryTimer:Reset();
		if self.twirlAngle > 0 then
			self.RotAngle = self.RotAngle - self.twirlAngle * self.FlipFactor;
			self.twirlAngle = math.max(self.twirlAngle * 0.9 - 0.1, 0);
		end

		if self.FiredFrame then
			self.setAngle = -1.3;

			local actor;
			local fireVec = Vector((self.Radius + self.reach) * self.FlipFactor, 0):RadRotate(self.RotAngle + self.setAngle * 0.5 * self.FlipFactor);
			local moRay = SceneMan:CastMORay(self.MuzzlePos, fireVec, self.ID, self.Team, rte.airID, false, 0);
			if moRay ~= rte.NoMOID then
				local mo = ToMOSRotating(MovableMan:GetMOFromID(moRay));
				if (IsActor(mo) or (IsAttachable(mo) and IsActor(ToAttachable(mo):GetParent()))) and mo.HFlipped == self.HFlipped then
					actor = ToActor(mo:GetRootParent());
					actor.Health = actor.Health - (actor.MaxHealth + 1);
					actor.AngularVel = -5 * actor.FlipFactor;

					local dist = SceneMan:ShortestDistance(mo.Pos, self.Pos, SceneMan.SceneWrapsX);
					local woundOffset = dist:SetMagnitude(dist.Magnitude - (self.Radius + self.reach));
					actor:AddWound(CreateAEmitter(actor:GetExitWoundPresetName()), woundOffset, false);

					self.stabSound:Play(self.Pos);

					local isFlesh = string.find(actor.Material.PresetName, "Flesh");
					if isFlesh then
						self.kills = self.kills + 1;
						self.Frame = math.floor(self.kills * 0.4);
					end
					local woundPos = actor.Pos + woundOffset;

					local particle = isFlesh and CreateMOSParticle("Blood Spray Particle") or CreateMOSParticle("Spark Yellow Particle");
					particle.Pos = woundPos;
					particle.Vel = Vector(dist.X, dist.Y):SetMagnitude(math.random(1, 5)) + Vector(0, -1);
					MovableMan:AddParticle(particle);
					
					for i = 1, 10 do
						local drop = isFlesh and CreateMOPixel("Drop Blood") or CreateMOPixel("Spark Yellow ".. math.random(2));
						drop.Pos = woundPos;
						drop.Vel = Vector(dist.X, dist.Y):SetMagnitude(math.random(1, 10)):DegRotate(math.random(-10, 10)) + Vector(0, -1);
						MovableMan:AddParticle(drop);
					end
				end
			end
			if not actor then
				local damageParticle = CreateMOPixel("Damage Particle", "4zK.rte");
				damageParticle.Pos = self.MuzzlePos;
				damageParticle.Vel = fireVec/rte.PxTravelledPerFrame;
				damageParticle.WoundDamageMultiplier = 1.5;
				damageParticle.Team = self.Team;
				damageParticle.IgnoresTeamHits = true;
				MovableMan:AddParticle(damageParticle);
			end
		end
		if self.setAngle < 0 then
			self.setAngle = math.min(self.setAngle + 0.01 * (1 + self.RateOfFire * 0.05), 0);
		end
	else
		self.StanceOffset = Vector(9, 7);
		self.SharpStanceOffset = Vector(9, 7);
	end
end