function Create(self)
	self.gravityPerFrame = SceneMan.Scene.GlobalAcc * TimerMan.DeltaTimeSecs;
	self.effectTime = 30000;
end
function Update(self)
	if not self:GetParent() then
		if self.target then
			if MovableMan:ValidMO(self.target) then
				local numberValue = self.target:GetNumberValue("Antigrav");
				if numberValue < 0 then
					self.ToDelete = true;
				else
					self.target:SetNumberValue("Antigrav", numberValue - TimerMan.DeltaTimeMS);
					self.Pos = Vector(self.target.Pos.X, self.target.Pos.Y) + Vector(self.target.Radius * RangeRand(0, 0.7), 0):RadRotate(RangeRand(-math.pi, math.pi));
					self.target.Vel = self.target.Vel - self.gravityPerFrame * self.target.GlobalAccScalar;
					if IsActor(self.target) and ToActor(self.target).Status < Actor.INACTIVE then
						ToActor(self.target).Status = Actor.UNSTABLE;
					end
				end
			else
				self:GibThis();
			end
		elseif self.Vel.Magnitude < 1 then
			self:GibThis();
		end
	else
		local parent = self:GetRootParent();
		if IsActor(parent) and not ToActor(parent):NumberValueExists("Antigrav") then
			parent.Vel = parent.Vel - self.gravityPerFrame * parent.GlobalAccScalar * 0.5;
		end
	end
end
function OnCollideWithMO(self, mo, rootMO)
	if not self.target and IsMOSRotating(rootMO) then
		rootMO = ToMOSRotating(rootMO);
		local add = self.effectTime/math.sqrt(math.abs(rootMO.Mass) + 1);
		if rootMO:NumberValueExists("Antigrav") then
			rootMO:SetNumberValue("Antigrav", rootMO:GetNumberValue("Antigrav") + add);
			self:GibThis();
		else
			self.target = rootMO;
			self.Vel = Vector();
			self.PinStrength = 1000;
			rootMO:SetNumberValue("Antigrav", add);
		end
	end
end
function OnCollideWithTerrain(self, terrain)
	self.IgnoresTeamHits = false;	--Maybe this won't crash
end
function Destroy(self)
	if self.target and MovableMan:ValidMO(self.target) then
		self.target:RemoveNumberValue("Antigrav");
	end
end