function Create(self)

	self.num = 0;

	self.draw = true;
	self.windup = false;
	self.swing = false;
	self.cooldown = false;
	self.equip = false;
	self.lastAngle = 0;
	self.crits = 0;		-- track critical hits
	self.critsMax = 2;	-- max amount of critical hits per swing

	self.speed = 0.5;	-- variable(not)
	self.equipSound = CreateSoundContainer("Katana Equip", "4zK.rte");
	self.swingSound = CreateSoundContainer("Katana Swing", "4zK.rte");
end

function Update(self)

	local parent = self:GetRootParent();
	if parent and IsAHuman(parent) then
		parent = ToAHuman(parent);
		local speed = parent.PresetName == "Ninja" and self.speed * 1.5 or self.speed;
		local pAngle = parent:GetAimAngle(false);
		local arc = self.lastAngle - pAngle;

		if self.Magazine then
			self.Magazine.Scale = 1;
			self.Scale = 0;
		end

		if self.equip == false then
			self.equipSound:Play(self.Pos);

			self.equip = true;
		end

		local rotAngle = -(-0.2 * (2 * math.pi) - math.sin(self.num) * 1.6 - arc);

		if self.cooldown == true then

			self.swing = false;

			if self.num > 2 * math.pi then

				self.cooldown = false;
				self.num = 0;
			else
				self.num = self.num + speed * 0.5;
			end

		elseif self.swing == true then

			self.windup = false;

			if self.num > math.pi * 1.5 then

				self.cooldown = true;
			else
				self.num = self.num + speed;

				local velBonus = (parent.PrevVel.X * 0.2 - parent.AngularVel * 2) * parent.FlipFactor + math.abs(parent.PrevVel.Y * 0.1);

				for i = 1, 2 do

					local part = CreateMOPixel("Particle Katana 1");
					part.Pos = self.MuzzlePos;

					part.Vel = 	parent.Vel + Vector((80 + velBonus) * self.FlipFactor, 0):RadRotate(rotAngle - 0.3);

					part.Mass = 0.07 * RangeRand(0.75, 1.25);
					part.Sharpness = 14 * RangeRand(0.75, 1.25);

					part.Team = self.Team;
					part.IgnoresTeamHits = true;

					MovableMan:AddParticle(part);
				end

				if self.crits < self.critsMax and math.random() < -math.sin(self.num + 0.4) - 0.6 * (1 + self.crits/self.critsMax)/(1 + velBonus * 0.1) then
					
					local mocheck = SceneMan:CastMORay(self.MuzzlePos, Vector(math.floor(self.Radius * 0.8) * self.FlipFactor, 0):RadRotate(rotAngle), self.ID, self.Team, rte.airID, true, 1);
					if mocheck ~= rte.NoMOID then
						local mo = MovableMan:GetMOFromID(MovableMan:GetMOFromID(mocheck).ID);
						if mo and IsAttachable(mo) and not (IsHDFirearm(mo) or IsTDExplosive(mo) or IsHeldDevice(mo)) and ToAttachable(mo):IsAttached() and mo.Team ~= self.Team then
							mo = ToAttachable(mo);
							if mo.Material.StructuralIntegrity < self.Sharpness * self.Mass then
								mo:GetParent():RemoveAttachable(ToAttachable(mo), true, true);
								mo.AngularVel = mo.AngularVel + math.random(-5, 5);
								mo.Vel = mo.Vel + parent.Vel * 0.5;
								mo.GetsHitByMOs = false;

								--print("DETACHED: " .. mo.PresetName);

								--sfx = CreateAEmitter("Katana Hit");
								--sfx.Pos = self.Pos;
								--MovableMan:AddParticle(sfx);

								self.crits = self.crits + 1;
								--print(self.crits);
							else
								--placeholder shit! replace
								self.cooldown = true;
								self.swing = false;
								self.num = math.pi * 1.5;
								--self.blockSound:Play(self.Pos);
							end
						end
					end
				end
			end

		elseif self.windup == true then

			if self.num > math.pi * 0.5 then

				if parent:IsPlayerControlled() == false then
					self:Deactivate();
				end

				if self:IsActivated() then
					self.num = 0.5 * math.pi;
				else
					self.swingSound:Play(self.Pos);
					self.swing = true;
					self.crits = 0;
				end
			else
				self.num = self.num + speed * 0.3;
			end

		elseif self:IsActivated() then

			self.windup = true;
		end
		local offset = Vector(13, 1):RadRotate(-0.5 + math.sin(self.num) * 1.1);

		self.StanceOffset = offset;
		self.SharpStanceOffset = offset;
		self.InheritedRotAngleOffset = rotAngle;

		self.lastAngle = pAngle;
	else
		self.num = 0;

		self.draw = true;
		self.windup = false;
		self.swing = false;

		self.equip = false;

		self.Scale = 1;
		if self.Magazine then
			self.Magazine.Scale = 0;
		end
	end
end