function Create(self)
	self.string = {[0] = {Pos = self.PrevPos, Vel = Vector()}};
	self.color = 12;
	
	self.settleTimer = Timer();
	self.maxLength = 1500;
	self.distanceTravelled = 0;
end
function Update(self)
	for i = 0, #self.string do
		self.string[i].Pos = self.string[i].Pos + self.string[i].Vel;
		if SceneMan:GetTerrMatter(self.string[i].Pos.X, self.string[i].Pos.Y) ~= rte.airID then
			if self.string[i].Vel.Magnitude > 0.5 then
				self.string[i].Pos = self.string[i].Pos - self.string[i].Vel * 0.5;
				self.string[i].Vel = self.string[i].Vel * (-0.5);
			else
				self.string[i].Vel = Vector();
			end
		else
			self.string[i].Vel = self.string[i].Vel + SceneMan.GlobalAcc * TimerMan.DeltaTimeSecs;
		end
	end
	if math.floor(self.Pos.X) ~= math.floor(self.PrevPos.X) and math.floor(self.Pos.Y) ~= math.floor(self.PrevPos.Y) then
		table.insert(self.string, {Pos = self.Pos, Vel = Vector()});
		self.distanceTravelled = self.distanceTravelled + SceneMan:ShortestDistance(self.Pos, self.PrevPos, SceneMan.SceneWrapsX).Magnitude;
	end
	self.toSettle = self.settleTimer:IsPastSimMS(1000) or self.distanceTravelled > self.maxLength;
	for i = 1, #self.string do
		local dist = SceneMan:ShortestDistance(self.string[i - 1].Pos, self.string[i].Pos, SceneMan.SceneWrapsX);
		PrimitiveMan:DrawLinePrimitive(self.string[i - 1].Pos, self.string[i - 1].Pos + dist, self.color);
		if self.toSettle then
			for j = 1, dist.Magnitude do
				local pix = CreateMOPixel("String Part", "4zK.rte");
				pix.Pos = self.string[i - 1].Pos + Vector(dist.X, dist.Y):SetMagnitude(j);
				pix.Vel = self.string[i - 1].Vel;
				MovableMan:AddParticle(pix);
			end
		end
	end
	if self.toSettle then
		self.ToDelete = self.toSettle;
	end
end
function Destroy(self)
	if not self.toSettle then
		for i = 1, #self.string do
			local dist = SceneMan:ShortestDistance(self.string[i - 1].Pos, self.string[i].Pos, SceneMan.SceneWrapsX);
			for j = 1, dist.Magnitude do
				local pix = CreateMOPixel("String Part", "4zK.rte");
				pix.Pos = self.string[i - 1].Pos + Vector(dist.X, dist.Y):SetMagnitude(j);
				pix.Vel = self.string[i - 1].Vel;
				MovableMan:AddParticle(pix);
			end
		end
	end
end