function Create(self)
	local range = self.Vel.Magnitude + math.sqrt(FrameMan.PlayerScreenWidth^2 + FrameMan.PlayerScreenHeight^2)/2 + math.random(8);

	local startPos = self.Pos + Vector(0, RangeRand(-0.5, 0.5)):RadRotate(self.Vel.AbsRadAngle);
	local hitPos = Vector(startPos.X, startPos.Y);
	local gapPos = Vector(startPos.X, startPos.Y);
	local trace = Vector(range, 0):RadRotate(self.Vel.AbsRadAngle);
	--Use higher pixel skip first to find a rough estimate
	local skipPx = 4;
	local rayLength = SceneMan:CastObstacleRay(startPos, trace, hitPos, gapPos, rte.NoMOID, self.Team, rte.airID, skipPx);

	if rayLength >= 0 then
		gapPos = gapPos - Vector(trace.X, trace.Y):SetMagnitude(skipPx);
		skipPx = 1;
		local shortRay = SceneMan:CastObstacleRay(gapPos, Vector(trace.X, trace.Y):SetMagnitude(range - rayLength + skipPx), hitPos, gapPos, rte.NoMOID, self.Team, rte.airID, skipPx);
		gapPos = gapPos - Vector(trace.X, trace.Y):SetMagnitude(skipPx);
		
		local moID = SceneMan:GetMOIDPixel(hitPos.X, hitPos.Y);
		if moID ~= rte.NoMOID then
			local mo = ToMOSRotating(MovableMan:GetMOFromID(moID));
			if self.Sharpness >= mo.Material.StructuralIntegrity then
				local moAngle = -mo.RotAngle * mo.FlipFactor;
				
				local woundName = mo:GetEntryWoundPresetName();
				if woundName ~= "" then
					local wound = CreateAEmitter(woundName);
					
					local dist = SceneMan:ShortestDistance(mo.Pos, hitPos, SceneMan.SceneWrapsX);
					local offset = Vector(dist.X * mo.FlipFactor, dist.Y):RadRotate(moAngle):SetMagnitude(dist.Magnitude - (wound.Radius - 1) * wound.Scale);
					local traceOffset = Vector(trace.X * mo.FlipFactor, trace.Y):RadRotate(moAngle);
					
					wound.InheritedRotAngleOffset = traceOffset.AbsRadAngle - (mo.HFlipped and 0 or math.pi);
					mo:AddWound(wound, Vector(offset.X, offset.Y), true);
				end
			end
		end
		local smoke = CreateMOSParticle("Tiny Smoke Trail " .. math.random(3), "Base.rte");
		smoke.Pos = gapPos;
		smoke.Vel = Vector(-trace.X, -trace.Y):SetMagnitude(math.random(10)):RadRotate(RangeRand(-1, 1));
		MovableMan:AddParticle(smoke);
	
		local pix = CreateMOPixel("Laser Rifle Glow End", "Base.rte");
		pix.Pos = gapPos;
		pix.Sharpness = self.Sharpness/6;
		pix.Vel = Vector(trace.X, trace.Y):SetMagnitude(6);
		MovableMan:AddParticle(pix);
	end
	if rayLength ~= 0 then
		trace = SceneMan:ShortestDistance(startPos, gapPos, SceneMan.SceneWrapsX);
		for player = Activity.PLAYER_1, Activity.MAXPLAYERCOUNT - 1 do
			local team = ActivityMan:GetActivity():GetTeamOfPlayer(player);
			local screen = ActivityMan:GetActivity():ScreenOfPlayer(player);
			if screen ~= -1 and not SceneMan:IsUnseen(startPos.X, startPos.Y, team) and not SceneMan:IsUnseen(hitPos.X, hitPos.Y, team) then
				PrimitiveMan:DrawLinePrimitive(screen, startPos, startPos + trace, 254);
			end
		end
		local particleCount = trace.Magnitude * RangeRand(0.3, 0.5);
		for i = 0, particleCount do
			local pix = CreateMOPixel("Laser Rifle Glow", "Base.rte");
			pix.Pos = startPos + trace * i/particleCount;
			MovableMan:AddParticle(pix);
		end
	end
	self.ToDelete = true;
end