function Create(self)
	self.inventoryTimer = Timer();
	self.inventoryTimer:SetSimTimeLimitMS(math.ceil(TimerMan.DeltaTimeMS));

	self.setMeleeAngle = 0;
	self.meleeReach = ToMOSprite(self):GetSpriteWidth() + self.SpriteOffset.X + 5;
	self.meleeKey = 7;	--G
	
	self.alternateDir = false;	--Whether to alternate the angle of the melee swing
	self.meleeDir = 1;

	local template = CreateHDFirearm(self:GetModuleAndPresetName());
	self.origStanceOffset = template.StanceOffset;
	DeleteEntity(template);
end
function Update(self)
	if self.setMeleeAngle ~= 0 then
		--self.InheritedRotAngleOffset = self.setMeleeAngle;	--Prerelease 4 onwards
		if self.meleeDir == 1 then
			self.setMeleeAngle = math.max(self.setMeleeAngle * 0.8 - 0.01, 0);
		else
			self.setMeleeAngle = math.min(self.setMeleeAngle * 0.8 + 0.01, 0);
		end
	end
	local actor = self:GetRootParent();
	if IsAHuman(actor) then
		actor = ToAHuman(actor);
		if self:DoneReloading() or self.inventoryTimer:IsPastSimTimeLimit() then
			self.setMeleeAngle = 0;
		end
		local controller = actor:GetController();
		if actor:IsPlayerControlled() and controller.Player == Activity.PLAYER_1 then
			
			if UInputMan:KeyHeld(self.meleeKey) then
				controller:SetState(Controller.AIM_SHARP, false);
				local arm = self:GetParent();
				
				self.StanceOffset = Vector(arm.Diameter, (-1 + self.meleeDir) * 3) + self.JointOffset;
				if not self.meleed then
					self.meleeDir = (self.meleeDir == 1 and self.alternateDir) and -1 or 1;
					local attackMass = (self.Mass + arm.Mass)/(1 + math.abs(self.setMeleeAngle));
					local attackAngle = math.sqrt(self.Radius)/self.Radius;
					local particleCount = math.sqrt(self.Diameter);
					local sharpness = math.sqrt(self.Material.StructuralIntegrity)/self.Radius;
					for i = 1, particleCount do
						local part = CreateMOPixel("Smack Particle Light");
						local vector = Vector(self.meleeReach * self.FlipFactor, 0):RadRotate(self.RotAngle + (particleCount * 0.5 - i) * attackAngle * self.meleeDir);
						part.Pos = self.Pos;
						part.Vel = self.Vel + (vector/rte.PxTravelledPerFrame) + Vector(0, -1);
						part.Mass = attackMass/particleCount;
						part.Sharpness = sharpness/math.sqrt(i);
						part.Team = self.Team;
						part.IgnoresTeamHits = true;
						MovableMan:AddParticle(part);
					end
					self.meleed = true;
				end
				self.setMeleeAngle = self.setMeleeAngle * 0.75 + 0.75 * self.meleeDir;
			elseif self.meleed then
				self.meleed = false;
				self.StanceOffset = Vector(self.origStanceOffset.X, self.origStanceOffset.Y);
			end
		end
		--Backwards-compatibility (outdated)
		self.RotAngle = self.RotAngle + (self.setMeleeAngle * self.FlipFactor);
		local jointOffset = Vector(self.JointOffset.X * self.FlipFactor, self.JointOffset.Y):RadRotate(self.RotAngle);
		local aimVector = Vector(self.setMeleeAngle, 0):RadRotate(actor:GetAimAngle(true));
		self.Pos = self.Pos - jointOffset + Vector(jointOffset.X, jointOffset.Y):RadRotate(-self.setMeleeAngle * self.FlipFactor) + aimVector;
		--/
	else
		self.setMeleeAngle = 0;
	end
	self.inventoryTimer:Reset();
end