function Create(self)
	self.cooldown = Timer();
	self.cooldownSpeed = self:NumberValueExists("CooldownSpeed") and self:GetNumberValue("CooldownSpeed") or 0.66;
	self.smokeParticle = self:StringValueExists("SmokeParticle") and self:GetStringValue("SmokeParticle") or "Base.rte/Tiny Smoke Ball 1";
	function self.emitSmoke(particleCount)
		for i = 1, particleCount do
			local smoke = CreateMOSParticle(self.smokeParticle);
			smoke.Pos = self.MuzzlePos;
			smoke.Lifetime = smoke.Lifetime * RangeRand(0.5, 1.0);
			smoke.Vel = self.Vel * 0.5 + Vector(RangeRand(0, i), 0):RadRotate(RangeRand(-math.pi, math.pi));
			MovableMan:AddParticle(smoke);
		end
	end
end
function Update(self)
	if self.FiredFrame then
		self.cooldown:Reset();
	end
	if self.Magazine and self.Magazine.RoundCount > 0 then
		local ammoRatio = 1 - self.Magazine.RoundCount/self.Magazine.Capacity;
		self.emitSmoke(math.floor(ammoRatio * RangeRand(0.5, 2.0) + RangeRand(0.25, 0.50)));
		self.cooldown:SetSimTimeLimitMS(self.ReloadTime * ammoRatio);
		
		local cooldownRate = math.floor(self.cooldown.ElapsedSimTimeMS/(60000/(self.RateOfFire * self.cooldownSpeed)));
		if ammoRatio ~= 0 and cooldownRate >= 1 then--self.cooldown:IsPastSimMS(60000/(self.RateOfFire * self.cooldownSpeed)) then
			self.Magazine.RoundCount = math.min(self.Magazine.RoundCount + cooldownRate, self.Magazine.Capacity);
			self.cooldown:Reset();
		end
	elseif self:IsReloading() then
		self.emitSmoke(math.floor((self.cooldown:LeftTillSimTimeLimitMS()/self.ReloadTime) * RangeRand(0.5, 2.0) + RangeRand(0.50, 0.75)));
	elseif self.RoundInMagCount >= 0 then
		self:Reload();
	end
end