for actor in MovableMan.Actors do
	local drawAfter = {};
	for att in actor.Attachables do
		if att.DrawAfterParent then
			table.insert(drawAfter, att);
		elseif att.Scale == 1 then
			PrimitiveMan:DrawBitmapPrimitive(-1, att.Pos, att, att.RotAngle, att.Frame, att.HFlipped, false);
		end
		for attAtt in att.Attachables do
			if attAtt.DrawAfterParent then
				table.insert(drawAfter, attAtt);
			elseif attAtt.Scale == 1 then
				PrimitiveMan:DrawBitmapPrimitive(-1, attAtt.Pos, attAtt, attAtt.RotAngle, attAtt.Frame, attAtt.HFlipped, false);
			end
		end
	end
	PrimitiveMan:DrawBitmapPrimitive(-1, actor.Pos, actor, actor.RotAngle, actor.Frame, actor.HFlipped, false);
	for _, att in pairs(drawAfter) do
		PrimitiveMan:DrawBitmapPrimitive(-1, att.Pos, att, att.RotAngle, att.Frame, att.HFlipped, false);
	end
end
for item in MovableMan.Items do
	if IsMOSRotating(item) then
		item = ToMOSRotating(item);
		local drawAfter = {};
		for att in item.Attachables do
			if att.DrawAfterParent then
				table.insert(drawAfter, att);
			elseif att.Scale == 1 then
				PrimitiveMan:DrawBitmapPrimitive(-1, att.Pos, att, att.RotAngle, att.Frame, att.HFlipped, false);
			end
		end
		PrimitiveMan:DrawBitmapPrimitive(-1, item.Pos, item, item.RotAngle, item.Frame, item.HFlipped, false);
		for _, att in pairs(drawAfter) do
			PrimitiveMan:DrawBitmapPrimitive(-1, att.Pos, att, att.RotAngle, att.Frame, att.HFlipped, false);
		end
	end
end
for part in MovableMan.Particles do
	if part.ClassName == "MOPixel" then
		part = ToMOPixel(part);
		PrimitiveMan:DrawLinePrimitive(part.PrevPos, part.Pos, part.TrailColor or math.random(255));
	elseif IsMOSRotating(part) then
		part = ToMOSRotating(part);
		local drawAfter = {};
		for att in part.Attachables do
			if att.DrawAfterParent then
				table.insert(drawAfter, att);
			else
				PrimitiveMan:DrawBitmapPrimitive(-1, att.Pos, att, att.RotAngle, att.Frame, att.HFlipped, false);
			end
		end
		PrimitiveMan:DrawBitmapPrimitive(-1, part.Pos, part, part.RotAngle, part.Frame, part.HFlipped, false);
		for _, att in pairs(drawAfter) do
			PrimitiveMan:DrawBitmapPrimitive(-1, att.Pos, att, att.RotAngle, att.Frame, att.HFlipped, false);
		end
	end
end